
#include "common.h"
const uint8_t x264_ue_size_tab [256] = {1, 1, 3, 3, 5, 5, 5, 5, 7, 7, 7, 7, 7, 7, 7, 7, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,};

uint8_t *x264_nal_escape_c (uint8_t *dst, uint8_t *src, uint8_t *end) {
    if (src < end)
        *dst++ = *src++;
    if (src < end)
        *dst++ = *src++;
    while (src < end) {
        if (src[0] <= 0x03 && !dst[-2] && !dst[-1])
            *dst++ = 0x03;
        *dst++ = *src++;
    }
    return dst;
}

uint8_t *x264_nal_escape_mmx2 (uint8_t *dst, uint8_t *src, uint8_t *end);
uint8_t *x264_nal_escape_sse2 (uint8_t *dst, uint8_t *src, uint8_t *end);
uint8_t *x264_nal_escape_avx2 (uint8_t *dst, uint8_t *src, uint8_t *end);
void x264_cabac_block_residual_rd_internal_sse2 (dctcoef * l, int b_interlaced, intptr_t ctx_block_cat, x264_cabac_t * cb);
void x264_cabac_block_residual_rd_internal_sse2_lzcnt (dctcoef * l, int b_interlaced, intptr_t ctx_block_cat, x264_cabac_t * cb);
void x264_cabac_block_residual_rd_internal_ssse3 (dctcoef * l, int b_interlaced, intptr_t ctx_block_cat, x264_cabac_t * cb);
void x264_cabac_block_residual_rd_internal_ssse3_lzcnt (dctcoef * l, int b_interlaced, intptr_t ctx_block_cat, x264_cabac_t * cb);
void x264_cabac_block_residual_8x8_rd_internal_sse2 (dctcoef * l, int b_interlaced, intptr_t ctx_block_cat, x264_cabac_t * cb);
void x264_cabac_block_residual_8x8_rd_internal_sse2_lzcnt (dctcoef * l, int b_interlaced, intptr_t ctx_block_cat, x264_cabac_t * cb);
void x264_cabac_block_residual_8x8_rd_internal_ssse3 (dctcoef * l, int b_interlaced, intptr_t ctx_block_cat, x264_cabac_t * cb);
void x264_cabac_block_residual_8x8_rd_internal_ssse3_lzcnt (dctcoef * l, int b_interlaced, intptr_t ctx_block_cat, x264_cabac_t * cb);
void x264_cabac_block_residual_internal_sse2 (dctcoef * l, int b_interlaced, intptr_t ctx_block_cat, x264_cabac_t * cb);
void x264_cabac_block_residual_internal_sse2_lzcnt (dctcoef * l, int b_interlaced, intptr_t ctx_block_cat, x264_cabac_t * cb);
void x264_cabac_block_residual_internal_avx2_bmi2 (dctcoef * l, int b_interlaced, intptr_t ctx_block_cat, x264_cabac_t * cb);

void x264_nal_encode (x264_t *h, uint8_t *dst, x264_nal_t *nal) {
    uint8_t *src = nal->p_payload;
    uint8_t *end = nal->p_payload + nal->i_payload;
    uint8_t *orig_dst = dst;
    if (h->param.b_annexb) {
        if (nal->b_long_startcode)
            *dst++ = 0x00;
        *dst++ = 0x00;
        *dst++ = 0x00;
        *dst++ = 0x01;
    }
    else
        dst += 4;
    *dst++ = (0x00 << 7) | (nal->i_ref_idc << 5) | nal->i_type;
    dst = h->bsf.nal_escape (dst, src, end);
    int size = (dst - orig_dst) - 4;
    if (!h->param.b_annexb) {
        orig_dst[0] = size >> 24;
        orig_dst[1] = size >> 16;
        orig_dst[2] = size >> 8;
        orig_dst[3] = size >> 0;
    }
    nal->i_payload = size + 4;
    nal->p_payload = orig_dst;
    x264_emms ();
}

void x264_bitstream_init (int cpu, x264_bitstream_function_t *pf) {
    memset (pf, 0, sizeof (* pf));
    pf->nal_escape = x264_nal_escape_c;
}

void bs_init (bs_t *s, void *p_data, int i_data) {
    int offset = ((intptr_t) p_data & 3);
    s->p = s->p_start = (uint8_t *) p_data - offset;
    s->p_end = (uint8_t *) p_data + i_data;
    s->i_left = (WORD_SIZE - offset) * 8;
    s->cur_bits = endian_fix32 (M32 (s->p));
    s->cur_bits >>= (4 - offset) * 8;
}

int bs_pos (bs_t *s) {
    return (8 * (s->p - s->p_start) + (WORD_SIZE * 8) - s->i_left);
}

void bs_flush (bs_t *s) {
    M32 (s->p) = endian_fix32 (s->cur_bits << (s->i_left & 31));
    s->p += WORD_SIZE - (s->i_left >> 3);
    s->i_left = WORD_SIZE * 8;
}

void bs_realign (bs_t *s) {
    int offset = ((intptr_t) s->p & 3);
    if (offset) {
        s->p = (uint8_t *) s->p - offset;
        s->i_left = (WORD_SIZE - offset) * 8;
        s->cur_bits = endian_fix32 (M32 (s->p));
        s->cur_bits >>= (4 - offset) * 8;
    }
}

void bs_write (bs_t *s, int i_count, uint32_t i_bits) {
    if (WORD_SIZE == 8) {
        s->cur_bits = (s->cur_bits << i_count) | i_bits;
        s->i_left -= i_count;
        if (s->i_left <= 32) {
            M32 (s->p) = endian_fix (s->cur_bits << s->i_left);
            s->i_left += 32;
            s->p += 4;
        }
    }
    else {
        if (i_count < s->i_left) {
            s->cur_bits = (s->cur_bits << i_count) | i_bits;
            s->i_left -= i_count;
        }
        else {
            i_count -= s->i_left;
            s->cur_bits = (s->cur_bits << s->i_left) | (i_bits >> i_count);
            M32 (s->p) = endian_fix (s->cur_bits);
            s->p += 4;
            s->cur_bits = i_bits;
            s->i_left = 32 - i_count;
        }
    }
}

void bs_write32 (bs_t *s, uint32_t i_bits) {
    bs_write (s, 16, i_bits >> 16);
    bs_write (s, 16, i_bits);
}

void bs_write1 (bs_t *s, uint32_t i_bit) {
    s->cur_bits <<= 1;
    s->cur_bits |= i_bit;
    s->i_left--;
    if (s->i_left == WORD_SIZE * 8 - 32) {
        M32 (s->p) = endian_fix32 (s->cur_bits);
        s->p += 4;
        s->i_left = WORD_SIZE * 8;
    }
}

void bs_align_0 (bs_t *s) {
    bs_write (s, s -> i_left & 7, 0);
    bs_flush (s);
}

void bs_align_1 (bs_t *s) {
    bs_write (s, s -> i_left & 7, (1 << (s -> i_left & 7)) - 1);
    bs_flush (s);
}

void bs_align_10 (bs_t *s) {
    if (s->i_left & 7)
        bs_write (s, s->i_left & 7, 1 << ((s->i_left & 7) - 1));
}

void bs_write_ue_big (bs_t *s, unsigned  int val) {
    int size = 0;
    int tmp = ++val;
    if (tmp >= 0x10000) {
        size = 32;
        tmp >>= 16;
    }
    if (tmp >= 0x100) {
        size += 16;
        tmp >>= 8;
    }
    size += x264_ue_size_tab[tmp];
    bs_write (s, size >> 1, 0);
    bs_write (s, (size >> 1) + 1, val);
}

void bs_write_ue (bs_t *s, int val) {
    bs_write (s, x264_ue_size_tab [val + 1], val + 1);
}

void bs_write_se (bs_t *s, int val) {
    int size = 0;
    int tmp = 1 - val * 2;
    if (tmp < 0)
        tmp = val * 2;
    val = tmp;
    if (tmp >= 0x100) {
        size = 16;
        tmp >>= 8;
    }
    size += x264_ue_size_tab[tmp];
    bs_write (s, size, val);
}

void bs_write_te (bs_t *s, int x, int val) {
    if (x == 1)
        bs_write1 (s, 1 ^ val);
    else
        bs_write_ue (s, val);
}

void bs_rbsp_trailing (bs_t *s) {
    bs_write1 (s, 1);
    bs_write (s, s -> i_left & 7, 0);
}

int bs_size_ue (unsigned  int val) {
    return x264_ue_size_tab[val + 1];
}

int bs_size_ue_big (unsigned  int val) {
    if (val < 255)
        return x264_ue_size_tab[val + 1];
    else
        return x264_ue_size_tab[(val + 1) >> 8] + 16;
}

int bs_size_se (int val) {
    int tmp = 1 - val * 2;
    if (tmp < 0)
        tmp = val * 2;
    if (tmp < 256)
        return x264_ue_size_tab[tmp];
    else
        return x264_ue_size_tab[tmp >> 8] + 16;
}

int bs_size_te (int x, int val) {
    if (x == 1)
        return 1;
    else
        return x264_ue_size_tab[val + 1];
}

