
#include "common.h"
const uint8_t i_alpha_table [52 + 12 * 3] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 4, 5, 6, 7, 8, 9, 10, 12, 13, 15, 17, 20, 22, 25, 28, 32, 36, 40, 45, 50, 56, 63, 71, 80, 90, 101, 113, 127, 144, 162, 182, 203, 226, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,};
const uint8_t i_beta_table [52 + 12 * 3] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 6, 6, 7, 7, 8, 8, 9, 9, 10, 10, 11, 11, 12, 12, 13, 13, 14, 14, 15, 15, 16, 16, 17, 17, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18,};
const int8_t i_tc0_table [52 + 12 * 3] [4] = {{-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 0}, {-1, 0, 0, 1}, {-1, 0, 0, 1}, {-1, 0, 0, 1}, {-1, 0, 0, 1}, {-1, 0, 1, 1}, {-1, 0, 1, 1}, {-1, 1, 1, 1}, {-1, 1, 1, 1}, {-1, 1, 1, 1}, {-1, 1, 1, 1}, {-1, 1, 1, 2}, {-1, 1, 1, 2}, {-1, 1, 1, 2}, {-1, 1, 1, 2}, {-1, 1, 2, 3}, {-1, 1, 2, 3}, {-1, 2, 2, 3}, {-1, 2, 2, 4}, {-1, 2, 3, 4}, {-1, 2, 3, 4}, {-1, 3, 3, 5}, {-1, 3, 4, 6}, {-1, 3, 4, 6}, {-1, 4, 5, 7}, {-1, 4, 5, 8}, {-1, 4, 6, 9}, {-1, 5, 7, 10}, {-1, 6, 8, 11}, {-1, 6, 8, 13}, {-1, 7, 10, 14}, {-1, 8, 11, 16}, {-1, 9, 12, 18}, {-1, 10, 13, 20}, {-1, 11, 15, 23}, {-1, 13, 17, 25}, {-1, 13, 17, 25}, {-1, 13, 17, 25}, {-1, 13, 17, 25}, {-1, 13, 17, 25}, {-1, 13, 17, 25}, {-1, 13, 17, 25}, {-1, 13, 17, 25}, {-1, 13, 17, 25}, {-1, 13, 17, 25}, {-1, 13, 17, 25}, {-1, 13, 17, 25}, {-1, 13, 17, 25},};

void deblock_edge_luma_c (pixel *pix, intptr_t xstride, int alpha, int beta, int8_t tc0) {
    int p2 = pix[-3 * xstride];
    int p1 = pix[-2 * xstride];
    int p0 = pix[-1 * xstride];
    int q0 = pix[0 * xstride];
    int q1 = pix[1 * xstride];
    int q2 = pix[2 * xstride];
    if (abs (p0 -q0) < alpha && abs (p1 -p0) < beta && abs (q1 -q0) < beta) {
        int tc = tc0;
        int delta;
        if (abs (p2 -p0) < beta) {
            if (tc0)
                pix[-2 * xstride] = p1 + x264_clip3 (((p2 + ((p0 + q0 + 1) >> 1)) >> 1) - p1, -tc0, tc0);
            tc++;
        }
        if (abs (q2 -q0) < beta) {
            if (tc0)
                pix[1 * xstride] = q1 + x264_clip3 (((q2 + ((p0 + q0 + 1) >> 1)) >> 1) - q1, -tc0, tc0);
            tc++;
        }
        delta = x264_clip3 ((((q0 - p0) << 2) + (p1 - q1) + 4) >> 3, -tc, tc);
        pix[-1 * xstride] = x264_clip_pixel (p0 +delta);
        pix[0 * xstride] = x264_clip_pixel (q0 -delta);
    }
}

void deblock_luma_c (pixel *pix, intptr_t xstride, intptr_t ystride, int alpha, int beta, int8_t *tc0) {
    for (int i = 0; i < 4; i++) {
        if (tc0[i] < 0) {
            pix += 4 * ystride;
            continue;
        }
        for (int d = 0; d < 4; d++, pix += ystride)
            deblock_edge_luma_c (pix, xstride, alpha, beta, tc0[i]);
    }
}

void deblock_h_luma_mbaff_c (pixel *pix, intptr_t stride, int alpha, int beta, int8_t *tc0) {
    for (int d = 0; d < 8; d++, pix += stride)
        deblock_edge_luma_c (pix, 1, alpha, beta, tc0[d >> 1]);
}

void deblock_v_luma_c (pixel *pix, intptr_t stride, int alpha, int beta, int8_t *tc0) {
    deblock_luma_c (pix, stride, 1, alpha, beta, tc0);
}

void deblock_h_luma_c (pixel *pix, intptr_t stride, int alpha, int beta, int8_t *tc0) {
    deblock_luma_c (pix, 1, stride, alpha, beta, tc0);
}

void deblock_edge_chroma_c (pixel *pix, intptr_t xstride, int alpha, int beta, int8_t tc) {
    int p1 = pix[-2 * xstride];
    int p0 = pix[-1 * xstride];
    int q0 = pix[0 * xstride];
    int q1 = pix[1 * xstride];
    if (abs (p0 -q0) < alpha && abs (p1 -p0) < beta && abs (q1 -q0) < beta) {
        int delta = x264_clip3 ((((q0 - p0) << 2) + (p1 - q1) + 4) >> 3, -tc, tc);
        pix[-1 * xstride] = x264_clip_pixel (p0 +delta);
        pix[0 * xstride] = x264_clip_pixel (q0 -delta);
    }
}

void deblock_chroma_c (pixel *pix, int height, intptr_t xstride, intptr_t ystride, int alpha, int beta, int8_t *tc0) {
    for (int i = 0; i < 4; i++) {
        int tc = tc0[i];
        if (tc <= 0) {
            pix += height * ystride;
            continue;
        }
        for (int d = 0; d < height; d++, pix += ystride - 2)
            for (int e = 0; e < 2; e++, pix++)
                deblock_edge_chroma_c (pix, xstride, alpha, beta, tc0[i]);
    }
}

void deblock_h_chroma_mbaff_c (pixel *pix, intptr_t stride, int alpha, int beta, int8_t *tc0) {
    deblock_chroma_c (pix, 1, 2, stride, alpha, beta, tc0);
}

void deblock_v_chroma_c (pixel *pix, intptr_t stride, int alpha, int beta, int8_t *tc0) {
    deblock_chroma_c (pix, 2, stride, 2, alpha, beta, tc0);
}

void deblock_h_chroma_c (pixel *pix, intptr_t stride, int alpha, int beta, int8_t *tc0) {
    deblock_chroma_c (pix, 2, 2, stride, alpha, beta, tc0);
}

void deblock_h_chroma_422_c (pixel *pix, intptr_t stride, int alpha, int beta, int8_t *tc0) {
    deblock_chroma_c (pix, 4, 2, stride, alpha, beta, tc0);
}

void deblock_edge_luma_intra_c (pixel *pix, intptr_t xstride, int alpha, int beta) {
    int p2 = pix[-3 * xstride];
    int p1 = pix[-2 * xstride];
    int p0 = pix[-1 * xstride];
    int q0 = pix[0 * xstride];
    int q1 = pix[1 * xstride];
    int q2 = pix[2 * xstride];
    if (abs (p0 -q0) < alpha && abs (p1 -p0) < beta && abs (q1 -q0) < beta) {
        if (abs (p0 -q0) < ((alpha >> 2) + 2)) {
            if (abs (p2 -p0) < beta) {
                const int p3 = pix[-4 * xstride];
                pix[-1 * xstride] = (p2 + 2 * p1 + 2 * p0 + 2 * q0 + q1 + 4) >> 3;
                pix[-2 * xstride] = (p2 + p1 + p0 + q0 + 2) >> 2;
                pix[-3 * xstride] = (2 * p3 + 3 * p2 + p1 + p0 + q0 + 4) >> 3;
            }
            else
                pix[-1 * xstride] = (2 * p1 + p0 + q1 + 2) >> 2;
            if (abs (q2 -q0) < beta) {
                const int q3 = pix[3 * xstride];
                pix[0 * xstride] = (p1 + 2 * p0 + 2 * q0 + 2 * q1 + q2 + 4) >> 3;
                pix[1 * xstride] = (p0 + q0 + q1 + q2 + 2) >> 2;
                pix[2 * xstride] = (2 * q3 + 3 * q2 + q1 + q0 + p0 + 4) >> 3;
            }
            else
                pix[0 * xstride] = (2 * q1 + q0 + p1 + 2) >> 2;
        }
        else {
            pix[-1 * xstride] = (2 * p1 + p0 + q1 + 2) >> 2;
            pix[0 * xstride] = (2 * q1 + q0 + p1 + 2) >> 2;
        }
    }
}

void deblock_luma_intra_c (pixel *pix, intptr_t xstride, intptr_t ystride, int alpha, int beta) {
    for (int d = 0; d < 16; d++, pix += ystride)
        deblock_edge_luma_intra_c (pix, xstride, alpha, beta);
}

void deblock_h_luma_intra_mbaff_c (pixel *pix, intptr_t ystride, int alpha, int beta) {
    for (int d = 0; d < 8; d++, pix += ystride)
        deblock_edge_luma_intra_c (pix, 1, alpha, beta);
}

void deblock_v_luma_intra_c (pixel *pix, intptr_t stride, int alpha, int beta) {
    deblock_luma_intra_c (pix, stride, 1, alpha, beta);
}

void deblock_h_luma_intra_c (pixel *pix, intptr_t stride, int alpha, int beta) {
    deblock_luma_intra_c (pix, 1, stride, alpha, beta);
}

void deblock_edge_chroma_intra_c (pixel *pix, intptr_t xstride, int alpha, int beta) {
    int p1 = pix[-2 * xstride];
    int p0 = pix[-1 * xstride];
    int q0 = pix[0 * xstride];
    int q1 = pix[1 * xstride];
    if (abs (p0 -q0) < alpha && abs (p1 -p0) < beta && abs (q1 -q0) < beta) {
        pix[-1 * xstride] = (2 * p1 + p0 + q1 + 2) >> 2;
        pix[0 * xstride] = (2 * q1 + q0 + p1 + 2) >> 2;
    }
}

void deblock_chroma_intra_c (pixel *pix, int width, int height, intptr_t xstride, intptr_t ystride, int alpha, int beta) {
    for (int d = 0; d < height; d++, pix += ystride - 2)
        for (int e = 0; e < width; e++, pix++)
            deblock_edge_chroma_intra_c (pix, xstride, alpha, beta);
}

void deblock_h_chroma_intra_mbaff_c (pixel *pix, intptr_t stride, int alpha, int beta) {
    deblock_chroma_intra_c (pix, 2, 4, 2, stride, alpha, beta);
}

void deblock_v_chroma_intra_c (pixel *pix, intptr_t stride, int alpha, int beta) {
    deblock_chroma_intra_c (pix, 1, 16, stride, 2, alpha, beta);
}

void deblock_h_chroma_intra_c (pixel *pix, intptr_t stride, int alpha, int beta) {
    deblock_chroma_intra_c (pix, 2, 8, 2, stride, alpha, beta);
}

void deblock_h_chroma_422_intra_c (pixel *pix, intptr_t stride, int alpha, int beta) {
    deblock_chroma_intra_c (pix, 2, 16, 2, stride, alpha, beta);
}

void deblock_strength_c (uint8_t nnz [((5 * 8) * 3)], int8_t ref [2] [(5 * 8)], int16_t mv [2] [(5 * 8)] [2], uint8_t bs [2] [8] [4], int mvy_limit, int bframe) {
    for (int dir = 0; dir < 2; dir++) {
        int s1 = dir ? 1 : 8;
        int s2 = dir ? 8 : 1;
        for (int edge = 0; edge < 4; edge++)
            for (int i = 0, loc = (4 + 1 * 8) + edge * s2; i < 4; i++, loc += s1) {
                int locn = loc - s2;
                if (nnz[loc] || nnz[locn])
                    bs[dir][edge][i] = 2;
                else if (ref[0][loc] != ref[0][locn] || abs (mv[0][loc][0] - mv[0][locn][0]) >= 4 || abs (mv[0][loc][1] - mv[0][locn][1]) >= mvy_limit || (bframe && (ref[1][loc] != ref[1][locn] || abs (mv[1][loc][0] - mv[1][locn][0]) >= 4 || abs (mv[1][loc][1] - mv[1][locn][1]) >= mvy_limit))) {
                    bs[dir][edge][i] = 1;
                }
                else
                    bs[dir][edge][i] = 0;
            }
    }
}

void deblock_edge (x264_t *h, pixel *pix, intptr_t i_stride, uint8_t bS [4], int i_qp, int a, int b, int b_chroma, x264_deblock_inter_t pf_inter) {
    int index_a = i_qp + a;
    int index_b = i_qp + b;
    int alpha = i_alpha_table[(index_a) +24] << (8 - 8);
    int beta = i_beta_table[(index_b) +24] << (8 - 8);
    int8_t tc [4];
    if (!(((x264_union32_t *) (bS))->i) || !alpha || !beta)
        return;
    tc[0] = (i_tc0_table[(index_a) +24][bS[0]] << (8 - 8)) + b_chroma;
    tc[1] = (i_tc0_table[(index_a) +24][bS[1]] << (8 - 8)) + b_chroma;
    tc[2] = (i_tc0_table[(index_a) +24][bS[2]] << (8 - 8)) + b_chroma;
    tc[3] = (i_tc0_table[(index_a) +24][bS[3]] << (8 - 8)) + b_chroma;
    pf_inter (pix, i_stride, alpha, beta, tc);
}

void deblock_edge_intra (x264_t *h, pixel *pix, intptr_t i_stride, uint8_t bS [4], int i_qp, int a, int b, int b_chroma, x264_deblock_intra_t pf_intra) {
    int index_a = i_qp + a;
    int index_b = i_qp + b;
    int alpha = i_alpha_table[(index_a) +24] << (8 - 8);
    int beta = i_beta_table[(index_b) +24] << (8 - 8);
    if (!alpha || !beta)
        return;
    pf_intra (pix, i_stride, alpha, beta);
}

void x264_macroblock_cache_load_neighbours_deblock (x264_t *h, int mb_x, int mb_y) {
    int deblock_on_slice_edges = h->sh.i_disable_deblocking_filter_idc != 2;
    h->mb.i_neighbour = 0;
    h->mb.i_mb_xy = mb_y * h->mb.i_mb_stride + mb_x;
    h->mb.b_interlaced = 0 && h->mb.field[h->mb.i_mb_xy];
    h->mb.i_mb_top_y = mb_y - (1 << 0);
    h->mb.i_mb_top_xy = mb_x + h->mb.i_mb_stride * h->mb.i_mb_top_y;
    h->mb.i_mb_left_xy[1] = h->mb.i_mb_left_xy[0] = h->mb.i_mb_xy - 1;
    if (0) {
        if (mb_y & 1) {
            if (mb_x && h->mb.field[h->mb.i_mb_xy - 1] != 0)
                h->mb.i_mb_left_xy[0] -= h->mb.i_mb_stride;
        }
        else {
            if (h->mb.i_mb_top_xy >= 0 && 0 && !h->mb.field[h->mb.i_mb_top_xy]) {
                h->mb.i_mb_top_xy += h->mb.i_mb_stride;
                h->mb.i_mb_top_y++;
            }
            if (mb_x && h->mb.field[h->mb.i_mb_xy - 1] != 0)
                h->mb.i_mb_left_xy[1] += h->mb.i_mb_stride;
        }
    }
    if (mb_x > 0 && (deblock_on_slice_edges || h->mb.slice_table[h->mb.i_mb_left_xy[0]] == h->mb.slice_table[h->mb.i_mb_xy]))
        h->mb.i_neighbour |= MB_LEFT;
    if (mb_y > 0 && (deblock_on_slice_edges || h->mb.slice_table[h->mb.i_mb_top_xy] == h->mb.slice_table[h->mb.i_mb_xy]))
        h->mb.i_neighbour |= MB_TOP;
}

void x264_frame_deblock_row (x264_t *h, int mb_y) {
    int b_interlaced = 0;
    int a = h->sh.i_alpha_c0_offset - (6 * (8 - 8));
    int b = h->sh.i_beta_offset - (6 * (8 - 8));
    int qp_thresh = 15 - ((a) < (b) ? (a) : (b)) - ((0) > (h->pps->i_chroma_qp_index_offset) ? (0) : (h->pps->i_chroma_qp_index_offset));
    int stridey = h->fdec->i_stride[0];
    int strideuv = h->fdec->i_stride[1];
    int chroma444 = (h->sps->i_chroma_format_idc == CHROMA_444);
    int chroma_height = 16 >> h->mb.chroma_v_shift;
    intptr_t uvdiff = chroma444 ? h->fdec->plane[2] - h->fdec->plane[1] : 1;
    for (int mb_x = 0; mb_x < h->mb.i_mb_width; mb_x += (~b_interlaced | mb_y) & 1, mb_y ^= b_interlaced) {
        x264_prefetch_fenc (h, h -> fdec, mb_x, mb_y);
        x264_macroblock_cache_load_neighbours_deblock (h, mb_x, mb_y);
        int mb_xy = h->mb.i_mb_xy;
        int transform_8x8 = h->mb.mb_transform_size[mb_xy];
        int intra_cur = ((h->mb.type[mb_xy]) == I_4x4 || (h->mb.type[mb_xy]) == I_8x8 || (h->mb.type[mb_xy]) == I_16x16 || (h->mb.type[mb_xy]) == I_PCM);
        uint8_t (*bs) [8] [4] = h->deblock_strength[mb_y & 1][h->param.b_sliced_threads ? mb_xy : mb_x];
        pixel *pixy = h->fdec->plane[0] + 16 * mb_y * stridey + 16 * mb_x;
        pixel *pixuv = h->fdec->plane[1] + chroma_height * mb_y * strideuv + 16 * mb_x;
        if (mb_y & 0) {
            pixy -= 15 * stridey;
            pixuv -= (chroma_height - 1) * strideuv;
        }
        int stride2y = stridey << 0;
        int stride2uv = strideuv << 0;
        int qp = h->mb.qp[mb_xy];
        int qpc = h->chroma_qp_table[qp];
        int first_edge_only = (h->mb.partition[mb_xy] == D_16x16 && !h->mb.cbp[mb_xy] && !intra_cur) || qp <= qp_thresh;
        if (h->mb.i_neighbour & MB_LEFT) {
            if (b_interlaced && h->mb.field[h->mb.i_mb_left_xy[0]] != 0) {
                int luma_qp [2];
                int chroma_qp [2];
                int left_qp [2];
                x264_deblock_inter_t luma_deblock = h->loopf.deblock_luma_mbaff;
                x264_deblock_inter_t chroma_deblock = h->loopf.deblock_chroma_mbaff;
                x264_deblock_intra_t luma_intra_deblock = h->loopf.deblock_luma_intra_mbaff;
                x264_deblock_intra_t chroma_intra_deblock = h->loopf.deblock_chroma_intra_mbaff;
                int c = chroma444 ? 0 : 1;
                left_qp[0] = h->mb.qp[h->mb.i_mb_left_xy[0]];
                luma_qp[0] = (qp + left_qp[0] + 1) >> 1;
                chroma_qp[0] = (qpc + h->chroma_qp_table[left_qp[0]] + 1) >> 1;
                if (intra_cur || ((h->mb.type[h->mb.i_mb_left_xy[0]]) == I_4x4 || (h->mb.type[h->mb.i_mb_left_xy[0]]) == I_8x8 || (h->mb.type[h->mb.i_mb_left_xy[0]]) == I_16x16 || (h->mb.type[h->mb.i_mb_left_xy[0]]) == I_PCM)) {
                    deblock_edge_intra (h, pixy, 2 * stridey, bs [0] [0], luma_qp [0], a, b, 0, luma_intra_deblock);
                    deblock_edge_intra (h, pixuv, 2 * strideuv, bs [0] [0], chroma_qp [0], a, b, c, chroma_intra_deblock);
                    if (chroma444)
                        deblock_edge_intra (h, pixuv +uvdiff, 2 * strideuv, bs[0][0], chroma_qp[0], a, b, c, chroma_intra_deblock);
                }
                else {
                    deblock_edge (h, pixy, 2 * stridey, bs [0] [0], luma_qp [0], a, b, 0, luma_deblock);
                    deblock_edge (h, pixuv, 2 * strideuv, bs [0] [0], chroma_qp [0], a, b, c, chroma_deblock);
                    if (chroma444)
                        deblock_edge (h, pixuv +uvdiff, 2 * strideuv, bs[0][0], chroma_qp[0], a, b, c, chroma_deblock);
                }
                int offy = 0 ? 4 : 0;
                int offuv = 0 ? 4 - h->mb.chroma_v_shift : 0;
                left_qp[1] = h->mb.qp[h->mb.i_mb_left_xy[1]];
                luma_qp[1] = (qp + left_qp[1] + 1) >> 1;
                chroma_qp[1] = (qpc + h->chroma_qp_table[left_qp[1]] + 1) >> 1;
                if (intra_cur || ((h->mb.type[h->mb.i_mb_left_xy[1]]) == I_4x4 || (h->mb.type[h->mb.i_mb_left_xy[1]]) == I_8x8 || (h->mb.type[h->mb.i_mb_left_xy[1]]) == I_16x16 || (h->mb.type[h->mb.i_mb_left_xy[1]]) == I_PCM)) {
                    deblock_edge_intra (h, pixy + (stridey << offy), 2 * stridey, bs [0] [4], luma_qp [1], a, b, 0, luma_intra_deblock);
                    deblock_edge_intra (h, pixuv + (strideuv << offuv), 2 * strideuv, bs [0] [4], chroma_qp [1], a, b, c, chroma_intra_deblock);
                    if (chroma444)
                        deblock_edge_intra (h, pixuv +uvdiff + (strideuv << offuv), 2 * strideuv, bs[0][4], chroma_qp[1], a, b, c, chroma_intra_deblock);
                }
                else {
                    deblock_edge (h, pixy + (stridey << offy), 2 * stridey, bs [0] [4], luma_qp [1], a, b, 0, luma_deblock);
                    deblock_edge (h, pixuv + (strideuv << offuv), 2 * strideuv, bs [0] [4], chroma_qp [1], a, b, c, chroma_deblock);
                    if (chroma444)
                        deblock_edge (h, pixuv +uvdiff + (strideuv << offuv), 2 * strideuv, bs[0][4], chroma_qp[1], a, b, c, chroma_deblock);
                }
            }
            else {
                int qpl = h->mb.qp[h->mb.i_mb_xy - 1];
                int qp_left = (qp + qpl + 1) >> 1;
                int qpc_left = (qpc + h->chroma_qp_table[qpl] + 1) >> 1;
                int intra_left = ((h->mb.type[h->mb.i_mb_xy - 1]) == I_4x4 || (h->mb.type[h->mb.i_mb_xy - 1]) == I_8x8 || (h->mb.type[h->mb.i_mb_xy - 1]) == I_16x16 || (h->mb.type[h->mb.i_mb_xy - 1]) == I_PCM);
                int intra_deblock = intra_cur || intra_left;
                if (h->fdec->mb_info && (((x264_union32_t *) (bs[0][0]))->i)) {
                    h->fdec->effective_qp[mb_xy] |= 0xff * !!(h->fdec->mb_info[mb_xy] & (1 << 0));
                    ;
                    h->fdec->effective_qp[h->mb.i_mb_left_xy[0]] |= 0xff * !!(h->fdec->mb_info[h->mb.i_mb_left_xy[0]] & (1 << 0));
                    ;
                }
                if (intra_deblock)
                    do {
                        if (!(0 & 1) || !transform_8x8) {
                            deblock_edge_intra (h, pixy + 4 * 0 * (0 ? stride2y : 1), stride2y, bs [0] [0], qp_left, a, b, 0, h -> loopf.deblock_luma_intra [0]);
                            if (h->sps->i_chroma_format_idc == CHROMA_444) {
                                deblock_edge_intra (h, pixuv + 4 * 0 * (0 ? stride2uv : 1), stride2uv, bs [0] [0], qpc_left, a, b, 0, h -> loopf.deblock_luma_intra [0]);
                                deblock_edge_intra (h, pixuv + uvdiff + 4 * 0 * (0 ? stride2uv : 1), stride2uv, bs [0] [0], qpc_left, a, b, 0, h -> loopf.deblock_luma_intra [0]);
                            }
                            else if (h->sps->i_chroma_format_idc == CHROMA_420 && !(0 & 1)) {
                                deblock_edge_intra (h, pixuv + 0 * (0 ? 2 * stride2uv : 4), stride2uv, bs [0] [0], qpc_left, a, b, 1, h -> loopf.deblock_chroma_intra [0]);
                            }
                        }
                        if (h->sps->i_chroma_format_idc == CHROMA_422 && (0 || !(0 & 1))) {
                            deblock_edge_intra (h, pixuv + 0 * (0 ? 4 * stride2uv : 4), stride2uv, bs [0] [0], qpc_left, a, b, 1, h -> loopf.deblock_chroma_intra [0]);
                        }
                    }
                    while (0);
                else
                    do {
                        if (!(0 & 1) || !transform_8x8) {
                            deblock_edge (h, pixy + 4 * 0 * (0 ? stride2y : 1), stride2y, bs [0] [0], qp_left, a, b, 0, h -> loopf.deblock_luma [0]);
                            if (h->sps->i_chroma_format_idc == CHROMA_444) {
                                deblock_edge (h, pixuv + 4 * 0 * (0 ? stride2uv : 1), stride2uv, bs [0] [0], qpc_left, a, b, 0, h -> loopf.deblock_luma [0]);
                                deblock_edge (h, pixuv + uvdiff + 4 * 0 * (0 ? stride2uv : 1), stride2uv, bs [0] [0], qpc_left, a, b, 0, h -> loopf.deblock_luma [0]);
                            }
                            else if (h->sps->i_chroma_format_idc == CHROMA_420 && !(0 & 1)) {
                                deblock_edge (h, pixuv + 0 * (0 ? 2 * stride2uv : 4), stride2uv, bs [0] [0], qpc_left, a, b, 1, h -> loopf.deblock_chroma [0]);
                            }
                        }
                        if (h->sps->i_chroma_format_idc == CHROMA_422 && (0 || !(0 & 1))) {
                            deblock_edge (h, pixuv + 0 * (0 ? 4 * stride2uv : 4), stride2uv, bs [0] [0], qpc_left, a, b, 1, h -> loopf.deblock_chroma [0]);
                        }
                    }
                    while (0);
            }
        }
        if (!first_edge_only) {
            do {
                if (!(1 & 1) || !transform_8x8) {
                    deblock_edge (h, pixy + 4 * 1 * (0 ? stride2y : 1), stride2y, bs [0] [1], qp, a, b, 0, h -> loopf.deblock_luma [0]);
                    if (h->sps->i_chroma_format_idc == CHROMA_444) {
                        deblock_edge (h, pixuv + 4 * 1 * (0 ? stride2uv : 1), stride2uv, bs [0] [1], qpc, a, b, 0, h -> loopf.deblock_luma [0]);
                        deblock_edge (h, pixuv + uvdiff + 4 * 1 * (0 ? stride2uv : 1), stride2uv, bs [0] [1], qpc, a, b, 0, h -> loopf.deblock_luma [0]);
                    }
                    else if (h->sps->i_chroma_format_idc == CHROMA_420 && !(1 & 1)) {
                        deblock_edge (h, pixuv + 1 * (0 ? 2 * stride2uv : 4), stride2uv, bs [0] [1], qpc, a, b, 1, h -> loopf.deblock_chroma [0]);
                    }
                }
                if (h->sps->i_chroma_format_idc == CHROMA_422 && (0 || !(1 & 1))) {
                    deblock_edge (h, pixuv + 1 * (0 ? 4 * stride2uv : 4), stride2uv, bs [0] [1], qpc, a, b, 1, h -> loopf.deblock_chroma [0]);
                }
            }
            while (0);
            do {
                if (!(2 & 1) || !transform_8x8) {
                    deblock_edge (h, pixy + 4 * 2 * (0 ? stride2y : 1), stride2y, bs [0] [2], qp, a, b, 0, h -> loopf.deblock_luma [0]);
                    if (h->sps->i_chroma_format_idc == CHROMA_444) {
                        deblock_edge (h, pixuv + 4 * 2 * (0 ? stride2uv : 1), stride2uv, bs [0] [2], qpc, a, b, 0, h -> loopf.deblock_luma [0]);
                        deblock_edge (h, pixuv + uvdiff + 4 * 2 * (0 ? stride2uv : 1), stride2uv, bs [0] [2], qpc, a, b, 0, h -> loopf.deblock_luma [0]);
                    }
                    else if (h->sps->i_chroma_format_idc == CHROMA_420 && !(2 & 1)) {
                        deblock_edge (h, pixuv + 2 * (0 ? 2 * stride2uv : 4), stride2uv, bs [0] [2], qpc, a, b, 1, h -> loopf.deblock_chroma [0]);
                    }
                }
                if (h->sps->i_chroma_format_idc == CHROMA_422 && (0 || !(2 & 1))) {
                    deblock_edge (h, pixuv + 2 * (0 ? 4 * stride2uv : 4), stride2uv, bs [0] [2], qpc, a, b, 1, h -> loopf.deblock_chroma [0]);
                }
            }
            while (0);
            do {
                if (!(3 & 1) || !transform_8x8) {
                    deblock_edge (h, pixy + 4 * 3 * (0 ? stride2y : 1), stride2y, bs [0] [3], qp, a, b, 0, h -> loopf.deblock_luma [0]);
                    if (h->sps->i_chroma_format_idc == CHROMA_444) {
                        deblock_edge (h, pixuv + 4 * 3 * (0 ? stride2uv : 1), stride2uv, bs [0] [3], qpc, a, b, 0, h -> loopf.deblock_luma [0]);
                        deblock_edge (h, pixuv + uvdiff + 4 * 3 * (0 ? stride2uv : 1), stride2uv, bs [0] [3], qpc, a, b, 0, h -> loopf.deblock_luma [0]);
                    }
                    else if (h->sps->i_chroma_format_idc == CHROMA_420 && !(3 & 1)) {
                        deblock_edge (h, pixuv + 3 * (0 ? 2 * stride2uv : 4), stride2uv, bs [0] [3], qpc, a, b, 1, h -> loopf.deblock_chroma [0]);
                    }
                }
                if (h->sps->i_chroma_format_idc == CHROMA_422 && (0 || !(3 & 1))) {
                    deblock_edge (h, pixuv + 3 * (0 ? 4 * stride2uv : 4), stride2uv, bs [0] [3], qpc, a, b, 1, h -> loopf.deblock_chroma [0]);
                }
            }
            while (0);
        }
        if (h->mb.i_neighbour & MB_TOP) {
            if (b_interlaced && !(mb_y & 1) && !0 && h->mb.field[h->mb.i_mb_top_xy]) {
                int mbn_xy = mb_xy - 2 * h->mb.i_mb_stride;
                for (int j = 0; j < 2; j++, mbn_xy += h->mb.i_mb_stride) {
                    int qpt = h->mb.qp[mbn_xy];
                    int qp_top = (qp + qpt + 1) >> 1;
                    int qpc_top = (qpc + h->chroma_qp_table[qpt] + 1) >> 1;
                    int intra_top = ((h->mb.type[mbn_xy]) == I_4x4 || (h->mb.type[mbn_xy]) == I_8x8 || (h->mb.type[mbn_xy]) == I_16x16 || (h->mb.type[mbn_xy]) == I_PCM);
                    if (intra_cur || intra_top)
                        (((x264_union32_t *) (bs[1][4 * j]))->i) = 0x03030303;
                    deblock_edge (h, pixy + j * stridey, 2 * stridey, bs [1] [4 * j], qp_top, a, b, 0, h -> loopf.deblock_luma [1]);
                    if (chroma444) {
                        deblock_edge (h, pixuv + j * strideuv, 2 * strideuv, bs [1] [4 * j], qpc_top, a, b, 0, h -> loopf.deblock_luma [1]);
                        deblock_edge (h, pixuv + uvdiff + j * strideuv, 2 * strideuv, bs [1] [4 * j], qpc_top, a, b, 0, h -> loopf.deblock_luma [1]);
                    }
                    else
                        deblock_edge (h, pixuv +j * strideuv, 2 * strideuv, bs[1][4 * j], qpc_top, a, b, 1, h->loopf.deblock_chroma[1]);
                }
            }
            else {
                int qpt = h->mb.qp[h->mb.i_mb_top_xy];
                int qp_top = (qp + qpt + 1) >> 1;
                int qpc_top = (qpc + h->chroma_qp_table[qpt] + 1) >> 1;
                int intra_top = ((h->mb.type[h->mb.i_mb_top_xy]) == I_4x4 || (h->mb.type[h->mb.i_mb_top_xy]) == I_8x8 || (h->mb.type[h->mb.i_mb_top_xy]) == I_16x16 || (h->mb.type[h->mb.i_mb_top_xy]) == I_PCM);
                int intra_deblock = intra_cur || intra_top;
                if (h->fdec->mb_info && (((x264_union32_t *) (bs[1][0]))->i)) {
                    h->fdec->effective_qp[mb_xy] |= 0xff * !!(h->fdec->mb_info[mb_xy] & (1 << 0));
                    ;
                    h->fdec->effective_qp[h->mb.i_mb_top_xy] |= 0xff * !!(h->fdec->mb_info[h->mb.i_mb_top_xy] & (1 << 0));
                    ;
                }
                if ((!b_interlaced || (!0 && !h->mb.field[h->mb.i_mb_top_xy])) && intra_deblock) {
                    do {
                        if (!(0 & 1) || !transform_8x8) {
                            deblock_edge_intra (h, pixy + 4 * 0 * (1 ? stride2y : 1), stride2y, bs [1] [0], qp_top, a, b, 0, h -> loopf.deblock_luma_intra [1]);
                            if (h->sps->i_chroma_format_idc == CHROMA_444) {
                                deblock_edge_intra (h, pixuv + 4 * 0 * (1 ? stride2uv : 1), stride2uv, bs [1] [0], qpc_top, a, b, 0, h -> loopf.deblock_luma_intra [1]);
                                deblock_edge_intra (h, pixuv + uvdiff + 4 * 0 * (1 ? stride2uv : 1), stride2uv, bs [1] [0], qpc_top, a, b, 0, h -> loopf.deblock_luma_intra [1]);
                            }
                            else if (h->sps->i_chroma_format_idc == CHROMA_420 && !(0 & 1)) {
                                deblock_edge_intra (h, pixuv + 0 * (1 ? 2 * stride2uv : 4), stride2uv, bs [1] [0], qpc_top, a, b, 1, h -> loopf.deblock_chroma_intra [1]);
                            }
                        }
                        if (h->sps->i_chroma_format_idc == CHROMA_422 && (1 || !(0 & 1))) {
                            deblock_edge_intra (h, pixuv + 0 * (1 ? 4 * stride2uv : 4), stride2uv, bs [1] [0], qpc_top, a, b, 1, h -> loopf.deblock_chroma_intra [1]);
                        }
                    }
                    while (0);
                }
                else {
                    if (intra_deblock)
                        (((x264_union32_t *) (bs[1][0]))->i) = 0x03030303;
                    do {
                        if (!(0 & 1) || !transform_8x8) {
                            deblock_edge (h, pixy + 4 * 0 * (1 ? stride2y : 1), stride2y, bs [1] [0], qp_top, a, b, 0, h -> loopf.deblock_luma [1]);
                            if (h->sps->i_chroma_format_idc == CHROMA_444) {
                                deblock_edge (h, pixuv + 4 * 0 * (1 ? stride2uv : 1), stride2uv, bs [1] [0], qpc_top, a, b, 0, h -> loopf.deblock_luma [1]);
                                deblock_edge (h, pixuv + uvdiff + 4 * 0 * (1 ? stride2uv : 1), stride2uv, bs [1] [0], qpc_top, a, b, 0, h -> loopf.deblock_luma [1]);
                            }
                            else if (h->sps->i_chroma_format_idc == CHROMA_420 && !(0 & 1)) {
                                deblock_edge (h, pixuv + 0 * (1 ? 2 * stride2uv : 4), stride2uv, bs [1] [0], qpc_top, a, b, 1, h -> loopf.deblock_chroma [1]);
                            }
                        }
                        if (h->sps->i_chroma_format_idc == CHROMA_422 && (1 || !(0 & 1))) {
                            deblock_edge (h, pixuv + 0 * (1 ? 4 * stride2uv : 4), stride2uv, bs [1] [0], qpc_top, a, b, 1, h -> loopf.deblock_chroma [1]);
                        }
                    }
                    while (0);
                }
            }
        }
        if (!first_edge_only) {
            do {
                if (!(1 & 1) || !transform_8x8) {
                    deblock_edge (h, pixy + 4 * 1 * (1 ? stride2y : 1), stride2y, bs [1] [1], qp, a, b, 0, h -> loopf.deblock_luma [1]);
                    if (h->sps->i_chroma_format_idc == CHROMA_444) {
                        deblock_edge (h, pixuv + 4 * 1 * (1 ? stride2uv : 1), stride2uv, bs [1] [1], qpc, a, b, 0, h -> loopf.deblock_luma [1]);
                        deblock_edge (h, pixuv + uvdiff + 4 * 1 * (1 ? stride2uv : 1), stride2uv, bs [1] [1], qpc, a, b, 0, h -> loopf.deblock_luma [1]);
                    }
                    else if (h->sps->i_chroma_format_idc == CHROMA_420 && !(1 & 1)) {
                        deblock_edge (h, pixuv + 1 * (1 ? 2 * stride2uv : 4), stride2uv, bs [1] [1], qpc, a, b, 1, h -> loopf.deblock_chroma [1]);
                    }
                }
                if (h->sps->i_chroma_format_idc == CHROMA_422 && (1 || !(1 & 1))) {
                    deblock_edge (h, pixuv + 1 * (1 ? 4 * stride2uv : 4), stride2uv, bs [1] [1], qpc, a, b, 1, h -> loopf.deblock_chroma [1]);
                }
            }
            while (0);
            do {
                if (!(2 & 1) || !transform_8x8) {
                    deblock_edge (h, pixy + 4 * 2 * (1 ? stride2y : 1), stride2y, bs [1] [2], qp, a, b, 0, h -> loopf.deblock_luma [1]);
                    if (h->sps->i_chroma_format_idc == CHROMA_444) {
                        deblock_edge (h, pixuv + 4 * 2 * (1 ? stride2uv : 1), stride2uv, bs [1] [2], qpc, a, b, 0, h -> loopf.deblock_luma [1]);
                        deblock_edge (h, pixuv + uvdiff + 4 * 2 * (1 ? stride2uv : 1), stride2uv, bs [1] [2], qpc, a, b, 0, h -> loopf.deblock_luma [1]);
                    }
                    else if (h->sps->i_chroma_format_idc == CHROMA_420 && !(2 & 1)) {
                        deblock_edge (h, pixuv + 2 * (1 ? 2 * stride2uv : 4), stride2uv, bs [1] [2], qpc, a, b, 1, h -> loopf.deblock_chroma [1]);
                    }
                }
                if (h->sps->i_chroma_format_idc == CHROMA_422 && (1 || !(2 & 1))) {
                    deblock_edge (h, pixuv + 2 * (1 ? 4 * stride2uv : 4), stride2uv, bs [1] [2], qpc, a, b, 1, h -> loopf.deblock_chroma [1]);
                }
            }
            while (0);
            do {
                if (!(3 & 1) || !transform_8x8) {
                    deblock_edge (h, pixy + 4 * 3 * (1 ? stride2y : 1), stride2y, bs [1] [3], qp, a, b, 0, h -> loopf.deblock_luma [1]);
                    if (h->sps->i_chroma_format_idc == CHROMA_444) {
                        deblock_edge (h, pixuv + 4 * 3 * (1 ? stride2uv : 1), stride2uv, bs [1] [3], qpc, a, b, 0, h -> loopf.deblock_luma [1]);
                        deblock_edge (h, pixuv + uvdiff + 4 * 3 * (1 ? stride2uv : 1), stride2uv, bs [1] [3], qpc, a, b, 0, h -> loopf.deblock_luma [1]);
                    }
                    else if (h->sps->i_chroma_format_idc == CHROMA_420 && !(3 & 1)) {
                        deblock_edge (h, pixuv + 3 * (1 ? 2 * stride2uv : 4), stride2uv, bs [1] [3], qpc, a, b, 1, h -> loopf.deblock_chroma [1]);
                    }
                }
                if (h->sps->i_chroma_format_idc == CHROMA_422 && (1 || !(3 & 1))) {
                    deblock_edge (h, pixuv + 3 * (1 ? 4 * stride2uv : 4), stride2uv, bs [1] [3], qpc, a, b, 1, h -> loopf.deblock_chroma [1]);
                }
            }
            while (0);
        }
    }
}

void x264_macroblock_deblock (x264_t *h) {
    int a = h->sh.i_alpha_c0_offset - (6 * (8 - 8));
    int b = h->sh.i_beta_offset - (6 * (8 - 8));
    int qp_thresh = 15 - ((a) < (b) ? (a) : (b)) - ((0) > (h->pps->i_chroma_qp_index_offset) ? (0) : (h->pps->i_chroma_qp_index_offset));
    int intra_cur = ((h->mb.i_type) == I_4x4 || (h->mb.i_type) == I_8x8 || (h->mb.i_type) == I_16x16 || (h->mb.i_type) == I_PCM);
    int qp = h->mb.i_qp;
    int qpc = h->mb.i_chroma_qp;
    if ((h->mb.i_partition == D_16x16 && !h->mb.i_cbp_luma && !intra_cur) || qp <= qp_thresh)
        return;
    uint8_t (*bs) [8] [4] = h->mb.cache.deblock_strength;
    if (intra_cur) {
        memset (& bs [0] [1], 3, 3 * 4 * sizeof (uint8_t));
        memset (& bs [1] [1], 3, 3 * 4 * sizeof (uint8_t));
    }
    else
        h->loopf.deblock_strength (h->mb.cache.non_zero_count, h->mb.cache.ref, h->mb.cache.mv, bs, 4 >> 0, h->sh.i_type == SLICE_TYPE_B);
    int transform_8x8 = h->mb.b_transform_8x8;
    if (!transform_8x8)
        do {
            deblock_edge (h, h -> mb.pic.p_fdec [0] + 4 * 1 * (0 ? 32 : 1), 32, bs [0] [1], qp, a, b, 0, h -> loopf.deblock_luma [0]);
            if ((h->sps->i_chroma_format_idc == CHROMA_444)) {
                deblock_edge (h, h -> mb.pic.p_fdec [1] + 4 * 1 * (0 ? 32 : 1), 32, bs [0] [1], qpc, a, b, 0, h -> loopf.deblock_luma [0]);
                deblock_edge (h, h -> mb.pic.p_fdec [2] + 4 * 1 * (0 ? 32 : 1), 32, bs [0] [1], qpc, a, b, 0, h -> loopf.deblock_luma [0]);
            }
        }
        while (0);
    do {
        deblock_edge (h, h -> mb.pic.p_fdec [0] + 4 * 2 * (0 ? 32 : 1), 32, bs [0] [2], qp, a, b, 0, h -> loopf.deblock_luma [0]);
        if ((h->sps->i_chroma_format_idc == CHROMA_444)) {
            deblock_edge (h, h -> mb.pic.p_fdec [1] + 4 * 2 * (0 ? 32 : 1), 32, bs [0] [2], qpc, a, b, 0, h -> loopf.deblock_luma [0]);
            deblock_edge (h, h -> mb.pic.p_fdec [2] + 4 * 2 * (0 ? 32 : 1), 32, bs [0] [2], qpc, a, b, 0, h -> loopf.deblock_luma [0]);
        }
    }
    while (0);
    if (!transform_8x8)
        do {
            deblock_edge (h, h -> mb.pic.p_fdec [0] + 4 * 3 * (0 ? 32 : 1), 32, bs [0] [3], qp, a, b, 0, h -> loopf.deblock_luma [0]);
            if ((h->sps->i_chroma_format_idc == CHROMA_444)) {
                deblock_edge (h, h -> mb.pic.p_fdec [1] + 4 * 3 * (0 ? 32 : 1), 32, bs [0] [3], qpc, a, b, 0, h -> loopf.deblock_luma [0]);
                deblock_edge (h, h -> mb.pic.p_fdec [2] + 4 * 3 * (0 ? 32 : 1), 32, bs [0] [3], qpc, a, b, 0, h -> loopf.deblock_luma [0]);
            }
        }
        while (0);
    if (!transform_8x8)
        do {
            deblock_edge (h, h -> mb.pic.p_fdec [0] + 4 * 1 * (1 ? 32 : 1), 32, bs [1] [1], qp, a, b, 0, h -> loopf.deblock_luma [1]);
            if ((h->sps->i_chroma_format_idc == CHROMA_444)) {
                deblock_edge (h, h -> mb.pic.p_fdec [1] + 4 * 1 * (1 ? 32 : 1), 32, bs [1] [1], qpc, a, b, 0, h -> loopf.deblock_luma [1]);
                deblock_edge (h, h -> mb.pic.p_fdec [2] + 4 * 1 * (1 ? 32 : 1), 32, bs [1] [1], qpc, a, b, 0, h -> loopf.deblock_luma [1]);
            }
        }
        while (0);
    do {
        deblock_edge (h, h -> mb.pic.p_fdec [0] + 4 * 2 * (1 ? 32 : 1), 32, bs [1] [2], qp, a, b, 0, h -> loopf.deblock_luma [1]);
        if ((h->sps->i_chroma_format_idc == CHROMA_444)) {
            deblock_edge (h, h -> mb.pic.p_fdec [1] + 4 * 2 * (1 ? 32 : 1), 32, bs [1] [2], qpc, a, b, 0, h -> loopf.deblock_luma [1]);
            deblock_edge (h, h -> mb.pic.p_fdec [2] + 4 * 2 * (1 ? 32 : 1), 32, bs [1] [2], qpc, a, b, 0, h -> loopf.deblock_luma [1]);
        }
    }
    while (0);
    if (!transform_8x8)
        do {
            deblock_edge (h, h -> mb.pic.p_fdec [0] + 4 * 3 * (1 ? 32 : 1), 32, bs [1] [3], qp, a, b, 0, h -> loopf.deblock_luma [1]);
            if ((h->sps->i_chroma_format_idc == CHROMA_444)) {
                deblock_edge (h, h -> mb.pic.p_fdec [1] + 4 * 3 * (1 ? 32 : 1), 32, bs [1] [3], qpc, a, b, 0, h -> loopf.deblock_luma [1]);
                deblock_edge (h, h -> mb.pic.p_fdec [2] + 4 * 3 * (1 ? 32 : 1), 32, bs [1] [3], qpc, a, b, 0, h -> loopf.deblock_luma [1]);
            }
        }
        while (0);
}

void x264_deblock_init (int cpu, x264_deblock_function_t *pf, int b_mbaff) {
    pf->deblock_luma[1] = deblock_v_luma_c;
    pf->deblock_luma[0] = deblock_h_luma_c;
    pf->deblock_chroma[1] = deblock_v_chroma_c;
    pf->deblock_h_chroma_420 = deblock_h_chroma_c;
    pf->deblock_h_chroma_422 = deblock_h_chroma_422_c;
    pf->deblock_luma_intra[1] = deblock_v_luma_intra_c;
    pf->deblock_luma_intra[0] = deblock_h_luma_intra_c;
    pf->deblock_chroma_intra[1] = deblock_v_chroma_intra_c;
    pf->deblock_h_chroma_420_intra = deblock_h_chroma_intra_c;
    pf->deblock_h_chroma_422_intra = deblock_h_chroma_422_intra_c;
    pf->deblock_luma_mbaff = deblock_h_luma_mbaff_c;
    pf->deblock_chroma_420_mbaff = deblock_h_chroma_mbaff_c;
    pf->deblock_luma_intra_mbaff = deblock_h_luma_intra_mbaff_c;
    pf->deblock_chroma_420_intra_mbaff = deblock_h_chroma_intra_mbaff_c;
    pf->deblock_strength = deblock_strength_c;
    pf->deblock_chroma_422_mbaff = pf->deblock_h_chroma_420;
    pf->deblock_chroma_422_intra_mbaff = pf->deblock_h_chroma_420_intra;
}

