
#include "common.h"

#include "me.h"
const uint8_t x264_pred_i4x4_neighbors [12] = {MB_TOP, MB_LEFT, MB_LEFT | MB_TOP, MB_TOP | MB_TOPRIGHT, MB_LEFT | MB_TOPLEFT | MB_TOP, MB_LEFT | MB_TOPLEFT | MB_TOP, MB_LEFT | MB_TOPLEFT | MB_TOP, MB_TOP | MB_TOPRIGHT, MB_LEFT, MB_LEFT, MB_TOP, 0};
const uint8_t x264_mb_type_fix [19] = {I_4x4, I_4x4, I_16x16, I_PCM, P_L0, P_8x8, P_SKIP, B_DIRECT, B_L0_L0, B_L0_L1, B_L0_BI, B_L1_L0, B_L1_L1, B_L1_BI, B_BI_L0, B_BI_L1, B_BI_BI, B_8x8, B_SKIP};
const uint8_t x264_mb_type_list_table [19] [2] [2] = {{{0, 0}, {0, 0}}, {{0, 0}, {0, 0}}, {{0, 0}, {0, 0}}, {{0, 0}, {0, 0}}, {{1, 1}, {0, 0}}, {{0, 0}, {0, 0}}, {{1, 1}, {0, 0}}, {{0, 0}, {0, 0}}, {{1, 1}, {0, 0}}, {{1, 0}, {0, 1}}, {{1, 1}, {0, 1}}, {{0, 1}, {1, 0}}, {{0, 0}, {1, 1}}, {{0, 1}, {1, 1}}, {{1, 1}, {1, 0}}, {{1, 0}, {1, 1}}, {{1, 1}, {1, 1}}, {{0, 0}, {0, 0}}, {{0, 0}, {0, 0}}};
const uint8_t x264_mb_partition_listX_table [2] [17] = {{1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0}};
const uint8_t x264_mb_partition_count_table [17] = {4, 2, 2, 1, 4, 2, 2, 1, 4, 2, 2, 1, 1, 4, 2, 2, 1};
const uint8_t x264_mb_partition_pixel_table [17] = {PIXEL_4x4, PIXEL_8x4, PIXEL_4x8, PIXEL_8x8, PIXEL_4x4, PIXEL_8x4, PIXEL_4x8, PIXEL_8x8, PIXEL_4x4, PIXEL_8x4, PIXEL_4x8, PIXEL_8x8, PIXEL_8x8, PIXEL_8x8, PIXEL_16x8, PIXEL_8x16, PIXEL_16x16,};
const uint8_t x264_zigzag_scan4 [2] [16] = {{0, 4, 1, 2, 5, 8, 12, 9, 6, 3, 7, 10, 13, 14, 11, 15}, {0, 1, 4, 2, 3, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15}};
const uint8_t x264_zigzag_scan8 [2] [64] = {{0, 8, 1, 2, 9, 16, 24, 17, 10, 3, 4, 11, 18, 25, 32, 40, 33, 26, 19, 12, 5, 6, 13, 20, 27, 34, 41, 48, 56, 49, 42, 35, 28, 21, 14, 7, 15, 22, 29, 36, 43, 50, 57, 58, 51, 44, 37, 30, 23, 31, 38, 45, 52, 59, 60, 53, 46, 39, 47, 54, 61, 62, 55, 63}, {0, 1, 2, 8, 9, 3, 4, 10, 16, 11, 5, 6, 7, 12, 17, 24, 18, 13, 14, 15, 19, 25, 32, 26, 20, 21, 22, 23, 27, 33, 40, 34, 28, 29, 30, 31, 35, 41, 48, 42, 36, 37, 38, 39, 43, 49, 50, 44, 45, 46, 47, 51, 56, 57, 52, 53, 54, 55, 58, 59, 60, 61, 62, 63}};
const uint8_t block_idx_x [16] = {0, 1, 0, 1, 2, 3, 2, 3, 0, 1, 0, 1, 2, 3, 2, 3};
const uint8_t block_idx_y [16] = {0, 0, 1, 1, 0, 0, 1, 1, 2, 2, 3, 3, 2, 2, 3, 3};
const uint8_t block_idx_xy [4] [4] = {{0, 2, 8, 10}, {1, 3, 9, 11}, {4, 6, 12, 14}, {5, 7, 13, 15}};
const uint8_t block_idx_xy_1d [16] = {0, 1, 4, 5, 2, 3, 6, 7, 8, 9, 12, 13, 10, 11, 14, 15};
const uint8_t block_idx_yx_1d [16] = {0, 4, 1, 5, 8, 12, 9, 13, 2, 6, 3, 7, 10, 14, 11, 15};
const uint8_t block_idx_xy_fenc [16] = {0 * 4 + 0 * 4 * FENC_STRIDE, 1 * 4 + 0 * 4 * FENC_STRIDE, 0 * 4 + 1 * 4 * FENC_STRIDE, 1 * 4 + 1 * 4 * FENC_STRIDE, 2 * 4 + 0 * 4 * FENC_STRIDE, 3 * 4 + 0 * 4 * FENC_STRIDE, 2 * 4 + 1 * 4 * FENC_STRIDE, 3 * 4 + 1 * 4 * FENC_STRIDE, 0 * 4 + 2 * 4 * FENC_STRIDE, 1 * 4 + 2 * 4 * FENC_STRIDE, 0 * 4 + 3 * 4 * FENC_STRIDE, 1 * 4 + 3 * 4 * FENC_STRIDE, 2 * 4 + 2 * 4 * FENC_STRIDE, 3 * 4 + 2 * 4 * FENC_STRIDE, 2 * 4 + 3 * 4 * FENC_STRIDE, 3 * 4 + 3 * 4 * FENC_STRIDE};
const uint16_t block_idx_xy_fdec [16] = {0 * 4 + 0 * 4 * FDEC_STRIDE, 1 * 4 + 0 * 4 * FDEC_STRIDE, 0 * 4 + 1 * 4 * FDEC_STRIDE, 1 * 4 + 1 * 4 * FDEC_STRIDE, 2 * 4 + 0 * 4 * FDEC_STRIDE, 3 * 4 + 0 * 4 * FDEC_STRIDE, 2 * 4 + 1 * 4 * FDEC_STRIDE, 3 * 4 + 1 * 4 * FDEC_STRIDE, 0 * 4 + 2 * 4 * FDEC_STRIDE, 1 * 4 + 2 * 4 * FDEC_STRIDE, 0 * 4 + 3 * 4 * FDEC_STRIDE, 1 * 4 + 3 * 4 * FDEC_STRIDE, 2 * 4 + 2 * 4 * FDEC_STRIDE, 3 * 4 + 2 * 4 * FDEC_STRIDE, 2 * 4 + 3 * 4 * FDEC_STRIDE, 3 * 4 + 3 * 4 * FDEC_STRIDE};
const uint8_t i_chroma_qp_table [QP_MAX + 1 + 12 * 2] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, ((0) + QP_BD_OFFSET), ((1) + QP_BD_OFFSET), ((2) + QP_BD_OFFSET), ((3) + QP_BD_OFFSET), ((4) + QP_BD_OFFSET), ((5) + QP_BD_OFFSET), ((6) + QP_BD_OFFSET), ((7) + QP_BD_OFFSET), ((8) + QP_BD_OFFSET), ((9) + QP_BD_OFFSET), ((10) + QP_BD_OFFSET), ((11) + QP_BD_OFFSET), ((12) + QP_BD_OFFSET), ((13) + QP_BD_OFFSET), ((14) + QP_BD_OFFSET), ((15) + QP_BD_OFFSET), ((16) + QP_BD_OFFSET), ((17) + QP_BD_OFFSET), ((18) + QP_BD_OFFSET), ((19) + QP_BD_OFFSET), ((20) + QP_BD_OFFSET), ((21) + QP_BD_OFFSET), ((22) + QP_BD_OFFSET), ((23) + QP_BD_OFFSET), ((24) + QP_BD_OFFSET), ((25) + QP_BD_OFFSET), ((26) + QP_BD_OFFSET), ((27) + QP_BD_OFFSET), ((28) + QP_BD_OFFSET), ((29) + QP_BD_OFFSET), ((29) + QP_BD_OFFSET), ((30) + QP_BD_OFFSET), ((31) + QP_BD_OFFSET), ((32) + QP_BD_OFFSET), ((32) + QP_BD_OFFSET), ((33) + QP_BD_OFFSET), ((34) + QP_BD_OFFSET), ((34) + QP_BD_OFFSET), ((35) + QP_BD_OFFSET), ((35) + QP_BD_OFFSET), ((36) + QP_BD_OFFSET), ((36) + QP_BD_OFFSET), ((37) + QP_BD_OFFSET), ((37) + QP_BD_OFFSET), ((37) + QP_BD_OFFSET), ((38) + QP_BD_OFFSET), ((38) + QP_BD_OFFSET), ((38) + QP_BD_OFFSET), ((39) + QP_BD_OFFSET), ((39) + QP_BD_OFFSET), ((39) + QP_BD_OFFSET), ((39) + QP_BD_OFFSET), ((39) + QP_BD_OFFSET), ((39) + QP_BD_OFFSET), ((39) + QP_BD_OFFSET), ((39) + QP_BD_OFFSET), ((39) + QP_BD_OFFSET), ((39) + QP_BD_OFFSET), ((39) + QP_BD_OFFSET), ((39) + QP_BD_OFFSET), ((39) + QP_BD_OFFSET), ((39) + QP_BD_OFFSET), ((39) + QP_BD_OFFSET), ((39) + QP_BD_OFFSET),};
const uint8_t ctx_cat_plane [6] [3] = {{DCT_LUMA_DC, DCT_CHROMAU_DC, DCT_CHROMAV_DC}, {DCT_LUMA_AC, DCT_CHROMAU_AC, DCT_CHROMAV_AC}, {DCT_LUMA_4x4, DCT_CHROMAU_4x4, DCT_CHROMAV_4x4}, {0}, {0}, {DCT_LUMA_8x8, DCT_CHROMAU_8x8, DCT_CHROMAV_8x8}};
const uint8_t x264_transform_allowed [19] = {0, 0, 0, 0, 1, 2, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0};

uint32_t pack16to32 (uint32_t a, uint32_t b) {
    return a + (b << 16);
}

uint32_t pack8to16 (uint32_t a, uint32_t b) {
    return a + (b << 8);
}

uint32_t pack8to32 (uint32_t a, uint32_t b, uint32_t c, uint32_t d) {
    return a + (b << 8) + (c << 16) + (d << 24);
}

uint32_t pack16to32_mask (int a, int b) {
    return (a & 0xFFFF) + (b << 16);
}

uint64_t pack32to64 (uint32_t a, uint32_t b) {
    return a + ((uint64_t) b << 32);
}

int x264_mb_predict_intra4x4_mode (x264_t *h, int idx) {
    const int ma = h->mb.cache.intra4x4_pred_mode[x264_scan8[idx] - 1];
    const int mb = h->mb.cache.intra4x4_pred_mode[x264_scan8[idx] - 8];
    const int m = X264_MIN (x264_mb_pred_mode4x4_fix (ma), x264_mb_pred_mode4x4_fix (mb));
    if (m < 0)
        return I_PRED_4x4_DC;
    return m;
}

int x264_mb_predict_non_zero_code (x264_t *h, int idx) {
    const int za = h->mb.cache.non_zero_count[x264_scan8[idx] - 1];
    const int zb = h->mb.cache.non_zero_count[x264_scan8[idx] - 8];
    int i_ret = za + zb;
    if (i_ret < 0x80)
        i_ret = (i_ret + 1) >> 1;
    return i_ret & 0x7f;
}

int x264_mb_transform_8x8_allowed (x264_t *h) {
    if (!h->pps->b_transform_8x8_mode)
        return 0;
    if (h->mb.i_type != P_8x8)
        return x264_transform_allowed[h->mb.i_type];
    return M32 (h->mb.i_sub_partition) == D_L0_8x8 * 0x01010101;
}

void x264_mb_mc_0xywh (x264_t *h, int x, int y, int width, int height) {
    int i8 = x264_scan8[0] + x + 8 * y;
    int i_ref = h->mb.cache.ref[0][i8];
    int mvx = x264_clip3 (h->mb.cache.mv[0][i8][0], h->mb.mv_min[0], h->mb.mv_max[0]) + 4 * 4 * x;
    int mvy = x264_clip3 (h->mb.cache.mv[0][i8][1], h->mb.mv_min[1], h->mb.mv_max[1]) + 4 * 4 * y;
    h->mc.mc_luma (&h->mb.pic.p_fdec[0][4 * y * 32 + 4 * x], 32, &h->mb.pic.p_fref[0][i_ref][0 * 4], h->mb.pic.i_stride[0], mvx, mvy, 4 * width, 4 * height, 0 ? x264_weight_none : &h->sh.weight[i_ref][0]);
    ;
    if ((h->sps->i_chroma_format_idc == CHROMA_444)) {
        h->mc.mc_luma (&h->mb.pic.p_fdec[1][4 * y * 32 + 4 * x], 32, &h->mb.pic.p_fref[0][i_ref][1 * 4], h->mb.pic.i_stride[1], mvx, mvy, 4 * width, 4 * height, 0 ? x264_weight_none : &h->sh.weight[i_ref][1]);
        ;
        h->mc.mc_luma (&h->mb.pic.p_fdec[2][4 * y * 32 + 4 * x], 32, &h->mb.pic.p_fref[0][i_ref][2 * 4], h->mb.pic.i_stride[2], mvx, mvy, 4 * width, 4 * height, 0 ? x264_weight_none : &h->sh.weight[i_ref][2]);
        ;
    }
    else {
        int v_shift = h->mb.chroma_v_shift;
        if (v_shift & 0 & i_ref)
            mvy += (h->mb.i_mb_y & 1) * 4 - 2;
        int offset = (4 * 32 >> v_shift) * y + 2 * x;
        height = 4 * height >> v_shift;
        h->mc.mc_chroma (&h->mb.pic.p_fdec[1][offset], &h->mb.pic.p_fdec[2][offset], 32, h->mb.pic.p_fref[0][i_ref][4], h->mb.pic.i_stride[1], mvx, 2 * mvy >> v_shift, 2 * width, height);
        if (h->sh.weight[i_ref][1].weightfn)
            h->sh.weight[i_ref][1].weightfn[width >> 1] (&h->mb.pic.p_fdec[1][offset], 32, &h->mb.pic.p_fdec[1][offset], 32, &h->sh.weight[i_ref][1], height);
        if (h->sh.weight[i_ref][2].weightfn)
            h->sh.weight[i_ref][2].weightfn[width >> 1] (&h->mb.pic.p_fdec[2][offset], 32, &h->mb.pic.p_fdec[2][offset], 32, &h->sh.weight[i_ref][2], height);
    }
}

void x264_mb_mc_1xywh (x264_t *h, int x, int y, int width, int height) {
    int i8 = x264_scan8[0] + x + 8 * y;
    int i_ref = h->mb.cache.ref[1][i8];
    int mvx = x264_clip3 (h->mb.cache.mv[1][i8][0], h->mb.mv_min[0], h->mb.mv_max[0]) + 4 * 4 * x;
    int mvy = x264_clip3 (h->mb.cache.mv[1][i8][1], h->mb.mv_min[1], h->mb.mv_max[1]) + 4 * 4 * y;
    h->mc.mc_luma (&h->mb.pic.p_fdec[0][4 * y * 32 + 4 * x], 32, &h->mb.pic.p_fref[1][i_ref][0 * 4], h->mb.pic.i_stride[0], mvx, mvy, 4 * width, 4 * height, 1 ? x264_weight_none : &h->sh.weight[i_ref][0]);
    ;
    if ((h->sps->i_chroma_format_idc == CHROMA_444)) {
        h->mc.mc_luma (&h->mb.pic.p_fdec[1][4 * y * 32 + 4 * x], 32, &h->mb.pic.p_fref[1][i_ref][1 * 4], h->mb.pic.i_stride[1], mvx, mvy, 4 * width, 4 * height, 1 ? x264_weight_none : &h->sh.weight[i_ref][1]);
        ;
        h->mc.mc_luma (&h->mb.pic.p_fdec[2][4 * y * 32 + 4 * x], 32, &h->mb.pic.p_fref[1][i_ref][2 * 4], h->mb.pic.i_stride[2], mvx, mvy, 4 * width, 4 * height, 1 ? x264_weight_none : &h->sh.weight[i_ref][2]);
        ;
    }
    else {
        int v_shift = h->mb.chroma_v_shift;
        if (v_shift & 0 & i_ref)
            mvy += (h->mb.i_mb_y & 1) * 4 - 2;
        int offset = (4 * 32 >> v_shift) * y + 2 * x;
        h->mc.mc_chroma (&h->mb.pic.p_fdec[1][offset], &h->mb.pic.p_fdec[2][offset], 32, h->mb.pic.p_fref[1][i_ref][4], h->mb.pic.i_stride[1], mvx, 2 * mvy >> v_shift, 2 * width, 4 * height >> v_shift);
    }
}

void x264_mb_mc_01xywh (x264_t *h, int x, int y, int width, int height) {
    int i8 = x264_scan8[0] + x + 8 * y;
    int i_ref0 = h->mb.cache.ref[0][i8];
    int i_ref1 = h->mb.cache.ref[1][i8];
    int weight = h->mb.bipred_weight[i_ref0][i_ref1];
    int mvx0 = x264_clip3 (h->mb.cache.mv[0][i8][0], h->mb.mv_min[0], h->mb.mv_max[0]) + 4 * 4 * x;
    int mvx1 = x264_clip3 (h->mb.cache.mv[1][i8][0], h->mb.mv_min[0], h->mb.mv_max[0]) + 4 * 4 * x;
    int mvy0 = x264_clip3 (h->mb.cache.mv[0][i8][1], h->mb.mv_min[1], h->mb.mv_max[1]) + 4 * 4 * y;
    int mvy1 = x264_clip3 (h->mb.cache.mv[1][i8][1], h->mb.mv_min[1], h->mb.mv_max[1]) + 4 * 4 * y;
    int i_mode = x264_size2pixel[height][width];
    intptr_t i_stride0 = 16, i_stride1 = 16;
    uint8_t tmp0_u [sizeof (pixel[16 * 16]) + 31];
    pixel (*tmp0) = (void *) ((intptr_t) (tmp0_u + 31) & ~31);
    uint8_t tmp1_u [sizeof (pixel[16 * 16]) + 31];
    pixel (*tmp1) = (void *) ((intptr_t) (tmp1_u + 31) & ~31);
    pixel *src0, *src1;
    src0 = h->mc.get_ref (tmp0, &i_stride0, &h->mb.pic.p_fref[0][i_ref0][0 * 4], h->mb.pic.i_stride[0], mvx0, mvy0, 4 * width, 4 * height, x264_weight_none);
    src1 = h->mc.get_ref (tmp1, &i_stride1, &h->mb.pic.p_fref[1][i_ref1][0 * 4], h->mb.pic.i_stride[0], mvx1, mvy1, 4 * width, 4 * height, x264_weight_none);
    h->mc.avg[i_mode] (&h->mb.pic.p_fdec[0][4 * y * 32 + 4 * x], 32, src0, i_stride0, src1, i_stride1, weight);
    ;
    if ((h->sps->i_chroma_format_idc == CHROMA_444)) {
        src0 = h->mc.get_ref (tmp0, &i_stride0, &h->mb.pic.p_fref[0][i_ref0][1 * 4], h->mb.pic.i_stride[1], mvx0, mvy0, 4 * width, 4 * height, x264_weight_none);
        src1 = h->mc.get_ref (tmp1, &i_stride1, &h->mb.pic.p_fref[1][i_ref1][1 * 4], h->mb.pic.i_stride[1], mvx1, mvy1, 4 * width, 4 * height, x264_weight_none);
        h->mc.avg[i_mode] (&h->mb.pic.p_fdec[1][4 * y * 32 + 4 * x], 32, src0, i_stride0, src1, i_stride1, weight);
        ;
        src0 = h->mc.get_ref (tmp0, &i_stride0, &h->mb.pic.p_fref[0][i_ref0][2 * 4], h->mb.pic.i_stride[2], mvx0, mvy0, 4 * width, 4 * height, x264_weight_none);
        src1 = h->mc.get_ref (tmp1, &i_stride1, &h->mb.pic.p_fref[1][i_ref1][2 * 4], h->mb.pic.i_stride[2], mvx1, mvy1, 4 * width, 4 * height, x264_weight_none);
        h->mc.avg[i_mode] (&h->mb.pic.p_fdec[2][4 * y * 32 + 4 * x], 32, src0, i_stride0, src1, i_stride1, weight);
        ;
    }
    else {
        int v_shift = h->mb.chroma_v_shift;
        if (v_shift & 0 & i_ref0)
            mvy0 += (h->mb.i_mb_y & 1) * 4 - 2;
        if (v_shift & 0 & i_ref1)
            mvy1 += (h->mb.i_mb_y & 1) * 4 - 2;
        h->mc.mc_chroma (tmp0, tmp0 +8, 16, h->mb.pic.p_fref[0][i_ref0][4], h->mb.pic.i_stride[1], mvx0, 2 * mvy0 >> v_shift, 2 * width, 4 * height >> v_shift);
        h->mc.mc_chroma (tmp1, tmp1 +8, 16, h->mb.pic.p_fref[1][i_ref1][4], h->mb.pic.i_stride[1], mvx1, 2 * mvy1 >> v_shift, 2 * width, 4 * height >> v_shift);
        int chromapix = h->luma2chroma_pixel[i_mode];
        int offset = (4 * 32 >> v_shift) * y + 2 * x;
        h->mc.avg[chromapix] (&h->mb.pic.p_fdec[1][offset], 32, tmp0, 16, tmp1, 16, weight);
        h->mc.avg[chromapix] (&h->mb.pic.p_fdec[2][offset], 32, tmp0 +8, 16, tmp1 +8, 16, weight);
    }
}

void x264_mb_mc_8x8 (x264_t *h, int i8) {
    int x = 2 * (i8 & 1);
    int y = 2 * (i8 >> 1);
    if (h->sh.i_type == SLICE_TYPE_P) {
        switch (h->mb.i_sub_partition[i8]) {
        case D_L0_8x8 :
            x264_mb_mc_0xywh (h, x, y, 2, 2);
            break;
        case D_L0_8x4 :
            x264_mb_mc_0xywh (h, x, y +0, 2, 1);
            x264_mb_mc_0xywh (h, x, y + 1, 2, 1);
            break;
        case D_L0_4x8 :
            x264_mb_mc_0xywh (h, x +0, y, 1, 2);
            x264_mb_mc_0xywh (h, x + 1, y, 1, 2);
            break;
        case D_L0_4x4 :
            x264_mb_mc_0xywh (h, x +0, y +0, 1, 1);
            x264_mb_mc_0xywh (h, x + 1, y + 0, 1, 1);
            x264_mb_mc_0xywh (h, x + 0, y + 1, 1, 1);
            x264_mb_mc_0xywh (h, x + 1, y + 1, 1, 1);
            break;
        }
    }
    else {
        int scan8 = x264_scan8[0] + x + 8 * y;
        if (h->mb.cache.ref[0][scan8] >= 0)
            if (h->mb.cache.ref[1][scan8] >= 0)
                x264_mb_mc_01xywh (h, x, y, 2, 2);
            else
                x264_mb_mc_0xywh (h, x, y, 2, 2);
        else
            x264_mb_mc_1xywh (h, x, y, 2, 2);
    }
}

void x264_mb_mc (x264_t *h) {
    if (h->mb.i_partition == D_8x8) {
        for (int i = 0; i < 4; i++)
            x264_mb_mc_8x8 (h, i);
    }
    else {
        int ref0a = h->mb.cache.ref[0][x264_scan8[0]];
        int ref0b = h->mb.cache.ref[0][x264_scan8[12]];
        int ref1a = h->mb.cache.ref[1][x264_scan8[0]];
        int ref1b = h->mb.cache.ref[1][x264_scan8[12]];
        if (h->mb.i_partition == D_16x16) {
            if (ref0a >= 0)
                if (ref1a >= 0)
                    x264_mb_mc_01xywh (h, 0, 0, 4, 4);
                else
                    x264_mb_mc_0xywh (h, 0, 0, 4, 4);
            else
                x264_mb_mc_1xywh (h, 0, 0, 4, 4);
        }
        else if (h->mb.i_partition == D_16x8) {
            if (ref0a >= 0)
                if (ref1a >= 0)
                    x264_mb_mc_01xywh (h, 0, 0, 4, 2);
                else
                    x264_mb_mc_0xywh (h, 0, 0, 4, 2);
            else
                x264_mb_mc_1xywh (h, 0, 0, 4, 2);
            if (ref0b >= 0)
                if (ref1b >= 0)
                    x264_mb_mc_01xywh (h, 0, 2, 4, 2);
                else
                    x264_mb_mc_0xywh (h, 0, 2, 4, 2);
            else
                x264_mb_mc_1xywh (h, 0, 2, 4, 2);
        }
        else if (h->mb.i_partition == D_8x16) {
            if (ref0a >= 0)
                if (ref1a >= 0)
                    x264_mb_mc_01xywh (h, 0, 0, 2, 4);
                else
                    x264_mb_mc_0xywh (h, 0, 0, 2, 4);
            else
                x264_mb_mc_1xywh (h, 0, 0, 2, 4);
            if (ref0b >= 0)
                if (ref1b >= 0)
                    x264_mb_mc_01xywh (h, 2, 0, 2, 4);
                else
                    x264_mb_mc_0xywh (h, 2, 0, 2, 4);
            else
                x264_mb_mc_1xywh (h, 2, 0, 2, 4);
        }
    }
}

int x264_macroblock_cache_allocate (x264_t *h) {
    int i_mb_count = h->mb.i_mb_count;
    h->mb.i_mb_stride = h->mb.i_mb_width;
    h->mb.i_b8_stride = h->mb.i_mb_width * 2;
    h->mb.i_b4_stride = h->mb.i_mb_width * 4;
    h->mb.b_interlaced = 0;
    int prealloc_idx = 0;
    size_t prealloc_size = 0;
    uint8_t **preallocs [1024];
    do {
        h->mb.qp = (void *) prealloc_size;
        preallocs[prealloc_idx++] = (uint8_t **) &h->mb.qp;
        prealloc_size += (((i_mb_count * sizeof (int8_t)) + ((32) - 1)) & ~((32) - 1));
    }
    while (0);
    do {
        h->mb.cbp = (void *) prealloc_size;
        preallocs[prealloc_idx++] = (uint8_t **) &h->mb.cbp;
        prealloc_size += (((i_mb_count * sizeof (int16_t)) + ((32) - 1)) & ~((32) - 1));
    }
    while (0);
    do {
        h->mb.mb_transform_size = (void *) prealloc_size;
        preallocs[prealloc_idx++] = (uint8_t **) &h->mb.mb_transform_size;
        prealloc_size += (((i_mb_count * sizeof (int8_t)) + ((32) - 1)) & ~((32) - 1));
    }
    while (0);
    do {
        h->mb.slice_table = (void *) prealloc_size;
        preallocs[prealloc_idx++] = (uint8_t **) &h->mb.slice_table;
        prealloc_size += (((i_mb_count * sizeof (uint16_t)) + ((32) - 1)) & ~((32) - 1));
    }
    while (0);
    do {
        h->mb.intra4x4_pred_mode = (void *) prealloc_size;
        preallocs[prealloc_idx++] = (uint8_t **) &h->mb.intra4x4_pred_mode;
        prealloc_size += (((i_mb_count * 8 * sizeof (int8_t)) + ((32) - 1)) & ~((32) - 1));
    }
    while (0);
    do {
        h->mb.non_zero_count = (void *) prealloc_size;
        preallocs[prealloc_idx++] = (uint8_t **) &h->mb.non_zero_count;
        prealloc_size += (((i_mb_count * 48 * sizeof (uint8_t)) + ((32) - 1)) & ~((32) - 1));
    }
    while (0);
    if (h->param.b_cabac) {
        do {
            h->mb.skipbp = (void *) prealloc_size;
            preallocs[prealloc_idx++] = (uint8_t **) &h->mb.skipbp;
            prealloc_size += (((i_mb_count * sizeof (int8_t)) + ((32) - 1)) & ~((32) - 1));
        }
        while (0);
        do {
            h->mb.chroma_pred_mode = (void *) prealloc_size;
            preallocs[prealloc_idx++] = (uint8_t **) &h->mb.chroma_pred_mode;
            prealloc_size += (((i_mb_count * sizeof (int8_t)) + ((32) - 1)) & ~((32) - 1));
        }
        while (0);
        do {
            h->mb.mvd[0] = (void *) prealloc_size;
            preallocs[prealloc_idx++] = (uint8_t **) &h->mb.mvd[0];
            prealloc_size += (((i_mb_count * sizeof (**h->mb.mvd)) + ((32) - 1)) & ~((32) - 1));
        }
        while (0);
        if (h->param.i_bframe)
            do {
                h->mb.mvd[1] = (void *) prealloc_size;
                preallocs[prealloc_idx++] = (uint8_t **) &h->mb.mvd[1];
                prealloc_size += (((i_mb_count * sizeof (**h->mb.mvd)) + ((32) - 1)) & ~((32) - 1));
            }
            while (0);
    }
    for (int i = 0; i < 2; i++) {
        int i_refs = ((16) < ((i ? 1 + !!h->param.i_bframe_pyramid : h->param.i_frame_reference)) ? (16) : ((i ? 1 + !!h->param.i_bframe_pyramid : h->param.i_frame_reference))) << 0;
        if (h->param.analyse.i_weighted_pred == 2)
            i_refs = ((16) < (i_refs + 1 + (8 == 8)) ? (16) : (i_refs + 1 + (8 == 8)));
        for (int j = !i; j < i_refs; j++)
            do {
                h->mb.mvr[i][j] = (void *) prealloc_size;
                preallocs[prealloc_idx++] = (uint8_t **) &h->mb.mvr[i][j];
                prealloc_size += (((2 * (i_mb_count + 1) * sizeof (int16_t)) + ((32) - 1)) & ~((32) - 1));
            }
            while (0);
    }
    if (h->param.analyse.i_weighted_pred) {
        int i_padv = 32 << 0;
        int luma_plane_size = 0;
        int numweightbuf;
        if (h->param.analyse.i_weighted_pred == (-1)) {
            if (!h->param.i_sync_lookahead || h == h->thread[h->param.i_threads]) {
                luma_plane_size = h->fdec->i_stride_lowres * (h->mb.i_mb_height * 8 + 2 * i_padv);
                numweightbuf = 1;
            }
            else
                numweightbuf = 0;
        }
        else {
            luma_plane_size = h->fdec->i_stride[0] * (h->mb.i_mb_height * (16 << (h->sps->i_chroma_format_idc == CHROMA_422)) + 2 * i_padv);
            if (h->param.analyse.i_weighted_pred == 2)
                numweightbuf = 1 + (8 == 8);
            else
                numweightbuf = 1;
        }
        for (int i = 0; i < numweightbuf; i++)
            do {
                h->mb.p_weight_buf[i] = (void *) prealloc_size;
                preallocs[prealloc_idx++] = (uint8_t **) &h->mb.p_weight_buf[i];
                prealloc_size += (((luma_plane_size * sizeof (pixel)) + ((32) - 1)) & ~((32) - 1));
            }
            while (0);
    }
    do {
        do {
            h->mb.base = x264_malloc (prealloc_size);
            if (!h->mb.base)
                goto fail;
        }
        while (0);
        while (prealloc_idx--)
            *preallocs[prealloc_idx] += (intptr_t) h->mb.base;
    }
    while (0);
    memset (h -> mb.slice_table, - 1, i_mb_count * sizeof (uint16_t));
    for (int i = 0; i < 2; i++) {
        int i_refs = ((16) < ((i ? 1 + !!h->param.i_bframe_pyramid : h->param.i_frame_reference)) ? (16) : ((i ? 1 + !!h->param.i_bframe_pyramid : h->param.i_frame_reference))) << 0;
        if (h->param.analyse.i_weighted_pred == 2)
            i_refs = ((16) < (i_refs + 1 + (8 == 8)) ? (16) : (i_refs + 1 + (8 == 8)));
        for (int j = !i; j < i_refs; j++) {
            (((x264_union32_t *) (h->mb.mvr[i][j][0]))->i) = 0;
            h->mb.mvr[i][j]++;
        }
    }
    return 0;
fail :
    return -1;
}

void x264_macroblock_cache_free (x264_t *h) {
    x264_free (h -> mb.base);
}

int x264_macroblock_thread_allocate (x264_t *h, int b_lookahead) {
    if (!b_lookahead) {
        for (int i = 0; i < (0 ? 5 : 2); i++)
            for (int j = 0; j < ((h->sps->i_chroma_format_idc == CHROMA_444) ? 3 : 2); j++) {
                do {
                    h->intra_border_backup[i][j] = x264_malloc ((h->sps->i_mb_width * 16 + 32) * sizeof (pixel));
                    if (!h->intra_border_backup[i][j])
                        goto fail;
                }
                while (0);
                h->intra_border_backup[i][j] += 16;
            }
        for (int i = 0; i <= 0; i++) {
            if (h->param.b_sliced_threads) {
                if (h == h->thread[0] && !i)
                    do {
                        h->deblock_strength[0] = x264_malloc (sizeof (**h->deblock_strength) * h->mb.i_mb_count);
                        if (!h->deblock_strength[0])
                            goto fail;
                    }
                    while (0);
                else
                    h->deblock_strength[i] = h->thread[0]->deblock_strength[0];
            }
            else
                do {
                    h->deblock_strength[i] = x264_malloc (sizeof (**h->deblock_strength) * h->mb.i_mb_width);
                    if (!h->deblock_strength[i])
                        goto fail;
                }
                while (0);
            h->deblock_strength[1] = h->deblock_strength[i];
        }
    }
    int scratch_size = 0;
    if (!b_lookahead) {
        int buf_hpel = (h->thread[0]->fdec->i_width[0] + 48 + 32) * sizeof (int16_t);
        int buf_ssim = h->param.analyse.b_ssim * 8 * (h->param.i_width / 4 + 3) * sizeof (int);
        int me_range = ((h->param.analyse.i_me_range) < (h->param.analyse.i_mv_range) ? (h->param.analyse.i_me_range) : (h->param.analyse.i_mv_range));
        int buf_tesa = (h->param.analyse.i_me_method >= 3) * ((me_range * 2 + 24) * sizeof (int16_t) + (me_range + 4) * (me_range + 1) * 4 * sizeof (mvsad_t));
        scratch_size = (((buf_hpel)) > ((((buf_ssim)) > ((buf_tesa)) ? ((buf_ssim)) : ((buf_tesa)))) ? ((buf_hpel)) : ((((buf_ssim)) > ((buf_tesa)) ? ((buf_ssim)) : ((buf_tesa)))));
    }
    int buf_mbtree = h->param.rc.b_mb_tree * ((h->mb.i_mb_width + 7) & ~7) * sizeof (int16_t);
    scratch_size = ((scratch_size) > (buf_mbtree) ? (scratch_size) : (buf_mbtree));
    if (scratch_size)
        do {
            h->scratch_buffer = x264_malloc (scratch_size);
            if (!h->scratch_buffer)
                goto fail;
        }
        while (0);
    else
        h->scratch_buffer = ((void *) 0);
    int buf_lookahead_threads = (h->mb.i_mb_height + (4 + 32) * h->param.i_lookahead_threads) * sizeof (int) * 2;
    int buf_mbtree2 = buf_mbtree * 12;
    scratch_size = ((buf_lookahead_threads) > (buf_mbtree2) ? (buf_lookahead_threads) : (buf_mbtree2));
    do {
        h->scratch_buffer2 = x264_malloc (scratch_size);
        if (!h->scratch_buffer2)
            goto fail;
    }
    while (0);
    return 0;
fail :
    return -1;
}

void x264_macroblock_thread_free (x264_t *h, int b_lookahead) {
    if (!b_lookahead) {
        for (int i = 0; i <= 0; i++)
            if (!h->param.b_sliced_threads || (h == h->thread[0] && !i))
                x264_free (h->deblock_strength[i]);
        for (int i = 0; i < (0 ? 5 : 2); i++)
            for (int j = 0; j < ((h->sps->i_chroma_format_idc == CHROMA_444) ? 3 : 2); j++)
                x264_free (h->intra_border_backup[i][j] - 16);
    }
    x264_free (h -> scratch_buffer);
    x264_free (h -> scratch_buffer2);
}

void x264_macroblock_slice_init (x264_t *h) {
    h->mb.mv[0] = h->fdec->mv[0];
    h->mb.mv[1] = h->fdec->mv[1];
    h->mb.mvr[0][0] = h->fdec->mv16x16;
    h->mb.ref[0] = h->fdec->ref[0];
    h->mb.ref[1] = h->fdec->ref[1];
    h->mb.type = h->fdec->mb_type;
    h->mb.partition = h->fdec->mb_partition;
    h->mb.field = h->fdec->field;
    h->fdec->i_ref[0] = h->i_ref[0];
    h->fdec->i_ref[1] = h->i_ref[1];
    for (int i = 0; i < h->i_ref[0]; i++)
        h->fdec->ref_poc[0][i] = h->fref[0][i]->i_poc;
    if (h->sh.i_type == SLICE_TYPE_B) {
        for (int i = 0; i < h->i_ref[1]; i++)
            h->fdec->ref_poc[1][i] = h->fref[1][i]->i_poc;
        h->mb.map_col_to_list0[(-1) + 2] = -1;
        h->mb.map_col_to_list0[(-2) + 2] = -2;
        for (int i = 0; i < h->fref[1][0]->i_ref[0]; i++) {
            int poc = h->fref[1][0]->ref_poc[0][i];
            h->mb.map_col_to_list0[(i) +2] = -2;
            for (int j = 0; j < h->i_ref[0]; j++)
                if (h->fref[0][j]->i_poc == poc) {
                    h->mb.map_col_to_list0[(i) +2] = j;
                    break;
                }
        }
    }
    else if (h->sh.i_type == SLICE_TYPE_P) {
        if (h->sh.i_disable_deblocking_filter_idc != 1 && h->param.analyse.i_weighted_pred == 2) {
            h->mb.deblock_ref_table[(-2) + 2] = -2;
            h->mb.deblock_ref_table[(-1) + 2] = -1;
            for (int i = 0; i < h->i_ref[0] << 0; i++) {
                if (!0)
                    h->mb.deblock_ref_table[(i) +2] = h->fref[0][i]->i_frame_num & 63;
                else
                    h->mb.deblock_ref_table[(i) +2] = ((h->fref[0][i >> 1]->i_frame_num & 63) << 1) + (i & 1);
            }
        }
    }
    memset (h -> mb.cache.ref, - 2, sizeof (h -> mb.cache.ref));
    if (h->i_ref[0] > 0)
        for (int field = 0; field <= 0; field++) {
            int curpoc = h->fdec->i_poc + h->fdec->i_delta_poc[field];
            int refpoc = h->fref[0][0]->i_poc + h->fref[0][0]->i_delta_poc[field];
            int delta = curpoc - refpoc;
            h->fdec->inv_ref_poc[field] = (256 + delta / 2) / delta;
        }
    h->mb.i_neighbour4[6] = h->mb.i_neighbour4[9] = h->mb.i_neighbour4[12] = h->mb.i_neighbour4[14] = MB_LEFT | MB_TOP | MB_TOPLEFT | MB_TOPRIGHT;
    h->mb.i_neighbour4[3] = h->mb.i_neighbour4[7] = h->mb.i_neighbour4[11] = h->mb.i_neighbour4[13] = h->mb.i_neighbour4[15] = h->mb.i_neighbour8[3] = MB_LEFT | MB_TOP | MB_TOPLEFT;
}

void x264_macroblock_thread_init (x264_t *h) {
    h->mb.i_me_method = h->param.analyse.i_me_method;
    h->mb.i_subpel_refine = h->param.analyse.i_subpel_refine;
    if (h->sh.i_type == SLICE_TYPE_B && (h->mb.i_subpel_refine == 6 || h->mb.i_subpel_refine == 8))
        h->mb.i_subpel_refine--;
    h->mb.b_chroma_me = h->param.analyse.b_chroma_me && ((h->sh.i_type == SLICE_TYPE_P && h->mb.i_subpel_refine >= 5) || (h->sh.i_type == SLICE_TYPE_B && h->mb.i_subpel_refine >= 9));
    h->mb.b_dct_decimate = h->sh.i_type == SLICE_TYPE_B || (h->param.analyse.b_dct_decimate && h->sh.i_type != SLICE_TYPE_I);
    h->mb.i_mb_prev_xy = -1;
    h->mb.pic.p_fenc[0] = h->mb.pic.fenc_buf;
    h->mb.pic.p_fdec[0] = h->mb.pic.fdec_buf + 2 * 32;
    h->mb.pic.p_fenc[1] = h->mb.pic.fenc_buf + 16 * 16;
    h->mb.pic.p_fdec[1] = h->mb.pic.fdec_buf + 19 * 32;
    if ((h->sps->i_chroma_format_idc == CHROMA_444)) {
        h->mb.pic.p_fenc[2] = h->mb.pic.fenc_buf + 32 * 16;
        h->mb.pic.p_fdec[2] = h->mb.pic.fdec_buf + 36 * 32;
    }
    else {
        h->mb.pic.p_fenc[2] = h->mb.pic.fenc_buf + 16 * 16 + 8;
        h->mb.pic.p_fdec[2] = h->mb.pic.fdec_buf + 19 * 32 + 16;
    }
}

void x264_prefetch_fenc (x264_t *h, x264_frame_t *fenc, int i_mb_x, int i_mb_y) {
    int stride_y = fenc->i_stride[0];
    int stride_uv = fenc->i_stride[1];
    int off_y = 16 * i_mb_x + 16 * i_mb_y * stride_y;
    int off_uv = 16 * i_mb_x + (16 * i_mb_y * stride_uv >> h->mb.chroma_v_shift);
    h->mc.prefetch_fenc (fenc->plane[0] + off_y, stride_y, fenc->plane[1] + off_uv, stride_uv, i_mb_x);
}

void x264_copy_column8 (pixel *dst, pixel *src) {
    for (int i = -4; i < 4; i++)
        dst[i * 32] = src[i * 32];
}

void x264_macroblock_load_pic_pointers (x264_t *h, int mb_x, int mb_y, int i, int b_chroma, int b_mbaff) {
    int mb_interlaced = b_mbaff && 0;
    int height = b_chroma ? 16 >> h->mb.chroma_v_shift : 16;
    int i_stride = h->fdec->i_stride[i];
    int i_stride2 = i_stride << mb_interlaced;
    int i_pix_offset = mb_interlaced ? 16 * mb_x + height * (mb_y & ~1) * i_stride + (mb_y & 1) * i_stride : 16 * mb_x + height * mb_y * i_stride;
    pixel *plane_fdec = &h->fdec->plane[i][i_pix_offset];
    int fdec_idx = b_mbaff ? (mb_interlaced ? (3 + (mb_y & 1)) : (mb_y & 1) ? 2 : 4) : !(mb_y & 1);
    pixel *intra_fdec = &h->intra_border_backup[fdec_idx][i][mb_x * 16];
    int ref_pix_offset [2] = {i_pix_offset, i_pix_offset};
    if (mb_interlaced)
        ref_pix_offset[1] += (1 - 2 * (mb_y & 1)) * i_stride;
    h->mb.pic.i_stride[i] = i_stride2;
    h->mb.pic.p_fenc_plane[i] = &h->fenc->plane[i][i_pix_offset];
    if (b_chroma) {
        h->mc.load_deinterleave_chroma_fenc (h->mb.pic.p_fenc[1], h->mb.pic.p_fenc_plane[1], i_stride2, height);
        memcpy (h -> mb.pic.p_fdec [1] - 32, intra_fdec, 8 * sizeof (pixel));
        memcpy (h -> mb.pic.p_fdec [2] - 32, intra_fdec + 8, 8 * sizeof (pixel));
        h->mb.pic.p_fdec[1][-32 - 1] = intra_fdec[-1 - 8];
        h->mb.pic.p_fdec[2][-32 - 1] = intra_fdec[-1];
    }
    else {
        h->mc.copy[PIXEL_16x16] (h->mb.pic.p_fenc[i], 16, h->mb.pic.p_fenc_plane[i], i_stride2, 16);
        memcpy (h -> mb.pic.p_fdec [i] - 32, intra_fdec, 24 * sizeof (pixel));
        h->mb.pic.p_fdec[i][-32 - 1] = intra_fdec[-1];
    }
    if (b_mbaff || h->mb.b_reencode_mb) {
        for (int j = 0; j < height; j++)
            if (b_chroma) {
                h->mb.pic.p_fdec[1][-1 + j * 32] = plane_fdec[-2 + j * i_stride2];
                h->mb.pic.p_fdec[2][-1 + j * 32] = plane_fdec[-1 + j * i_stride2];
            }
            else
                h->mb.pic.p_fdec[i][-1 + j * 32] = plane_fdec[-1 + j * i_stride2];
    }
    pixel *plane_src, **filtered_src;
    for (int j = 0; j < h->mb.pic.i_fref[0]; j++) {
        if (mb_interlaced) {
            plane_src = h->fref[0][j >> 1]->plane_fld[i];
            filtered_src = h->fref[0][j >> 1]->filtered_fld[i];
        }
        else {
            plane_src = h->fref[0][j]->plane[i];
            filtered_src = h->fref[0][j]->filtered[i];
        }
        h->mb.pic.p_fref[0][j][i * 4] = plane_src + ref_pix_offset[j & 1];
        if (!b_chroma) {
            for (int k = 1; k < 4; k++)
                h->mb.pic.p_fref[0][j][i * 4 + k] = filtered_src[k] + ref_pix_offset[j & 1];
            if (!i) {
                if (h->sh.weight[j][0].weightfn)
                    h->mb.pic.p_fref_w[j] = &h->fenc->weighted[j >> mb_interlaced][ref_pix_offset[j & 1]];
                else
                    h->mb.pic.p_fref_w[j] = h->mb.pic.p_fref[0][j][0];
            }
        }
    }
    if (h->sh.i_type == SLICE_TYPE_B)
        for (int j = 0; j < h->mb.pic.i_fref[1]; j++) {
            if (mb_interlaced) {
                plane_src = h->fref[1][j >> 1]->plane_fld[i];
                filtered_src = h->fref[1][j >> 1]->filtered_fld[i];
            }
            else {
                plane_src = h->fref[1][j]->plane[i];
                filtered_src = h->fref[1][j]->filtered[i];
            }
            h->mb.pic.p_fref[1][j][i * 4] = plane_src + ref_pix_offset[j & 1];
            if (!b_chroma)
                for (int k = 1; k < 4; k++)
                    h->mb.pic.p_fref[1][j][i * 4 + k] = filtered_src[k] + ref_pix_offset[j & 1];
        }
}

const x264_left_table_t left_indices [4] = {{{4, 4, 5, 5}, {3, 3, 7, 7}, {16 + 1, 16 + 1, 32 + 1, 32 + 1}, {0, 0, 1, 1}, {0, 0, 0, 0}}, {{6, 6, 3, 3}, {11, 11, 15, 15}, {16 + 5, 16 + 5, 32 + 5, 32 + 5}, {2, 2, 3, 3}, {1, 1, 1, 1}}, {{4, 6, 4, 6}, {3, 11, 3, 11}, {16 + 1, 16 + 1, 32 + 1, 32 + 1}, {0, 2, 0, 2}, {0, 1, 0, 1}}, {{4, 5, 6, 3}, {3, 7, 11, 15}, {16 + 1, 16 + 5, 32 + 1, 32 + 5}, {0, 1, 2, 3}, {0, 0, 1, 1}}};

void x264_macroblock_cache_load_neighbours (x264_t *h, int mb_x, int mb_y, int b_interlaced) {
    const int mb_interlaced = b_interlaced && 0;
    int top_y = mb_y - (1 << mb_interlaced);
    int top = top_y * h->mb.i_mb_stride + mb_x;
    h->mb.i_mb_x = mb_x;
    h->mb.i_mb_y = mb_y;
    h->mb.i_mb_xy = mb_y * h->mb.i_mb_stride + mb_x;
    h->mb.i_b8_xy = 2 * (mb_y * h->mb.i_b8_stride + mb_x);
    h->mb.i_b4_xy = 4 * (mb_y * h->mb.i_b4_stride + mb_x);
    h->mb.left_b8[0] = h->mb.left_b8[1] = -1;
    h->mb.left_b4[0] = h->mb.left_b4[1] = -1;
    h->mb.i_neighbour = 0;
    h->mb.i_neighbour_intra = 0;
    h->mb.i_neighbour_frame = 0;
    h->mb.i_mb_top_xy = -1;
    h->mb.i_mb_top_y = -1;
    h->mb.i_mb_left_xy[0] = h->mb.i_mb_left_xy[1] = -1;
    h->mb.i_mb_topleft_xy = -1;
    h->mb.i_mb_topright_xy = -1;
    h->mb.i_mb_type_top = -1;
    h->mb.i_mb_type_left[0] = h->mb.i_mb_type_left[1] = -1;
    h->mb.i_mb_type_topleft = -1;
    h->mb.i_mb_type_topright = -1;
    h->mb.left_index_table = &left_indices[3];
    h->mb.topleft_partition = 0;
    int topleft_y = top_y;
    int topright_y = top_y;
    int left [2];
    left[0] = left[1] = h->mb.i_mb_xy - 1;
    h->mb.left_b8[0] = h->mb.left_b8[1] = h->mb.i_b8_xy - 2;
    h->mb.left_b4[0] = h->mb.left_b4[1] = h->mb.i_b4_xy - 4;
    if (b_interlaced) {
        h->mb.i_mb_top_mbpair_xy = h->mb.i_mb_xy - 2 * h->mb.i_mb_stride;
        h->mb.i_mb_topleft_y = -1;
        h->mb.i_mb_topright_y = -1;
        if (mb_y & 1) {
            if (mb_x && mb_interlaced != h->mb.field[h->mb.i_mb_xy - 1]) {
                left[0] = left[1] = h->mb.i_mb_xy - 1 - h->mb.i_mb_stride;
                h->mb.left_b8[0] = h->mb.left_b8[1] = h->mb.i_b8_xy - 2 - 2 * h->mb.i_b8_stride;
                h->mb.left_b4[0] = h->mb.left_b4[1] = h->mb.i_b4_xy - 4 - 4 * h->mb.i_b4_stride;
                if (mb_interlaced) {
                    h->mb.left_index_table = &left_indices[2];
                    left[1] += h->mb.i_mb_stride;
                    h->mb.left_b8[1] += 2 * h->mb.i_b8_stride;
                    h->mb.left_b4[1] += 4 * h->mb.i_b4_stride;
                }
                else {
                    h->mb.left_index_table = &left_indices[1];
                    topleft_y++;
                    h->mb.topleft_partition = 1;
                }
            }
            if (!mb_interlaced)
                topright_y = -1;
        }
        else {
            if (mb_interlaced && top >= 0) {
                if (!h->mb.field[top]) {
                    top += h->mb.i_mb_stride;
                    top_y++;
                }
                if (mb_x)
                    topleft_y += !h->mb.field[h->mb.i_mb_stride * topleft_y + mb_x - 1];
                if (mb_x < h->mb.i_mb_width - 1)
                    topright_y += !h->mb.field[h->mb.i_mb_stride * topright_y + mb_x + 1];
            }
            if (mb_x && mb_interlaced != h->mb.field[h->mb.i_mb_xy - 1]) {
                if (mb_interlaced) {
                    h->mb.left_index_table = &left_indices[2];
                    left[1] += h->mb.i_mb_stride;
                    h->mb.left_b8[1] += 2 * h->mb.i_b8_stride;
                    h->mb.left_b4[1] += 4 * h->mb.i_b4_stride;
                }
                else
                    h->mb.left_index_table = &left_indices[0];
            }
        }
    }
    if (mb_x > 0) {
        h->mb.i_neighbour_frame |= MB_LEFT;
        h->mb.i_mb_left_xy[0] = left[0];
        h->mb.i_mb_left_xy[1] = left[1];
        h->mb.i_mb_type_left[0] = h->mb.type[h->mb.i_mb_left_xy[0]];
        h->mb.i_mb_type_left[1] = h->mb.type[h->mb.i_mb_left_xy[1]];
        if (h->mb.slice_table[left[0]] == h->sh.i_first_mb) {
            h->mb.i_neighbour |= MB_LEFT;
            if (!h->param.b_constrained_intra || ((h->mb.i_mb_type_left[0]) == I_4x4 || (h->mb.i_mb_type_left[0]) == I_8x8 || (h->mb.i_mb_type_left[0]) == I_16x16 || (h->mb.i_mb_type_left[0]) == I_PCM))
                h->mb.i_neighbour_intra |= MB_LEFT;
        }
    }
    if ((h->i_threadslice_start >> mb_interlaced) != (mb_y >> mb_interlaced)) {
        if (top >= 0) {
            h->mb.i_neighbour_frame |= MB_TOP;
            h->mb.i_mb_top_xy = top;
            h->mb.i_mb_top_y = top_y;
            h->mb.i_mb_type_top = h->mb.type[h->mb.i_mb_top_xy];
            if (h->mb.slice_table[top] == h->sh.i_first_mb) {
                h->mb.i_neighbour |= MB_TOP;
                if (!h->param.b_constrained_intra || ((h->mb.i_mb_type_top) == I_4x4 || (h->mb.i_mb_type_top) == I_8x8 || (h->mb.i_mb_type_top) == I_16x16 || (h->mb.i_mb_type_top) == I_PCM))
                    h->mb.i_neighbour_intra |= MB_TOP;
                __builtin_prefetch (& h -> mb.cbp [top]);
                __builtin_prefetch (h -> mb.intra4x4_pred_mode [top]);
                __builtin_prefetch (& h -> mb.non_zero_count [top] [12]);
                __builtin_prefetch (& h -> mb.mb_transform_size [top]);
                __builtin_prefetch (& h -> mb.skipbp [top]);
            }
        }
        if (mb_x > 0 && topleft_y >= 0) {
            h->mb.i_neighbour_frame |= MB_TOPLEFT;
            h->mb.i_mb_topleft_xy = h->mb.i_mb_stride * topleft_y + mb_x - 1;
            h->mb.i_mb_topleft_y = topleft_y;
            h->mb.i_mb_type_topleft = h->mb.type[h->mb.i_mb_topleft_xy];
            if (h->mb.slice_table[h->mb.i_mb_topleft_xy] == h->sh.i_first_mb) {
                h->mb.i_neighbour |= MB_TOPLEFT;
                if (!h->param.b_constrained_intra || ((h->mb.i_mb_type_topleft) == I_4x4 || (h->mb.i_mb_type_topleft) == I_8x8 || (h->mb.i_mb_type_topleft) == I_16x16 || (h->mb.i_mb_type_topleft) == I_PCM))
                    h->mb.i_neighbour_intra |= MB_TOPLEFT;
            }
        }
        if (mb_x < h->mb.i_mb_width - 1 && topright_y >= 0) {
            h->mb.i_neighbour_frame |= MB_TOPRIGHT;
            h->mb.i_mb_topright_xy = h->mb.i_mb_stride * topright_y + mb_x + 1;
            h->mb.i_mb_topright_y = topright_y;
            h->mb.i_mb_type_topright = h->mb.type[h->mb.i_mb_topright_xy];
            if (h->mb.slice_table[h->mb.i_mb_topright_xy] == h->sh.i_first_mb) {
                h->mb.i_neighbour |= MB_TOPRIGHT;
                if (!h->param.b_constrained_intra || ((h->mb.i_mb_type_topright) == I_4x4 || (h->mb.i_mb_type_topright) == I_8x8 || (h->mb.i_mb_type_topright) == I_16x16 || (h->mb.i_mb_type_topright) == I_PCM))
                    h->mb.i_neighbour_intra |= MB_TOPRIGHT;
            }
        }
    }
}

void x264_macroblock_cache_load (x264_t *h, int mb_x, int mb_y, int b_mbaff) {
    x264_macroblock_cache_load_neighbours (h, mb_x, mb_y, b_mbaff);
    int *left = h->mb.i_mb_left_xy;
    int top = h->mb.i_mb_top_xy;
    int top_y = h->mb.i_mb_top_y;
    int s8x8 = h->mb.i_b8_stride;
    int s4x4 = h->mb.i_b4_stride;
    int top_8x8 = (2 * top_y + 1) * s8x8 + 2 * mb_x;
    int top_4x4 = (4 * top_y + 3) * s4x4 + 4 * mb_x;
    int lists = (1 << h->sh.i_type) & 3;
    int8_t (*i4x4) [8] = h->mb.intra4x4_pred_mode;
    uint8_t (*nnz) [48] = h->mb.non_zero_count;
    int16_t *cbp = h->mb.cbp;
    const x264_left_table_t *left_index_table = h->mb.left_index_table;
    h->mb.cache.deblock_strength = h->deblock_strength[mb_y & 1][h->param.b_sliced_threads ? h->mb.i_mb_xy : mb_x];
    if (h->mb.i_neighbour & MB_TOP) {
        h->mb.cache.i_cbp_top = cbp[top];
        (((x264_union32_t *) (&h->mb.cache.intra4x4_pred_mode[x264_scan8[0] - 8]))->i) = (((x264_union32_t *) (&i4x4[top][0]))->i);
        (((x264_union32_t *) (&h->mb.cache.non_zero_count[x264_scan8[0] - 8]))->i) = (((x264_union32_t *) (&nnz[top][12]))->i);
        (((x264_union32_t *) (&h->mb.cache.non_zero_count[x264_scan8[16] - 8]))->i) = (((x264_union32_t *) (&nnz[top][16 - 4 + (16 >> h->mb.chroma_v_shift)]))->i);
        (((x264_union32_t *) (&h->mb.cache.non_zero_count[x264_scan8[32] - 8]))->i) = (((x264_union32_t *) (&nnz[top][32 - 4 + (16 >> h->mb.chroma_v_shift)]))->i);
        for (int l = 0; l < lists; l++) {
            __builtin_prefetch (& h -> mb.mv [l] [top_4x4 - 1]);
            __builtin_prefetch (& h -> mb.mv [l] [top_4x4 + 4]);
            __builtin_prefetch (& h -> mb.ref [l] [top_8x8 - 1]);
            __builtin_prefetch (& h -> mb.mvd [l] [top]);
        }
    }
    else {
        h->mb.cache.i_cbp_top = -1;
        (((x264_union32_t *) (&h->mb.cache.intra4x4_pred_mode[x264_scan8[0] - 8]))->i) = 0xFFFFFFFFU;
        (((x264_union32_t *) (&h->mb.cache.non_zero_count[x264_scan8[0] - 8]))->i) = 0x80808080U;
        (((x264_union32_t *) (&h->mb.cache.non_zero_count[x264_scan8[16] - 8]))->i) = 0x80808080U;
        (((x264_union32_t *) (&h->mb.cache.non_zero_count[x264_scan8[32] - 8]))->i) = 0x80808080U;
    }
    if (h->mb.i_neighbour & MB_LEFT) {
        int ltop = left[0];
        int lbot = b_mbaff ? left[0] : ltop;
        if (b_mbaff) {
            const int16_t top_luma = (cbp[ltop] >> (left_index_table->mv[0] & (~1))) & 2;
            const int16_t bot_luma = (cbp[lbot] >> (left_index_table->mv[2] & (~1))) & 2;
            h->mb.cache.i_cbp_left = (cbp[ltop] & 0xfff0) | (bot_luma << 2) | top_luma;
        }
        else
            h->mb.cache.i_cbp_left = cbp[ltop];
        h->mb.cache.intra4x4_pred_mode[x264_scan8[0] - 1] = i4x4[ltop][left_index_table->intra[0]];
        h->mb.cache.intra4x4_pred_mode[x264_scan8[2] - 1] = i4x4[ltop][left_index_table->intra[1]];
        h->mb.cache.intra4x4_pred_mode[x264_scan8[8] - 1] = i4x4[lbot][left_index_table->intra[2]];
        h->mb.cache.intra4x4_pred_mode[x264_scan8[10] - 1] = i4x4[lbot][left_index_table->intra[3]];
        h->mb.cache.non_zero_count[x264_scan8[0] - 1] = nnz[ltop][left_index_table->nnz[0]];
        h->mb.cache.non_zero_count[x264_scan8[2] - 1] = nnz[ltop][left_index_table->nnz[1]];
        h->mb.cache.non_zero_count[x264_scan8[8] - 1] = nnz[lbot][left_index_table->nnz[2]];
        h->mb.cache.non_zero_count[x264_scan8[10] - 1] = nnz[lbot][left_index_table->nnz[3]];
        if (h->sps->i_chroma_format_idc >= CHROMA_422) {
            int offset = (4 >> h->mb.chroma_h_shift) - 4;
            h->mb.cache.non_zero_count[x264_scan8[16 + 0] - 1] = nnz[ltop][left_index_table->nnz[0] + 16 + offset];
            h->mb.cache.non_zero_count[x264_scan8[16 + 2] - 1] = nnz[ltop][left_index_table->nnz[1] + 16 + offset];
            h->mb.cache.non_zero_count[x264_scan8[16 + 8] - 1] = nnz[lbot][left_index_table->nnz[2] + 16 + offset];
            h->mb.cache.non_zero_count[x264_scan8[16 + 10] - 1] = nnz[lbot][left_index_table->nnz[3] + 16 + offset];
            h->mb.cache.non_zero_count[x264_scan8[32 + 0] - 1] = nnz[ltop][left_index_table->nnz[0] + 32 + offset];
            h->mb.cache.non_zero_count[x264_scan8[32 + 2] - 1] = nnz[ltop][left_index_table->nnz[1] + 32 + offset];
            h->mb.cache.non_zero_count[x264_scan8[32 + 8] - 1] = nnz[lbot][left_index_table->nnz[2] + 32 + offset];
            h->mb.cache.non_zero_count[x264_scan8[32 + 10] - 1] = nnz[lbot][left_index_table->nnz[3] + 32 + offset];
        }
        else {
            h->mb.cache.non_zero_count[x264_scan8[16 + 0] - 1] = nnz[ltop][left_index_table->nnz_chroma[0]];
            h->mb.cache.non_zero_count[x264_scan8[16 + 2] - 1] = nnz[lbot][left_index_table->nnz_chroma[1]];
            h->mb.cache.non_zero_count[x264_scan8[32 + 0] - 1] = nnz[ltop][left_index_table->nnz_chroma[2]];
            h->mb.cache.non_zero_count[x264_scan8[32 + 2] - 1] = nnz[lbot][left_index_table->nnz_chroma[3]];
        }
    }
    else {
        h->mb.cache.i_cbp_left = -1;
        h->mb.cache.intra4x4_pred_mode[x264_scan8[0] - 1] = h->mb.cache.intra4x4_pred_mode[x264_scan8[2] - 1] = h->mb.cache.intra4x4_pred_mode[x264_scan8[8] - 1] = h->mb.cache.intra4x4_pred_mode[x264_scan8[10] - 1] = -1;
        h->mb.cache.non_zero_count[x264_scan8[0] - 1] = h->mb.cache.non_zero_count[x264_scan8[2] - 1] = h->mb.cache.non_zero_count[x264_scan8[8] - 1] = h->mb.cache.non_zero_count[x264_scan8[10] - 1] = h->mb.cache.non_zero_count[x264_scan8[16 + 0] - 1] = h->mb.cache.non_zero_count[x264_scan8[16 + 2] - 1] = h->mb.cache.non_zero_count[x264_scan8[32 + 0] - 1] = h->mb.cache.non_zero_count[x264_scan8[32 + 2] - 1] = 0x80;
        if (h->sps->i_chroma_format_idc >= CHROMA_422) {
            h->mb.cache.non_zero_count[x264_scan8[16 + 8] - 1] = h->mb.cache.non_zero_count[x264_scan8[16 + 10] - 1] = h->mb.cache.non_zero_count[x264_scan8[32 + 8] - 1] = h->mb.cache.non_zero_count[x264_scan8[32 + 10] - 1] = 0x80;
        }
    }
    if (h->pps->b_transform_8x8_mode) {
        h->mb.cache.i_neighbour_transform_size = ((h->mb.i_neighbour & MB_LEFT) && h->mb.mb_transform_size[left[0]]) + ((h->mb.i_neighbour & MB_TOP) && h->mb.mb_transform_size[top]);
    }
    if (b_mbaff) {
        h->mb.pic.i_fref[0] = h->i_ref[0] << 0;
        h->mb.pic.i_fref[1] = h->i_ref[1] << 0;
    }
    if (!b_mbaff) {
        x264_copy_column8 (h -> mb.pic.p_fdec [0] - 1 + 4 * 32, h -> mb.pic.p_fdec [0] + 15 + 4 * 32);
        x264_copy_column8 (h -> mb.pic.p_fdec [0] - 1 + 12 * 32, h -> mb.pic.p_fdec [0] + 15 + 12 * 32);
        x264_macroblock_load_pic_pointers (h, mb_x, mb_y, 0, 0, 0);
        if ((h->sps->i_chroma_format_idc == CHROMA_444)) {
            x264_copy_column8 (h -> mb.pic.p_fdec [1] - 1 + 4 * 32, h -> mb.pic.p_fdec [1] + 15 + 4 * 32);
            x264_copy_column8 (h -> mb.pic.p_fdec [1] - 1 + 12 * 32, h -> mb.pic.p_fdec [1] + 15 + 12 * 32);
            x264_copy_column8 (h -> mb.pic.p_fdec [2] - 1 + 4 * 32, h -> mb.pic.p_fdec [2] + 15 + 4 * 32);
            x264_copy_column8 (h -> mb.pic.p_fdec [2] - 1 + 12 * 32, h -> mb.pic.p_fdec [2] + 15 + 12 * 32);
            x264_macroblock_load_pic_pointers (h, mb_x, mb_y, 1, 0, 0);
            x264_macroblock_load_pic_pointers (h, mb_x, mb_y, 2, 0, 0);
        }
        else {
            x264_copy_column8 (h -> mb.pic.p_fdec [1] - 1 + 4 * 32, h -> mb.pic.p_fdec [1] + 7 + 4 * 32);
            x264_copy_column8 (h -> mb.pic.p_fdec [2] - 1 + 4 * 32, h -> mb.pic.p_fdec [2] + 7 + 4 * 32);
            if (h->sps->i_chroma_format_idc == CHROMA_422) {
                x264_copy_column8 (h -> mb.pic.p_fdec [1] - 1 + 12 * 32, h -> mb.pic.p_fdec [1] + 7 + 12 * 32);
                x264_copy_column8 (h -> mb.pic.p_fdec [2] - 1 + 12 * 32, h -> mb.pic.p_fdec [2] + 7 + 12 * 32);
            }
            x264_macroblock_load_pic_pointers (h, mb_x, mb_y, 1, 1, 0);
        }
    }
    else {
        x264_macroblock_load_pic_pointers (h, mb_x, mb_y, 0, 0, 1);
        if ((h->sps->i_chroma_format_idc == CHROMA_444)) {
            x264_macroblock_load_pic_pointers (h, mb_x, mb_y, 1, 0, 1);
            x264_macroblock_load_pic_pointers (h, mb_x, mb_y, 2, 0, 1);
        }
        else
            x264_macroblock_load_pic_pointers (h, mb_x, mb_y, 1, 1, 1);
    }
    if (h->fdec->integral) {
        int offset = 16 * (mb_x + mb_y * h->fdec->i_stride[0]);
        for (int list = 0; list < 2; list++)
            for (int i = 0; i < h->mb.pic.i_fref[list]; i++)
                h->mb.pic.p_integral[list][i] = &h->fref[list][i]->integral[offset];
    }
    x264_prefetch_fenc (h, h -> fenc, mb_x, mb_y);
    for (int l = 0; l < lists; l++) {
        int16_t (*mv) [2] = h->mb.mv[l];
        int8_t *ref = h->mb.ref[l];
        int i8 = x264_scan8[0] - 1 - 1 * 8;
        if (h->mb.i_neighbour & MB_TOPLEFT) {
            int ir = b_mbaff ? 2 * (s8x8 * h->mb.i_mb_topleft_y + mb_x - 1) + 1 + s8x8 : top_8x8 - 1;
            int iv = b_mbaff ? 4 * (s4x4 * h->mb.i_mb_topleft_y + mb_x - 1) + 3 + 3 * s4x4 : top_4x4 - 1;
            if (b_mbaff && h->mb.topleft_partition) {
                iv -= 2 * s4x4;
                ir -= s8x8;
            }
            h->mb.cache.ref[l][i8] = ref[ir];
            (((x264_union32_t *) (h->mb.cache.mv[l][i8]))->i) = (((x264_union32_t *) (mv[iv]))->i);
        }
        else {
            h->mb.cache.ref[l][i8] = -2;
            (((x264_union32_t *) (h->mb.cache.mv[l][i8]))->i) = 0;
        }
        i8 = x264_scan8[0] - 8;
        if (h->mb.i_neighbour & MB_TOP) {
            h->mb.cache.ref[l][i8 + 0] = h->mb.cache.ref[l][i8 + 1] = ref[top_8x8 + 0];
            h->mb.cache.ref[l][i8 + 2] = h->mb.cache.ref[l][i8 + 3] = ref[top_8x8 + 1];
            (((x264_union128_sse_t *) (h->mb.cache.mv[l][i8]))->i) = (((x264_union128_sse_t *) (mv[top_4x4]))->i);
        }
        else {
            (((x264_union128_sse_t *) (h->mb.cache.mv[l][i8]))->i) = ((__m128) {0, 0, 0, 0});
            (((x264_union32_t *) (&h->mb.cache.ref[l][i8]))->i) = (uint8_t) (-2) * 0x01010101U;
        }
        i8 = x264_scan8[0] + 4 - 1 * 8;
        if (h->mb.i_neighbour & MB_TOPRIGHT) {
            int ir = b_mbaff ? 2 * (s8x8 * h->mb.i_mb_topright_y + (mb_x + 1)) + s8x8 : top_8x8 + 2;
            int iv = b_mbaff ? 4 * (s4x4 * h->mb.i_mb_topright_y + (mb_x + 1)) + 3 * s4x4 : top_4x4 + 4;
            h->mb.cache.ref[l][i8] = ref[ir];
            (((x264_union32_t *) (h->mb.cache.mv[l][i8]))->i) = (((x264_union32_t *) (mv[iv]))->i);
        }
        else
            h->mb.cache.ref[l][i8] = -2;
        i8 = x264_scan8[0] - 1;
        if (h->mb.i_neighbour & MB_LEFT) {
            if (b_mbaff) {
                h->mb.cache.ref[l][i8 + 0 * 8] = ref[h->mb.left_b8[0] + 1 + s8x8 * left_index_table->ref[0]];
                h->mb.cache.ref[l][i8 + 1 * 8] = ref[h->mb.left_b8[0] + 1 + s8x8 * left_index_table->ref[1]];
                h->mb.cache.ref[l][i8 + 2 * 8] = ref[h->mb.left_b8[0] + 1 + s8x8 * left_index_table->ref[2]];
                h->mb.cache.ref[l][i8 + 3 * 8] = ref[h->mb.left_b8[0] + 1 + s8x8 * left_index_table->ref[3]];
                (((x264_union32_t *) (h->mb.cache.mv[l][i8 + 0 * 8]))->i) = (((x264_union32_t *) (mv[h->mb.left_b4[0] + 3 + s4x4 * left_index_table->mv[0]]))->i);
                (((x264_union32_t *) (h->mb.cache.mv[l][i8 + 1 * 8]))->i) = (((x264_union32_t *) (mv[h->mb.left_b4[0] + 3 + s4x4 * left_index_table->mv[1]]))->i);
                (((x264_union32_t *) (h->mb.cache.mv[l][i8 + 2 * 8]))->i) = (((x264_union32_t *) (mv[h->mb.left_b4[0] + 3 + s4x4 * left_index_table->mv[2]]))->i);
                (((x264_union32_t *) (h->mb.cache.mv[l][i8 + 3 * 8]))->i) = (((x264_union32_t *) (mv[h->mb.left_b4[0] + 3 + s4x4 * left_index_table->mv[3]]))->i);
            }
            else {
                const int ir = h->mb.i_b8_xy - 1;
                const int iv = h->mb.i_b4_xy - 1;
                h->mb.cache.ref[l][i8 + 0 * 8] = h->mb.cache.ref[l][i8 + 1 * 8] = ref[ir + 0 * s8x8];
                h->mb.cache.ref[l][i8 + 2 * 8] = h->mb.cache.ref[l][i8 + 3 * 8] = ref[ir + 1 * s8x8];
                (((x264_union32_t *) (h->mb.cache.mv[l][i8 + 0 * 8]))->i) = (((x264_union32_t *) (mv[iv + 0 * s4x4]))->i);
                (((x264_union32_t *) (h->mb.cache.mv[l][i8 + 1 * 8]))->i) = (((x264_union32_t *) (mv[iv + 1 * s4x4]))->i);
                (((x264_union32_t *) (h->mb.cache.mv[l][i8 + 2 * 8]))->i) = (((x264_union32_t *) (mv[iv + 2 * s4x4]))->i);
                (((x264_union32_t *) (h->mb.cache.mv[l][i8 + 3 * 8]))->i) = (((x264_union32_t *) (mv[iv + 3 * s4x4]))->i);
            }
        }
        else {
            for (int i = 0; i < 4; i++) {
                h->mb.cache.ref[l][i8 + i * 8] = -2;
                (((x264_union32_t *) (h->mb.cache.mv[l][i8 + i * 8]))->i) = 0;
            }
        }
        if (b_mbaff && (h->mb.i_neighbour & MB_LEFT)) {
            if (0 && !h->mb.field[h->mb.i_mb_xy - 1]) {
                h->mb.cache.topright_ref[l][0] = ref[h->mb.left_b8[0] + 1 + s8x8 * 0];
                h->mb.cache.topright_ref[l][1] = ref[h->mb.left_b8[0] + 1 + s8x8 * 1];
                h->mb.cache.topright_ref[l][2] = ref[h->mb.left_b8[1] + 1 + s8x8 * 0];
                (((x264_union32_t *) (h->mb.cache.topright_mv[l][0]))->i) = (((x264_union32_t *) (mv[h->mb.left_b4[0] + 3 + s4x4 * (left_index_table->mv[0] + 1)]))->i);
                (((x264_union32_t *) (h->mb.cache.topright_mv[l][1]))->i) = (((x264_union32_t *) (mv[h->mb.left_b4[0] + 3 + s4x4 * (left_index_table->mv[1] + 1)]))->i);
                (((x264_union32_t *) (h->mb.cache.topright_mv[l][2]))->i) = (((x264_union32_t *) (mv[h->mb.left_b4[1] + 3 + s4x4 * (left_index_table->mv[2] + 1)]))->i);
            }
            else if (!0 && h->mb.field[h->mb.i_mb_xy - 1]) {
                h->mb.cache.topright_ref[l][0] = ref[h->mb.left_b8[0] + 1 + s8x8 * 2 + s8x8 * left_index_table->ref[0]];
                h->mb.cache.topright_ref[l][1] = ref[h->mb.left_b8[0] + 1 + s8x8 * 2 + s8x8 * left_index_table->ref[0]];
                h->mb.cache.topright_ref[l][2] = ref[h->mb.left_b8[0] + 1 + s8x8 * 2 + s8x8 * left_index_table->ref[2]];
                (((x264_union32_t *) (h->mb.cache.topright_mv[l][0]))->i) = (((x264_union32_t *) (mv[h->mb.left_b4[0] + 3 + s4x4 * 4 + s4x4 * left_index_table->mv[0]]))->i);
                (((x264_union32_t *) (h->mb.cache.topright_mv[l][1]))->i) = (((x264_union32_t *) (mv[h->mb.left_b4[0] + 3 + s4x4 * 4 + s4x4 * left_index_table->mv[1]]))->i);
                (((x264_union32_t *) (h->mb.cache.topright_mv[l][2]))->i) = (((x264_union32_t *) (mv[h->mb.left_b4[0] + 3 + s4x4 * 4 + s4x4 * left_index_table->mv[2]]))->i);
            }
        }
        if (h->param.b_cabac) {
            uint8_t (*mvd) [8] [2] = h->mb.mvd[l];
            if (h->mb.i_neighbour & MB_TOP)
                (((x264_union64_t *) (h->mb.cache.mvd[l][x264_scan8[0] - 8]))->i) = (((x264_union64_t *) (mvd[top][0]))->i);
            else
                (((x264_union64_t *) (h->mb.cache.mvd[l][x264_scan8[0] - 8]))->i) = 0;
            if (h->mb.i_neighbour & MB_LEFT && (!b_mbaff || h->mb.cache.ref[l][x264_scan8[0] - 1] >= 0)) {
                (((x264_union16_t *) (h->mb.cache.mvd[l][x264_scan8[0] - 1]))->i) = (((x264_union16_t *) (mvd[left[0]][left_index_table->intra[0]]))->i);
                (((x264_union16_t *) (h->mb.cache.mvd[l][x264_scan8[2] - 1]))->i) = (((x264_union16_t *) (mvd[left[0]][left_index_table->intra[1]]))->i);
            }
            else {
                (((x264_union16_t *) (h->mb.cache.mvd[l][x264_scan8[0] - 1 + 0 * 8]))->i) = 0;
                (((x264_union16_t *) (h->mb.cache.mvd[l][x264_scan8[0] - 1 + 1 * 8]))->i) = 0;
            }
            if (h->mb.i_neighbour & MB_LEFT && (!b_mbaff || h->mb.cache.ref[l][x264_scan8[0] - 1 + 2 * 8] >= 0)) {
                (((x264_union16_t *) (h->mb.cache.mvd[l][x264_scan8[8] - 1]))->i) = (((x264_union16_t *) (mvd[left[0]][left_index_table->intra[2]]))->i);
                (((x264_union16_t *) (h->mb.cache.mvd[l][x264_scan8[10] - 1]))->i) = (((x264_union16_t *) (mvd[left[0]][left_index_table->intra[3]]))->i);
            }
            else {
                (((x264_union16_t *) (h->mb.cache.mvd[l][x264_scan8[0] - 1 + 2 * 8]))->i) = 0;
                (((x264_union16_t *) (h->mb.cache.mvd[l][x264_scan8[0] - 1 + 3 * 8]))->i) = 0;
            }
        }
        if (b_mbaff) {
            if (0) {
                if ((h->mb.i_mb_topleft_xy >= 0 && !h->mb.field[h->mb.i_mb_topleft_xy]))
                    if (h->mb.cache.ref[l][x264_scan8[0] - 1 - 1 * 8] >= 0) {
                        h->mb.cache.ref[l][x264_scan8[0] - 1 - 1 * 8] <<= 1;
                        h->mb.cache.mv[l][x264_scan8[0] - 1 - 1 * 8][1] /= 2;
                        h->mb.cache.mvd[l][x264_scan8[0] - 1 - 1 * 8][1] >>= 1;
                    }
                if ((top >= 0 && !h->mb.field[top])) {
                    if (h->mb.cache.ref[l][x264_scan8[0] + 0 - 1 * 8] >= 0) {
                        h->mb.cache.ref[l][x264_scan8[0] + 0 - 1 * 8] <<= 1;
                        h->mb.cache.mv[l][x264_scan8[0] + 0 - 1 * 8][1] /= 2;
                        h->mb.cache.mvd[l][x264_scan8[0] + 0 - 1 * 8][1] >>= 1;
                    }
                    if (h->mb.cache.ref[l][x264_scan8[0] + 1 - 1 * 8] >= 0) {
                        h->mb.cache.ref[l][x264_scan8[0] + 1 - 1 * 8] <<= 1;
                        h->mb.cache.mv[l][x264_scan8[0] + 1 - 1 * 8][1] /= 2;
                        h->mb.cache.mvd[l][x264_scan8[0] + 1 - 1 * 8][1] >>= 1;
                    }
                    if (h->mb.cache.ref[l][x264_scan8[0] + 2 - 1 * 8] >= 0) {
                        h->mb.cache.ref[l][x264_scan8[0] + 2 - 1 * 8] <<= 1;
                        h->mb.cache.mv[l][x264_scan8[0] + 2 - 1 * 8][1] /= 2;
                        h->mb.cache.mvd[l][x264_scan8[0] + 2 - 1 * 8][1] >>= 1;
                    }
                    if (h->mb.cache.ref[l][x264_scan8[0] + 3 - 1 * 8] >= 0) {
                        h->mb.cache.ref[l][x264_scan8[0] + 3 - 1 * 8] <<= 1;
                        h->mb.cache.mv[l][x264_scan8[0] + 3 - 1 * 8][1] /= 2;
                        h->mb.cache.mvd[l][x264_scan8[0] + 3 - 1 * 8][1] >>= 1;
                    }
                }
                if ((h->mb.i_mb_topright_xy >= 0 && !h->mb.field[h->mb.i_mb_topright_xy]))
                    if (h->mb.cache.ref[l][x264_scan8[0] + 4 - 1 * 8] >= 0) {
                        h->mb.cache.ref[l][x264_scan8[0] + 4 - 1 * 8] <<= 1;
                        h->mb.cache.mv[l][x264_scan8[0] + 4 - 1 * 8][1] /= 2;
                        h->mb.cache.mvd[l][x264_scan8[0] + 4 - 1 * 8][1] >>= 1;
                    }
                if ((left[0] >= 0 && !h->mb.field[left[0]])) {
                    if (h->mb.cache.ref[l][x264_scan8[0] - 1 + 0 * 8] >= 0) {
                        h->mb.cache.ref[l][x264_scan8[0] - 1 + 0 * 8] <<= 1;
                        h->mb.cache.mv[l][x264_scan8[0] - 1 + 0 * 8][1] /= 2;
                        h->mb.cache.mvd[l][x264_scan8[0] - 1 + 0 * 8][1] >>= 1;
                    }
                    if (h->mb.cache.ref[l][x264_scan8[0] - 1 + 1 * 8] >= 0) {
                        h->mb.cache.ref[l][x264_scan8[0] - 1 + 1 * 8] <<= 1;
                        h->mb.cache.mv[l][x264_scan8[0] - 1 + 1 * 8][1] /= 2;
                        h->mb.cache.mvd[l][x264_scan8[0] - 1 + 1 * 8][1] >>= 1;
                    }
                    if (h->mb.cache.ref[l][x264_scan8[0] - 1 + 2 * 8] >= 0) {
                        h->mb.cache.ref[l][x264_scan8[0] - 1 + 2 * 8] <<= 1;
                        h->mb.cache.mv[l][x264_scan8[0] - 1 + 2 * 8][1] /= 2;
                        h->mb.cache.mvd[l][x264_scan8[0] - 1 + 2 * 8][1] >>= 1;
                    }
                    if (h->mb.cache.ref[l][x264_scan8[0] - 1 + 3 * 8] >= 0) {
                        h->mb.cache.ref[l][x264_scan8[0] - 1 + 3 * 8] <<= 1;
                        h->mb.cache.mv[l][x264_scan8[0] - 1 + 3 * 8][1] /= 2;
                        h->mb.cache.mvd[l][x264_scan8[0] - 1 + 3 * 8][1] >>= 1;
                    }
                    if (h->mb.cache.topright_ref[l][0] >= 0) {
                        h->mb.cache.topright_ref[l][0] <<= 1;
                        h->mb.cache.topright_mv[l][0][1] /= 2;
                        h->mb.cache.mvd[l][0][1] >>= 1;
                    }
                    if (h->mb.cache.topright_ref[l][1] >= 0) {
                        h->mb.cache.topright_ref[l][1] <<= 1;
                        h->mb.cache.topright_mv[l][1][1] /= 2;
                        h->mb.cache.mvd[l][1][1] >>= 1;
                    }
                    if (h->mb.cache.topright_ref[l][2] >= 0) {
                        h->mb.cache.topright_ref[l][2] <<= 1;
                        h->mb.cache.topright_mv[l][2][1] /= 2;
                        h->mb.cache.mvd[l][2][1] >>= 1;
                    }
                }
            }
            else {
                if ((h->mb.i_mb_topleft_xy >= 0 && h->mb.field[h->mb.i_mb_topleft_xy]))
                    if (h->mb.cache.ref[l][x264_scan8[0] - 1 - 1 * 8] >= 0) {
                        h->mb.cache.ref[l][x264_scan8[0] - 1 - 1 * 8] >>= 1;
                        h->mb.cache.mv[l][x264_scan8[0] - 1 - 1 * 8][1] <<= 1;
                        h->mb.cache.mvd[l][x264_scan8[0] - 1 - 1 * 8][1] <<= 1;
                    }
                if ((top >= 0 && h->mb.field[top])) {
                    if (h->mb.cache.ref[l][x264_scan8[0] + 0 - 1 * 8] >= 0) {
                        h->mb.cache.ref[l][x264_scan8[0] + 0 - 1 * 8] >>= 1;
                        h->mb.cache.mv[l][x264_scan8[0] + 0 - 1 * 8][1] <<= 1;
                        h->mb.cache.mvd[l][x264_scan8[0] + 0 - 1 * 8][1] <<= 1;
                    }
                    if (h->mb.cache.ref[l][x264_scan8[0] + 1 - 1 * 8] >= 0) {
                        h->mb.cache.ref[l][x264_scan8[0] + 1 - 1 * 8] >>= 1;
                        h->mb.cache.mv[l][x264_scan8[0] + 1 - 1 * 8][1] <<= 1;
                        h->mb.cache.mvd[l][x264_scan8[0] + 1 - 1 * 8][1] <<= 1;
                    }
                    if (h->mb.cache.ref[l][x264_scan8[0] + 2 - 1 * 8] >= 0) {
                        h->mb.cache.ref[l][x264_scan8[0] + 2 - 1 * 8] >>= 1;
                        h->mb.cache.mv[l][x264_scan8[0] + 2 - 1 * 8][1] <<= 1;
                        h->mb.cache.mvd[l][x264_scan8[0] + 2 - 1 * 8][1] <<= 1;
                    }
                    if (h->mb.cache.ref[l][x264_scan8[0] + 3 - 1 * 8] >= 0) {
                        h->mb.cache.ref[l][x264_scan8[0] + 3 - 1 * 8] >>= 1;
                        h->mb.cache.mv[l][x264_scan8[0] + 3 - 1 * 8][1] <<= 1;
                        h->mb.cache.mvd[l][x264_scan8[0] + 3 - 1 * 8][1] <<= 1;
                    }
                }
                if ((h->mb.i_mb_topright_xy >= 0 && h->mb.field[h->mb.i_mb_topright_xy]))
                    if (h->mb.cache.ref[l][x264_scan8[0] + 4 - 1 * 8] >= 0) {
                        h->mb.cache.ref[l][x264_scan8[0] + 4 - 1 * 8] >>= 1;
                        h->mb.cache.mv[l][x264_scan8[0] + 4 - 1 * 8][1] <<= 1;
                        h->mb.cache.mvd[l][x264_scan8[0] + 4 - 1 * 8][1] <<= 1;
                    }
                if ((left[0] >= 0 && h->mb.field[left[0]])) {
                    if (h->mb.cache.ref[l][x264_scan8[0] - 1 + 0 * 8] >= 0) {
                        h->mb.cache.ref[l][x264_scan8[0] - 1 + 0 * 8] >>= 1;
                        h->mb.cache.mv[l][x264_scan8[0] - 1 + 0 * 8][1] <<= 1;
                        h->mb.cache.mvd[l][x264_scan8[0] - 1 + 0 * 8][1] <<= 1;
                    }
                    if (h->mb.cache.ref[l][x264_scan8[0] - 1 + 1 * 8] >= 0) {
                        h->mb.cache.ref[l][x264_scan8[0] - 1 + 1 * 8] >>= 1;
                        h->mb.cache.mv[l][x264_scan8[0] - 1 + 1 * 8][1] <<= 1;
                        h->mb.cache.mvd[l][x264_scan8[0] - 1 + 1 * 8][1] <<= 1;
                    }
                    if (h->mb.cache.ref[l][x264_scan8[0] - 1 + 2 * 8] >= 0) {
                        h->mb.cache.ref[l][x264_scan8[0] - 1 + 2 * 8] >>= 1;
                        h->mb.cache.mv[l][x264_scan8[0] - 1 + 2 * 8][1] <<= 1;
                        h->mb.cache.mvd[l][x264_scan8[0] - 1 + 2 * 8][1] <<= 1;
                    }
                    if (h->mb.cache.ref[l][x264_scan8[0] - 1 + 3 * 8] >= 0) {
                        h->mb.cache.ref[l][x264_scan8[0] - 1 + 3 * 8] >>= 1;
                        h->mb.cache.mv[l][x264_scan8[0] - 1 + 3 * 8][1] <<= 1;
                        h->mb.cache.mvd[l][x264_scan8[0] - 1 + 3 * 8][1] <<= 1;
                    }
                    if (h->mb.cache.topright_ref[l][0] >= 0) {
                        h->mb.cache.topright_ref[l][0] >>= 1;
                        h->mb.cache.topright_mv[l][0][1] <<= 1;
                        h->mb.cache.mvd[l][0][1] <<= 1;
                    }
                    if (h->mb.cache.topright_ref[l][1] >= 0) {
                        h->mb.cache.topright_ref[l][1] >>= 1;
                        h->mb.cache.topright_mv[l][1][1] <<= 1;
                        h->mb.cache.mvd[l][1][1] <<= 1;
                    }
                    if (h->mb.cache.topright_ref[l][2] >= 0) {
                        h->mb.cache.topright_ref[l][2] >>= 1;
                        h->mb.cache.topright_mv[l][2][1] <<= 1;
                        h->mb.cache.mvd[l][2][1] <<= 1;
                    }
                }
            }
        }
    }
    if (b_mbaff && mb_x == 0 && !(mb_y & 1)) {
        if (h->mb.i_mb_top_xy >= h->sh.i_first_mb)
            h->mb.field_decoding_flag = h->mb.field[h->mb.i_mb_top_xy];
        else
            h->mb.field_decoding_flag = 0;
    }
    h->mb.b_allow_skip = 1;
    if (b_mbaff) {
        if (0 != h->mb.field_decoding_flag && (mb_y & 1) && ((h->mb.type[h->mb.i_mb_xy - h->mb.i_mb_stride]) == P_SKIP || (h->mb.type[h->mb.i_mb_xy - h->mb.i_mb_stride]) == B_SKIP))
            h->mb.b_allow_skip = 0;
    }
    if (h->param.b_cabac) {
        if (b_mbaff) {
            int left_xy, top_xy;
            int mb_xy = mb_x + (mb_y & ~1) * h->mb.i_mb_stride;
            left_xy = mb_xy - 1;
            if ((mb_y & 1) && mb_x > 0 && h->mb.field_decoding_flag == h->mb.field[left_xy])
                left_xy += h->mb.i_mb_stride;
            if (h->mb.field_decoding_flag) {
                top_xy = mb_xy - h->mb.i_mb_stride;
                if (!(mb_y & 1) && top_xy >= 0 && h->mb.slice_table[top_xy] == h->sh.i_first_mb && h->mb.field[top_xy])
                    top_xy -= h->mb.i_mb_stride;
            }
            else
                top_xy = mb_x + (mb_y - 1) * h->mb.i_mb_stride;
            h->mb.cache.i_neighbour_skip = (mb_x > 0 && h->mb.slice_table[left_xy] == h->sh.i_first_mb && !((h->mb.type[left_xy]) == P_SKIP || (h->mb.type[left_xy]) == B_SKIP)) + (top_xy >= 0 && h->mb.slice_table[top_xy] == h->sh.i_first_mb && !((h->mb.type[top_xy]) == P_SKIP || (h->mb.type[top_xy]) == B_SKIP));
        }
        else {
            h->mb.cache.i_neighbour_skip = ((h->mb.i_neighbour & MB_LEFT) && !((h->mb.i_mb_type_left[0]) == P_SKIP || (h->mb.i_mb_type_left[0]) == B_SKIP)) + ((h->mb.i_neighbour & MB_TOP) && !((h->mb.i_mb_type_top) == P_SKIP || (h->mb.i_mb_type_top) == B_SKIP));
        }
    }
    if (h->sh.i_type == SLICE_TYPE_B) {
        h->mb.bipred_weight = h->mb.bipred_weight_buf[0][0 & (mb_y & 1)];
        h->mb.dist_scale_factor = h->mb.dist_scale_factor_buf[0][0 & (mb_y & 1)];
        if (h->param.b_cabac) {
            uint8_t skipbp;
            x264_macroblock_cache_skip (h, 0, 0, 4, 4, 0);
            if (b_mbaff) {
                skipbp = (h->mb.i_neighbour & MB_LEFT) ? h->mb.skipbp[left[0]] : 0;
                h->mb.cache.skip[x264_scan8[0] - 1] = (skipbp >> (1 + (left_index_table->mv[0] & ~1))) & 1;
                skipbp = (h->mb.i_neighbour & MB_LEFT) ? h->mb.skipbp[left[0]] : 0;
                h->mb.cache.skip[x264_scan8[8] - 1] = (skipbp >> (1 + (left_index_table->mv[2] & ~1))) & 1;
            }
            else {
                skipbp = (h->mb.i_neighbour & MB_LEFT) ? h->mb.skipbp[left[0]] : 0;
                h->mb.cache.skip[x264_scan8[0] - 1] = skipbp & 0x2;
                h->mb.cache.skip[x264_scan8[8] - 1] = skipbp & 0x8;
            }
            skipbp = (h->mb.i_neighbour & MB_TOP) ? h->mb.skipbp[top] : 0;
            h->mb.cache.skip[x264_scan8[0] - 8] = skipbp & 0x4;
            h->mb.cache.skip[x264_scan8[4] - 8] = skipbp & 0x8;
        }
    }
    if (h->sh.i_type == SLICE_TYPE_P)
        x264_mb_predict_mv_pskip (h, h->mb.cache.pskip_mv);
    h->mb.i_neighbour4[0] = h->mb.i_neighbour8[0] = (h->mb.i_neighbour_intra & (MB_TOP | MB_LEFT | MB_TOPLEFT)) | ((h->mb.i_neighbour_intra & MB_TOP) ? MB_TOPRIGHT : 0);
    h->mb.i_neighbour4[4] = h->mb.i_neighbour4[1] = MB_LEFT | ((h->mb.i_neighbour_intra & MB_TOP) ? (MB_TOP | MB_TOPLEFT | MB_TOPRIGHT) : 0);
    h->mb.i_neighbour4[2] = h->mb.i_neighbour4[8] = h->mb.i_neighbour4[10] = h->mb.i_neighbour8[2] = MB_TOP | MB_TOPRIGHT | ((h->mb.i_neighbour_intra & MB_LEFT) ? (MB_LEFT | MB_TOPLEFT) : 0);
    h->mb.i_neighbour4[5] = h->mb.i_neighbour8[1] = MB_LEFT | (h->mb.i_neighbour_intra & MB_TOPRIGHT) | ((h->mb.i_neighbour_intra & MB_TOP) ? MB_TOP | MB_TOPLEFT : 0);
}

void x264_macroblock_cache_load_progressive (x264_t *h, int mb_x, int mb_y) {
    x264_macroblock_cache_load (h, mb_x, mb_y, 0);
}

void x264_macroblock_cache_load_interlaced (x264_t *h, int mb_x, int mb_y) {
    x264_macroblock_cache_load (h, mb_x, mb_y, 1);
}

void x264_macroblock_deblock_strength_mbaff (x264_t *h, uint8_t (*bs) [8] [4]) {
    if ((h->mb.i_neighbour & MB_LEFT) && h->mb.field[h->mb.i_mb_left_xy[0]] != 0) {
        static const uint8_t offset [2] [2] [8] = {{{0, 0, 0, 0, 1, 1, 1, 1}, {2, 2, 2, 2, 3, 3, 3, 3},}, {{0, 1, 2, 3, 0, 1, 2, 3}, {0, 1, 2, 3, 0, 1, 2, 3},}};
        uint8_t tmpbs [8];
        const uint8_t *off = offset[0][h->mb.i_mb_y & 1];
        uint8_t (*nnz) [48] = h->mb.non_zero_count;
        for (int i = 0; i < 8; i++) {
            int left = h->mb.i_mb_left_xy[0 ? i >> 2 : i & 1];
            int nnz_this = h->mb.cache.non_zero_count[x264_scan8[0] + 8 * (i >> 1)];
            int nnz_left = nnz[left][3 + 4 * off[i]];
            if (!h->param.b_cabac && h->pps->b_transform_8x8_mode) {
                int j = off[i] & ~1;
                if (h->mb.mb_transform_size[left])
                    nnz_left = !!((((x264_union16_t *) (&nnz[left][2 + 4 * j]))->i) | (((x264_union16_t *) (&nnz[left][2 + 4 * (1 + j)]))->i));
            }
            tmpbs[i] = (nnz_left || nnz_this) ? 2 : 1;
        }
        if (0) {
            (((x264_union32_t *) (bs[0][0]))->i) = (((x264_union32_t *) (&tmpbs[0]))->i);
            (((x264_union32_t *) (bs[0][4]))->i) = (((x264_union32_t *) (&tmpbs[4]))->i);
        }
        else {
            for (int i = 0; i < 4; i++)
                bs[0][0][i] = tmpbs[2 * i];
            for (int i = 0; i < 4; i++)
                bs[0][4][i] = tmpbs[1 + 2 * i];
        }
    }
    if ((h->mb.i_neighbour & MB_TOP) && 0 != h->mb.field[h->mb.i_mb_top_xy]) {
        if (!(h->mb.i_mb_y & 1) && !0) {
            int mbn_xy = h->mb.i_mb_xy - 2 * h->mb.i_mb_stride;
            uint8_t *nnz_cur = &h->mb.cache.non_zero_count[x264_scan8[0]];
            for (int j = 0; j < 2; j++, mbn_xy += h->mb.i_mb_stride) {
                uint8_t (*nnz) [48] = h->mb.non_zero_count;
                uint8_t nnz_top [4];
                (((x264_union32_t *) (nnz_top))->i) = (((x264_union32_t *) (&nnz[mbn_xy][3 * 4]))->i);
                if (!h->param.b_cabac && h->pps->b_transform_8x8_mode && h->mb.mb_transform_size[mbn_xy]) {
                    nnz_top[0] = nnz_top[1] = (((x264_union16_t *) (&nnz[mbn_xy][8]))->i) || (((x264_union16_t *) (&nnz[mbn_xy][12]))->i);
                    nnz_top[2] = nnz_top[3] = (((x264_union16_t *) (&nnz[mbn_xy][10]))->i) || (((x264_union16_t *) (&nnz[mbn_xy][14]))->i);
                }
                for (int i = 0; i < 4; i++)
                    bs[1][4 * j][i] = (nnz_cur[i] || nnz_top[i]) ? 2 : 1;
            }
        }
        else
            for (int i = 0; i < 4; i++)
                bs[1][0][i] = ((bs[1][0][i]) > (1) ? (bs[1][0][i]) : (1));
    }
}

void x264_macroblock_deblock_strength (x264_t *h) {
    uint8_t (*bs) [8] [4] = h->mb.cache.deblock_strength;
    if (((h->mb.i_type) == I_4x4 || (h->mb.i_type) == I_8x8 || (h->mb.i_type) == I_16x16 || (h->mb.i_type) == I_PCM)) {
        memset (bs [0] [1], 3, 3 * 4 * sizeof (uint8_t));
        memset (bs [1] [1], 3, 3 * 4 * sizeof (uint8_t));
        return;
    }
    if (h->mb.b_transform_8x8 && !(h->sps->i_chroma_format_idc == CHROMA_444)) {
        int cbp_mask = 0xf >> h->mb.chroma_v_shift;
        if ((h->mb.i_cbp_luma & cbp_mask) == cbp_mask) {
            (((x264_union32_t *) (bs[0][0]))->i) = 0x02020202;
            (((x264_union32_t *) (bs[0][2]))->i) = 0x02020202;
            (((x264_union32_t *) (bs[0][4]))->i) = 0x02020202;
            memset (bs [1] [0], 2, 5 * 4 * sizeof (uint8_t));
            return;
        }
    }
    int neighbour_changed = 0;
    if (h->sh.i_disable_deblocking_filter_idc != 2) {
        neighbour_changed = h->mb.i_neighbour_frame & ~h->mb.i_neighbour;
        h->mb.i_neighbour = h->mb.i_neighbour_frame;
    }
    if (0 && (h->mb.i_neighbour & MB_LEFT) && (h->mb.field[h->mb.i_mb_xy - 1] != 0)) {
        h->mb.i_mb_left_xy[1] = h->mb.i_mb_left_xy[0] = h->mb.i_mb_xy - 1;
        if (h->mb.i_mb_y & 1)
            h->mb.i_mb_left_xy[0] -= h->mb.i_mb_stride;
        else
            h->mb.i_mb_left_xy[1] += h->mb.i_mb_stride;
    }
    if (neighbour_changed) {
        int top_y = h->mb.i_mb_top_y;
        int top_8x8 = (2 * top_y + 1) * h->mb.i_b8_stride + 2 * h->mb.i_mb_x;
        int top_4x4 = (4 * top_y + 3) * h->mb.i_b4_stride + 4 * h->mb.i_mb_x;
        int s8x8 = h->mb.i_b8_stride;
        int s4x4 = h->mb.i_b4_stride;
        uint8_t (*nnz) [48] = h->mb.non_zero_count;
        const x264_left_table_t *left_index_table = 0 ? h->mb.left_index_table : &left_indices[3];
        if (neighbour_changed & MB_TOP)
            (((x264_union32_t *) (&h->mb.cache.non_zero_count[x264_scan8[0] - 8]))->i) = (((x264_union32_t *) (&nnz[h->mb.i_mb_top_xy][12]))->i);
        if (neighbour_changed & MB_LEFT) {
            int *left = h->mb.i_mb_left_xy;
            h->mb.cache.non_zero_count[x264_scan8[0] - 1] = nnz[left[0]][left_index_table->nnz[0]];
            h->mb.cache.non_zero_count[x264_scan8[2] - 1] = nnz[left[0]][left_index_table->nnz[1]];
            h->mb.cache.non_zero_count[x264_scan8[8] - 1] = nnz[left[1]][left_index_table->nnz[2]];
            h->mb.cache.non_zero_count[x264_scan8[10] - 1] = nnz[left[1]][left_index_table->nnz[3]];
        }
        for (int l = 0; l <= (h->sh.i_type == SLICE_TYPE_B); l++) {
            int16_t (*mv) [2] = h->mb.mv[l];
            int8_t *ref = h->mb.ref[l];
            int i8 = x264_scan8[0] - 8;
            if (neighbour_changed & MB_TOP) {
                h->mb.cache.ref[l][i8 + 0] = h->mb.cache.ref[l][i8 + 1] = ref[top_8x8 + 0];
                h->mb.cache.ref[l][i8 + 2] = h->mb.cache.ref[l][i8 + 3] = ref[top_8x8 + 1];
                (((x264_union128_sse_t *) (h->mb.cache.mv[l][i8]))->i) = (((x264_union128_sse_t *) (mv[top_4x4]))->i);
            }
            i8 = x264_scan8[0] - 1;
            if (neighbour_changed & MB_LEFT) {
                h->mb.cache.ref[l][i8 + 0 * 8] = h->mb.cache.ref[l][i8 + 1 * 8] = ref[h->mb.left_b8[0] + 1 + s8x8 * left_index_table->ref[0]];
                h->mb.cache.ref[l][i8 + 2 * 8] = h->mb.cache.ref[l][i8 + 3 * 8] = ref[h->mb.left_b8[1] + 1 + s8x8 * left_index_table->ref[2]];
                (((x264_union32_t *) (h->mb.cache.mv[l][i8 + 0 * 8]))->i) = (((x264_union32_t *) (mv[h->mb.left_b4[0] + 3 + s4x4 * left_index_table->mv[0]]))->i);
                (((x264_union32_t *) (h->mb.cache.mv[l][i8 + 1 * 8]))->i) = (((x264_union32_t *) (mv[h->mb.left_b4[0] + 3 + s4x4 * left_index_table->mv[1]]))->i);
                (((x264_union32_t *) (h->mb.cache.mv[l][i8 + 2 * 8]))->i) = (((x264_union32_t *) (mv[h->mb.left_b4[1] + 3 + s4x4 * left_index_table->mv[2]]))->i);
                (((x264_union32_t *) (h->mb.cache.mv[l][i8 + 3 * 8]))->i) = (((x264_union32_t *) (mv[h->mb.left_b4[1] + 3 + s4x4 * left_index_table->mv[3]]))->i);
            }
        }
    }
    if (h->param.analyse.i_weighted_pred == 2 && h->sh.i_type == SLICE_TYPE_P) {
        int i8 = x264_scan8[0] - 8;
        h->mb.cache.ref[0][i8 + 0] = h->mb.cache.ref[0][i8 + 1] = h->mb.deblock_ref_table[(h->mb.cache.ref[0][i8 + 0]) + 2];
        h->mb.cache.ref[0][i8 + 2] = h->mb.cache.ref[0][i8 + 3] = h->mb.deblock_ref_table[(h->mb.cache.ref[0][i8 + 2]) + 2];
        i8 = x264_scan8[0] - 1;
        h->mb.cache.ref[0][i8 + 0 * 8] = h->mb.cache.ref[0][i8 + 1 * 8] = h->mb.deblock_ref_table[(h->mb.cache.ref[0][i8 + 0 * 8]) + 2];
        h->mb.cache.ref[0][i8 + 2 * 8] = h->mb.cache.ref[0][i8 + 3 * 8] = h->mb.deblock_ref_table[(h->mb.cache.ref[0][i8 + 2 * 8]) + 2];
        int ref0 = h->mb.deblock_ref_table[(h->mb.cache.ref[0][x264_scan8[0]]) + 2];
        int ref1 = h->mb.deblock_ref_table[(h->mb.cache.ref[0][x264_scan8[4]]) + 2];
        int ref2 = h->mb.deblock_ref_table[(h->mb.cache.ref[0][x264_scan8[8]]) + 2];
        int ref3 = h->mb.deblock_ref_table[(h->mb.cache.ref[0][x264_scan8[12]]) + 2];
        uint32_t reftop = pack16to32 ((uint8_t) ref0, (uint8_t) ref1) * 0x0101;
        uint32_t refbot = pack16to32 ((uint8_t) ref2, (uint8_t) ref3) * 0x0101;
        (((x264_union32_t *) (&h->mb.cache.ref[0][x264_scan8[0] + 8 * 0]))->i) = reftop;
        (((x264_union32_t *) (&h->mb.cache.ref[0][x264_scan8[0] + 8 * 1]))->i) = reftop;
        (((x264_union32_t *) (&h->mb.cache.ref[0][x264_scan8[0] + 8 * 2]))->i) = refbot;
        (((x264_union32_t *) (&h->mb.cache.ref[0][x264_scan8[0] + 8 * 3]))->i) = refbot;
    }
    if (!h->param.b_cabac && h->pps->b_transform_8x8_mode) {
        uint8_t (*nnz) [48] = h->mb.non_zero_count;
        int top = h->mb.i_mb_top_xy;
        int *left = h->mb.i_mb_left_xy;
        if ((h->mb.i_neighbour & MB_TOP) && h->mb.mb_transform_size[top]) {
            int i8 = x264_scan8[0] - 8;
            int nnz_top0 = (((x264_union16_t *) (&nnz[top][8]))->i) | (((x264_union16_t *) (&nnz[top][12]))->i);
            int nnz_top1 = (((x264_union16_t *) (&nnz[top][10]))->i) | (((x264_union16_t *) (&nnz[top][14]))->i);
            (((x264_union16_t *) (&h->mb.cache.non_zero_count[i8 + 0]))->i) = nnz_top0 ? 0x0101 : 0;
            (((x264_union16_t *) (&h->mb.cache.non_zero_count[i8 + 2]))->i) = nnz_top1 ? 0x0101 : 0;
        }
        if (h->mb.i_neighbour & MB_LEFT) {
            int i8 = x264_scan8[0] - 1;
            if (h->mb.mb_transform_size[left[0]]) {
                int nnz_left0 = (((x264_union16_t *) (&nnz[left[0]][2]))->i) | (((x264_union16_t *) (&nnz[left[0]][6]))->i);
                h->mb.cache.non_zero_count[i8 + 8 * 0] = !!nnz_left0;
                h->mb.cache.non_zero_count[i8 + 8 * 1] = !!nnz_left0;
            }
            if (h->mb.mb_transform_size[left[1]]) {
                int nnz_left1 = (((x264_union16_t *) (&nnz[left[1]][10]))->i) | (((x264_union16_t *) (&nnz[left[1]][14]))->i);
                h->mb.cache.non_zero_count[i8 + 8 * 2] = !!nnz_left1;
                h->mb.cache.non_zero_count[i8 + 8 * 3] = !!nnz_left1;
            }
        }
        if (h->mb.b_transform_8x8) {
            int nnz0 = (((x264_union16_t *) (&h->mb.cache.non_zero_count[x264_scan8[0]]))->i) | (((x264_union16_t *) (&h->mb.cache.non_zero_count[x264_scan8[2]]))->i);
            int nnz1 = (((x264_union16_t *) (&h->mb.cache.non_zero_count[x264_scan8[4]]))->i) | (((x264_union16_t *) (&h->mb.cache.non_zero_count[x264_scan8[6]]))->i);
            int nnz2 = (((x264_union16_t *) (&h->mb.cache.non_zero_count[x264_scan8[8]]))->i) | (((x264_union16_t *) (&h->mb.cache.non_zero_count[x264_scan8[10]]))->i);
            int nnz3 = (((x264_union16_t *) (&h->mb.cache.non_zero_count[x264_scan8[12]]))->i) | (((x264_union16_t *) (&h->mb.cache.non_zero_count[x264_scan8[14]]))->i);
            uint32_t nnztop = pack16to32 (!!nnz0, !!nnz1) * 0x0101;
            uint32_t nnzbot = pack16to32 (!!nnz2, !!nnz3) * 0x0101;
            (((x264_union32_t *) (&h->mb.cache.non_zero_count[x264_scan8[0] + 8 * 0]))->i) = nnztop;
            (((x264_union32_t *) (&h->mb.cache.non_zero_count[x264_scan8[0] + 8 * 1]))->i) = nnztop;
            (((x264_union32_t *) (&h->mb.cache.non_zero_count[x264_scan8[0] + 8 * 2]))->i) = nnzbot;
            (((x264_union32_t *) (&h->mb.cache.non_zero_count[x264_scan8[0] + 8 * 3]))->i) = nnzbot;
        }
    }
    h->loopf.deblock_strength (h->mb.cache.non_zero_count, h->mb.cache.ref, h->mb.cache.mv, bs, 4 >> 0, h->sh.i_type == SLICE_TYPE_B);
    if (0)
        x264_macroblock_deblock_strength_mbaff (h, bs);
}

void x264_macroblock_store_pic (x264_t *h, int mb_x, int mb_y, int i, int b_chroma, int b_mbaff) {
    int height = b_chroma ? 16 >> h->mb.chroma_v_shift : 16;
    int i_stride = h->fdec->i_stride[i];
    int i_stride2 = i_stride << (b_mbaff && 0);
    int i_pix_offset = (b_mbaff && 0) ? 16 * mb_x + height * (mb_y & ~1) * i_stride + (mb_y & 1) * i_stride : 16 * mb_x + height * mb_y * i_stride;
    if (b_chroma)
        h->mc.store_interleave_chroma (&h->fdec->plane[1][i_pix_offset], i_stride2, h->mb.pic.p_fdec[1], h->mb.pic.p_fdec[2], height);
    else
        h->mc.copy[PIXEL_16x16] (&h->fdec->plane[i][i_pix_offset], i_stride2, h->mb.pic.p_fdec[i], 32, 16);
}

void x264_macroblock_backup_intra (x264_t *h, int mb_x, int mb_y, int b_mbaff) {
    int backup_dst = !b_mbaff ? (mb_y & 1) : (mb_y & 1) ? 1 : 0 ? 0 : 2;
    memcpy (& h -> intra_border_backup [backup_dst] [0] [mb_x * 16], h -> mb.pic.p_fdec [0] + 32 * 15, 16 * sizeof (pixel));
    if ((h->sps->i_chroma_format_idc == CHROMA_444)) {
        memcpy (& h -> intra_border_backup [backup_dst] [1] [mb_x * 16], h -> mb.pic.p_fdec [1] + 32 * 15, 16 * sizeof (pixel));
        memcpy (& h -> intra_border_backup [backup_dst] [2] [mb_x * 16], h -> mb.pic.p_fdec [2] + 32 * 15, 16 * sizeof (pixel));
    }
    else {
        int backup_src = (15 >> h->mb.chroma_v_shift) * 32;
        memcpy (& h -> intra_border_backup [backup_dst] [1] [mb_x * 16], h -> mb.pic.p_fdec [1] + backup_src, 8 * sizeof (pixel));
        memcpy (& h -> intra_border_backup [backup_dst] [1] [mb_x * 16 + 8], h -> mb.pic.p_fdec [2] + backup_src, 8 * sizeof (pixel));
    }
    if (b_mbaff) {
        if (mb_y & 1) {
            int backup_src = (0 ? 7 : 14) * 32;
            backup_dst = 0 ? 2 : 0;
            memcpy (& h -> intra_border_backup [backup_dst] [0] [mb_x * 16], h -> mb.pic.p_fdec [0] + backup_src, 16 * sizeof (pixel));
            if ((h->sps->i_chroma_format_idc == CHROMA_444)) {
                memcpy (& h -> intra_border_backup [backup_dst] [1] [mb_x * 16], h -> mb.pic.p_fdec [1] + backup_src, 16 * sizeof (pixel));
                memcpy (& h -> intra_border_backup [backup_dst] [2] [mb_x * 16], h -> mb.pic.p_fdec [2] + backup_src, 16 * sizeof (pixel));
            }
            else {
                if (h->sps->i_chroma_format_idc == CHROMA_420)
                    backup_src = (0 ? 3 : 6) * 32;
                memcpy (& h -> intra_border_backup [backup_dst] [1] [mb_x * 16], h -> mb.pic.p_fdec [1] + backup_src, 8 * sizeof (pixel));
                memcpy (& h -> intra_border_backup [backup_dst] [1] [mb_x * 16 + 8], h -> mb.pic.p_fdec [2] + backup_src, 8 * sizeof (pixel));
            }
        }
    }
}

void x264_macroblock_cache_save (x264_t *h) {
    const int i_mb_xy = h->mb.i_mb_xy;
    const int i_mb_type = x264_mb_type_fix[h->mb.i_type];
    const int s8x8 = h->mb.i_b8_stride;
    const int s4x4 = h->mb.i_b4_stride;
    const int i_mb_4x4 = h->mb.i_b4_xy;
    const int i_mb_8x8 = h->mb.i_b8_xy;
    int8_t *i4x4 = h->mb.intra4x4_pred_mode[i_mb_xy];
    uint8_t *nnz = h->mb.non_zero_count[i_mb_xy];
    if (0) {
        x264_macroblock_backup_intra (h, h -> mb.i_mb_x, h -> mb.i_mb_y, 1);
        x264_macroblock_store_pic (h, h -> mb.i_mb_x, h -> mb.i_mb_y, 0, 0, 1);
        if ((h->sps->i_chroma_format_idc == CHROMA_444)) {
            x264_macroblock_store_pic (h, h -> mb.i_mb_x, h -> mb.i_mb_y, 1, 0, 1);
            x264_macroblock_store_pic (h, h -> mb.i_mb_x, h -> mb.i_mb_y, 2, 0, 1);
        }
        else
            x264_macroblock_store_pic (h, h->mb.i_mb_x, h->mb.i_mb_y, 1, 1, 1);
    }
    else {
        x264_macroblock_backup_intra (h, h -> mb.i_mb_x, h -> mb.i_mb_y, 0);
        x264_macroblock_store_pic (h, h -> mb.i_mb_x, h -> mb.i_mb_y, 0, 0, 0);
        if ((h->sps->i_chroma_format_idc == CHROMA_444)) {
            x264_macroblock_store_pic (h, h -> mb.i_mb_x, h -> mb.i_mb_y, 1, 0, 0);
            x264_macroblock_store_pic (h, h -> mb.i_mb_x, h -> mb.i_mb_y, 2, 0, 0);
        }
        else
            x264_macroblock_store_pic (h, h->mb.i_mb_x, h->mb.i_mb_y, 1, 1, 0);
    }
    x264_prefetch_fenc (h, h -> fdec, h -> mb.i_mb_x, h -> mb.i_mb_y);
    h->mb.type[i_mb_xy] = i_mb_type;
    h->mb.slice_table[i_mb_xy] = h->sh.i_first_mb;
    h->mb.partition[i_mb_xy] = ((i_mb_type) == I_4x4 || (i_mb_type) == I_8x8 || (i_mb_type) == I_16x16 || (i_mb_type) == I_PCM) ? D_16x16 : h->mb.i_partition;
    h->mb.i_mb_prev_xy = i_mb_xy;
    if (i_mb_type == I_4x4) {
        (((x264_union32_t *) (&i4x4[0]))->i) = (((x264_union32_t *) (&h->mb.cache.intra4x4_pred_mode[x264_scan8[10]]))->i);
        (((x264_union32_t *) (&i4x4[4]))->i) = pack8to32 (h->mb.cache.intra4x4_pred_mode[x264_scan8[5]], h->mb.cache.intra4x4_pred_mode[x264_scan8[7]], h->mb.cache.intra4x4_pred_mode[x264_scan8[13]], 0);
    }
    else if (!h->param.b_constrained_intra || ((i_mb_type) == I_4x4 || (i_mb_type) == I_8x8 || (i_mb_type) == I_16x16 || (i_mb_type) == I_PCM))
        (((x264_union64_t *) (i4x4))->i) = I_PRED_4x4_DC * 0x0101010101010101ULL;
    else
        (((x264_union64_t *) (i4x4))->i) = (uint8_t) (-1) * 0x0101010101010101ULL;
    if (i_mb_type == I_PCM) {
        h->mb.qp[i_mb_xy] = 0;
        h->mb.i_last_dqp = 0;
        h->mb.i_cbp_chroma = (h->sps->i_chroma_format_idc == CHROMA_444) ? 0 : 2;
        h->mb.i_cbp_luma = 0xf;
        h->mb.cbp[i_mb_xy] = (h->mb.i_cbp_chroma << 4) | h->mb.i_cbp_luma | 0x700;
        h->mb.b_transform_8x8 = 0;
        for (int i = 0; i < 48; i++)
            h->mb.cache.non_zero_count[x264_scan8[i]] = h->param.b_cabac ? 1 : 16;
    }
    else {
        if (h->mb.i_type != I_16x16 && h->mb.i_cbp_luma == 0 && h->mb.i_cbp_chroma == 0)
            h->mb.i_qp = h->mb.i_last_qp;
        h->mb.qp[i_mb_xy] = h->mb.i_qp;
        h->mb.i_last_dqp = h->mb.i_qp - h->mb.i_last_qp;
        h->mb.i_last_qp = h->mb.i_qp;
    }
    (((x264_union32_t *) (&nnz[0 + 0 * 4]))->i) = (((x264_union32_t *) (&h->mb.cache.non_zero_count[x264_scan8[0]]))->i);
    (((x264_union32_t *) (&nnz[0 + 1 * 4]))->i) = (((x264_union32_t *) (&h->mb.cache.non_zero_count[x264_scan8[2]]))->i);
    (((x264_union32_t *) (&nnz[0 + 2 * 4]))->i) = (((x264_union32_t *) (&h->mb.cache.non_zero_count[x264_scan8[8]]))->i);
    (((x264_union32_t *) (&nnz[0 + 3 * 4]))->i) = (((x264_union32_t *) (&h->mb.cache.non_zero_count[x264_scan8[10]]))->i);
    (((x264_union32_t *) (&nnz[16 + 0 * 4]))->i) = (((x264_union32_t *) (&h->mb.cache.non_zero_count[x264_scan8[16 + 0]]))->i);
    (((x264_union32_t *) (&nnz[16 + 1 * 4]))->i) = (((x264_union32_t *) (&h->mb.cache.non_zero_count[x264_scan8[16 + 2]]))->i);
    (((x264_union32_t *) (&nnz[32 + 0 * 4]))->i) = (((x264_union32_t *) (&h->mb.cache.non_zero_count[x264_scan8[32 + 0]]))->i);
    (((x264_union32_t *) (&nnz[32 + 1 * 4]))->i) = (((x264_union32_t *) (&h->mb.cache.non_zero_count[x264_scan8[32 + 2]]))->i);
    if (h->sps->i_chroma_format_idc >= CHROMA_422) {
        (((x264_union32_t *) (&nnz[16 + 2 * 4]))->i) = (((x264_union32_t *) (&h->mb.cache.non_zero_count[x264_scan8[16 + 8]]))->i);
        (((x264_union32_t *) (&nnz[16 + 3 * 4]))->i) = (((x264_union32_t *) (&h->mb.cache.non_zero_count[x264_scan8[16 + 10]]))->i);
        (((x264_union32_t *) (&nnz[32 + 2 * 4]))->i) = (((x264_union32_t *) (&h->mb.cache.non_zero_count[x264_scan8[32 + 8]]))->i);
        (((x264_union32_t *) (&nnz[32 + 3 * 4]))->i) = (((x264_union32_t *) (&h->mb.cache.non_zero_count[x264_scan8[32 + 10]]))->i);
    }
    if (h->mb.i_cbp_luma == 0 && h->mb.i_type != I_8x8)
        h->mb.b_transform_8x8 = 0;
    h->mb.mb_transform_size[i_mb_xy] = h->mb.b_transform_8x8;
    if (h->sh.i_type != SLICE_TYPE_I) {
        int16_t (*mv0) [2] = &h->mb.mv[0][i_mb_4x4];
        int16_t (*mv1) [2] = &h->mb.mv[1][i_mb_4x4];
        int8_t *ref0 = &h->mb.ref[0][i_mb_8x8];
        int8_t *ref1 = &h->mb.ref[1][i_mb_8x8];
        if (!((i_mb_type) == I_4x4 || (i_mb_type) == I_8x8 || (i_mb_type) == I_16x16 || (i_mb_type) == I_PCM)) {
            ref0[0 + 0 * s8x8] = h->mb.cache.ref[0][x264_scan8[0]];
            ref0[1 + 0 * s8x8] = h->mb.cache.ref[0][x264_scan8[4]];
            ref0[0 + 1 * s8x8] = h->mb.cache.ref[0][x264_scan8[8]];
            ref0[1 + 1 * s8x8] = h->mb.cache.ref[0][x264_scan8[12]];
            (((x264_union128_sse_t *) (&mv0[0 * s4x4]))->i) = (((x264_union128_sse_t *) (h->mb.cache.mv[0][x264_scan8[0] + 8 * 0]))->i);
            (((x264_union128_sse_t *) (&mv0[1 * s4x4]))->i) = (((x264_union128_sse_t *) (h->mb.cache.mv[0][x264_scan8[0] + 8 * 1]))->i);
            (((x264_union128_sse_t *) (&mv0[2 * s4x4]))->i) = (((x264_union128_sse_t *) (h->mb.cache.mv[0][x264_scan8[0] + 8 * 2]))->i);
            (((x264_union128_sse_t *) (&mv0[3 * s4x4]))->i) = (((x264_union128_sse_t *) (h->mb.cache.mv[0][x264_scan8[0] + 8 * 3]))->i);
            if (h->sh.i_type == SLICE_TYPE_B) {
                ref1[0 + 0 * s8x8] = h->mb.cache.ref[1][x264_scan8[0]];
                ref1[1 + 0 * s8x8] = h->mb.cache.ref[1][x264_scan8[4]];
                ref1[0 + 1 * s8x8] = h->mb.cache.ref[1][x264_scan8[8]];
                ref1[1 + 1 * s8x8] = h->mb.cache.ref[1][x264_scan8[12]];
                (((x264_union128_sse_t *) (&mv1[0 * s4x4]))->i) = (((x264_union128_sse_t *) (h->mb.cache.mv[1][x264_scan8[0] + 8 * 0]))->i);
                (((x264_union128_sse_t *) (&mv1[1 * s4x4]))->i) = (((x264_union128_sse_t *) (h->mb.cache.mv[1][x264_scan8[0] + 8 * 1]))->i);
                (((x264_union128_sse_t *) (&mv1[2 * s4x4]))->i) = (((x264_union128_sse_t *) (h->mb.cache.mv[1][x264_scan8[0] + 8 * 2]))->i);
                (((x264_union128_sse_t *) (&mv1[3 * s4x4]))->i) = (((x264_union128_sse_t *) (h->mb.cache.mv[1][x264_scan8[0] + 8 * 3]))->i);
            }
        }
        else {
            (((x264_union16_t *) (&ref0[0 * s8x8]))->i) = (uint8_t) (-1) * 0x0101;
            (((x264_union16_t *) (&ref0[1 * s8x8]))->i) = (uint8_t) (-1) * 0x0101;
            (((x264_union128_sse_t *) (&mv0[0 * s4x4]))->i) = ((__m128) {0, 0, 0, 0});
            (((x264_union128_sse_t *) (&mv0[1 * s4x4]))->i) = ((__m128) {0, 0, 0, 0});
            (((x264_union128_sse_t *) (&mv0[2 * s4x4]))->i) = ((__m128) {0, 0, 0, 0});
            (((x264_union128_sse_t *) (&mv0[3 * s4x4]))->i) = ((__m128) {0, 0, 0, 0});
            if (h->sh.i_type == SLICE_TYPE_B) {
                (((x264_union16_t *) (&ref1[0 * s8x8]))->i) = (uint8_t) (-1) * 0x0101;
                (((x264_union16_t *) (&ref1[1 * s8x8]))->i) = (uint8_t) (-1) * 0x0101;
                (((x264_union128_sse_t *) (&mv1[0 * s4x4]))->i) = ((__m128) {0, 0, 0, 0});
                (((x264_union128_sse_t *) (&mv1[1 * s4x4]))->i) = ((__m128) {0, 0, 0, 0});
                (((x264_union128_sse_t *) (&mv1[2 * s4x4]))->i) = ((__m128) {0, 0, 0, 0});
                (((x264_union128_sse_t *) (&mv1[3 * s4x4]))->i) = ((__m128) {0, 0, 0, 0});
            }
        }
    }
    if (h->param.b_cabac) {
        uint8_t (*mvd0) [2] = h->mb.mvd[0][i_mb_xy];
        uint8_t (*mvd1) [2] = h->mb.mvd[1][i_mb_xy];
        if (((i_mb_type) == I_4x4 || (i_mb_type) == I_8x8 || (i_mb_type) == I_16x16 || (i_mb_type) == I_PCM) && i_mb_type != I_PCM)
            h->mb.chroma_pred_mode[i_mb_xy] = x264_mb_chroma_pred_mode_fix[h->mb.i_chroma_pred_mode];
        else
            h->mb.chroma_pred_mode[i_mb_xy] = I_PRED_CHROMA_DC;
        if ((0x3FF30 >> i_mb_type) & 1) {
            (((x264_union64_t *) (mvd0[0]))->i) = (((x264_union64_t *) (h->mb.cache.mvd[0][x264_scan8[10]]))->i);
            (((x264_union16_t *) (mvd0[4]))->i) = (((x264_union16_t *) (h->mb.cache.mvd[0][x264_scan8[5]]))->i);
            (((x264_union16_t *) (mvd0[5]))->i) = (((x264_union16_t *) (h->mb.cache.mvd[0][x264_scan8[7]]))->i);
            (((x264_union16_t *) (mvd0[6]))->i) = (((x264_union16_t *) (h->mb.cache.mvd[0][x264_scan8[13]]))->i);
            if (h->sh.i_type == SLICE_TYPE_B) {
                (((x264_union64_t *) (mvd1[0]))->i) = (((x264_union64_t *) (h->mb.cache.mvd[1][x264_scan8[10]]))->i);
                (((x264_union16_t *) (mvd1[4]))->i) = (((x264_union16_t *) (h->mb.cache.mvd[1][x264_scan8[5]]))->i);
                (((x264_union16_t *) (mvd1[5]))->i) = (((x264_union16_t *) (h->mb.cache.mvd[1][x264_scan8[7]]))->i);
                (((x264_union16_t *) (mvd1[6]))->i) = (((x264_union16_t *) (h->mb.cache.mvd[1][x264_scan8[13]]))->i);
            }
        }
        else {
            (((x264_union128_sse_t *) (mvd0[0]))->i) = ((__m128) {0, 0, 0, 0});
            if (h->sh.i_type == SLICE_TYPE_B)
                (((x264_union128_sse_t *) (mvd1[0]))->i) = ((__m128) {0, 0, 0, 0});
        }
        if (h->sh.i_type == SLICE_TYPE_B) {
            if (i_mb_type == B_SKIP || i_mb_type == B_DIRECT)
                h->mb.skipbp[i_mb_xy] = 0xf;
            else if (i_mb_type == B_8x8) {
                int skipbp = (h->mb.i_sub_partition[0] == D_DIRECT_8x8) << 0;
                skipbp |= (h->mb.i_sub_partition[1] == D_DIRECT_8x8) << 1;
                skipbp |= (h->mb.i_sub_partition[2] == D_DIRECT_8x8) << 2;
                skipbp |= (h->mb.i_sub_partition[3] == D_DIRECT_8x8) << 3;
                h->mb.skipbp[i_mb_xy] = skipbp;
            }
            else
                h->mb.skipbp[i_mb_xy] = 0;
        }
    }
}

void x264_macroblock_bipred_init (x264_t *h) {
    for (int mbfield = 0; mbfield <= 0; mbfield++)
        for (int field = 0; field <= 0; field++)
            for (int i_ref0 = 0; i_ref0 < (h->i_ref[0] << mbfield); i_ref0++) {
                x264_frame_t *l0 = h->fref[0][i_ref0 >> mbfield];
                int poc0 = l0->i_poc + mbfield * l0->i_delta_poc[field ^ (i_ref0 & 1)];
                for (int i_ref1 = 0; i_ref1 < (h->i_ref[1] << mbfield); i_ref1++) {
                    int dist_scale_factor;
                    x264_frame_t *l1 = h->fref[1][i_ref1 >> mbfield];
                    int cur_poc = h->fdec->i_poc + mbfield * h->fdec->i_delta_poc[field];
                    int poc1 = l1->i_poc + mbfield * l1->i_delta_poc[field ^ (i_ref1 & 1)];
                    int td = x264_clip3 (poc1 -poc0, -128, 127);
                    if (td == 0)
                        dist_scale_factor = 256;
                    else {
                        int tb = x264_clip3 (cur_poc -poc0, -128, 127);
                        int tx = (16384 + (abs (td) >> 1)) / td;
                        dist_scale_factor = x264_clip3 ((tb * tx + 32) >> 6, -1024, 1023);
                    }
                    h->mb.dist_scale_factor_buf[mbfield][field][i_ref0][i_ref1] = dist_scale_factor;
                    dist_scale_factor >>= 2;
                    if (h->param.analyse.b_weighted_bipred && dist_scale_factor >= -64 && dist_scale_factor <= 128) {
                        h->mb.bipred_weight_buf[mbfield][field][i_ref0][i_ref1] = 64 - dist_scale_factor;
                        ((dist_scale_factor >= -63 && dist_scale_factor <= 127) ? (void) (0) : __assert_fail ("dist_scale_factor >= -63 && dist_scale_factor <= 127", "DonorSourceCode/macroblock.c", 1900, __PRETTY_FUNCTION__));
                    }
                    else
                        h->mb.bipred_weight_buf[mbfield][field][i_ref0][i_ref1] = 32;
                }
            }
}

