
#include "common.h"

#include "macroblockENCODER.h"

#include "me.h"
const uint8_t subpel_iterations [] [4] = {{0, 0, 0, 0}, {1, 1, 0, 0}, {0, 1, 1, 0}, {0, 2, 1, 0}, {0, 2, 1, 1}, {0, 2, 1, 2}, {0, 0, 2, 2}, {0, 0, 2, 2}, {0, 0, 4, 10}, {0, 0, 4, 10}, {0, 0, 4, 10}, {0, 0, 4, 10}};
const uint8_t mod6m1 [8] = {5, 0, 1, 2, 3, 4, 5, 0};
const int8_t hex2 [8] [2] = {{-1, -2}, {-2, 0}, {-1, 2}, {1, 2}, {2, 0}, {1, -2}, {-1, -2}, {-2, 0}};
const int8_t square1 [9] [2] = {{0, 0}, {0, -1}, {0, 1}, {-1, 0}, {1, 0}, {-1, -1}, {-1, 1}, {1, -1}, {1, 1}};
void refine_subpel (x264_t * h, x264_me_t * m, int hpel_iters, int qpel_iters, int * p_halfpel_thresh, int b_refine_qpel);

void x264_me_search_ref (x264_t *h, x264_me_t *m, int16_t (*mvc) [2], int i_mvc, int *p_halfpel_thresh) {
    const int bw = x264_pixel_size[m->i_pixel].w;
    const int bh = x264_pixel_size[m->i_pixel].h;
    const int i_pixel = m->i_pixel;
    const int stride = m->i_stride[0];
    int i_me_range = h->param.analyse.i_me_range;
    int bmx, bmy, bcost = (1 << 28);
    int bpred_cost = (1 << 28);
    int omx, omy, pmx, pmy;
    pixel *p_fenc = m->p_fenc[0];
    pixel *p_fref_w = m->p_fref_w;
    uint8_t pix_u [sizeof (pixel[16 * 16]) + 31];
    pixel (*pix) = (void *) ((intptr_t) (pix_u + 31) & ~31);
    int16_t mvc_temp [16] [2];
    int costs [16];
    int mv_x_min = h->mb.mv_limit_fpel[0][0];
    int mv_y_min = h->mb.mv_limit_fpel[0][1];
    int mv_x_max = h->mb.mv_limit_fpel[1][0];
    int mv_y_max = h->mb.mv_limit_fpel[1][1];
    uint32_t mv_min = ((-mv_x_min << 16) | (-mv_y_min & 0x7FFF));
    uint32_t mv_max = ((mv_x_max << 16) | (mv_y_max & 0x7FFF)) | 0x8000;
    uint32_t pmv, bpred_mv = 0;
    const uint16_t *p_cost_mvx = m->p_cost_mv - m->mvp[0];
    const uint16_t *p_cost_mvy = m->p_cost_mv - m->mvp[1];
    if (h->mb.i_subpel_refine >= 3) {
        int bpred_mx = x264_clip3 (m->mvp[0], ((mv_x_min) << 2), ((mv_x_max) << 2));
        int bpred_my = x264_clip3 (m->mvp[1], ((mv_y_min) << 2), ((mv_y_max) << 2));
        pmv = pack16to32_mask (bpred_mx, bpred_my);
        pmx = (((bpred_mx) +2) >> 2);
        pmy = (((bpred_my) +2) >> 2);
        do {
            intptr_t stride2 = 16;
            pixel *src = h->mc.get_ref (pix, &stride2, m->p_fref, stride, bpred_mx, bpred_my, bw, bh, &m->weight[0]);
            bpred_cost = h->pixf.fpelcmp[i_pixel] (p_fenc, 16, src, stride2) + p_cost_mvx[bpred_mx] + p_cost_mvy[bpred_my];
        }
        while (0);
        int pmv_cost = bpred_cost;
        if (i_mvc > 0) {
            int valid_mvcs = x264_predictor_clip (mvc_temp +2, mvc, i_mvc, h->mb.mv_limit_fpel, pmv);
            if (valid_mvcs > 0) {
                int i = 1, cost;
                (((x264_union32_t *) (mvc_temp[1]))->i) = pmv;
                bpred_cost <<= 4;
                do {
                    int mx = mvc_temp[i + 1][0];
                    int my = mvc_temp[i + 1][1];
                    do {
                        intptr_t stride2 = 16;
                        pixel *src = h->mc.get_ref (pix, &stride2, m->p_fref, stride, mx, my, bw, bh, &m->weight[0]);
                        cost = h->pixf.fpelcmp[i_pixel] (p_fenc, 16, src, stride2) + p_cost_mvx[mx] + p_cost_mvy[my];
                    }
                    while (0);
                    if (((cost << 4) + i) < (bpred_cost))
                        (bpred_cost) = ((cost << 4) + i);
                    ;
                }
                while (++i <= valid_mvcs);
                bpred_mx = mvc_temp[(bpred_cost & 15) + 1][0];
                bpred_my = mvc_temp[(bpred_cost & 15) + 1][1];
                bpred_cost >>= 4;
            }
        }
        bmx = (((bpred_mx) +2) >> 2);
        bmy = (((bpred_my) +2) >> 2);
        bpred_mv = pack16to32_mask (bpred_mx, bpred_my);
        if (bpred_mv & 0x00030003)
            do {
                int cost = h->pixf.fpelcmp[i_pixel] (p_fenc, 16, &p_fref_w[(bmy) *stride + (bmx)], stride) + (p_cost_mvx[(bmx) << 2] + p_cost_mvy[(bmy) << 2]);
                if ((cost) < (bcost)) {
                    (bcost) = (cost);
                    (bmx) = (bmx);
                    (bmy) = (bmy);
                };
            }
            while (0);
        else
            bcost = bpred_cost;
        if (pmv) {
            if (bmx | bmy)
                do {
                    int cost = h->pixf.fpelcmp[i_pixel] (p_fenc, 16, &p_fref_w[(0) * stride + (0)], stride) + (p_cost_mvx[(0) << 2] + p_cost_mvy[(0) << 2]);
                    if ((cost) < (bcost)) {
                        (bcost) = (cost);
                        (bmx) = (0);
                        (bmy) = (0);
                    };
                }
                while (0);
        }
        else {
            if ((pmv_cost) < (bcost)) {
                (bcost) = (pmv_cost);
                (bmx) = (0);
                (bmy) = (0);
            };
        }
    }
    else {
        bmx = pmx = x264_clip3 ((((m->mvp[0]) + 2) >> 2), mv_x_min, mv_x_max);
        bmy = pmy = x264_clip3 ((((m->mvp[1]) + 2) >> 2), mv_y_min, mv_y_max);
        pmv = pack16to32_mask (bmx, bmy);
        bcost = h->pixf.fpelcmp[i_pixel] (p_fenc, 16, &p_fref_w[bmy * stride + bmx], stride);
        if (i_mvc > 0) {
            int valid_mvcs = x264_predictor_roundclip (mvc_temp +2, mvc, i_mvc, h->mb.mv_limit_fpel, pmv);
            if (valid_mvcs > 0) {
                int i = 1, cost;
                (((x264_union32_t *) (mvc_temp[1]))->i) = pmv;
                bcost <<= 4;
                do {
                    int mx = mvc_temp[i + 1][0];
                    int my = mvc_temp[i + 1][1];
                    cost = h->pixf.fpelcmp[i_pixel] (p_fenc, 16, &p_fref_w[my * stride + mx], stride) + (p_cost_mvx[(mx) << 2] + p_cost_mvy[(my) << 2]);
                    if (((cost << 4) + i) < (bcost))
                        (bcost) = ((cost << 4) + i);
                    ;
                }
                while (++i <= valid_mvcs);
                bmx = mvc_temp[(bcost & 15) + 1][0];
                bmy = mvc_temp[(bcost & 15) + 1][1];
                bcost >>= 4;
            }
        }
        if (pmv)
            do {
                int cost = h->pixf.fpelcmp[i_pixel] (p_fenc, 16, &p_fref_w[(0) * stride + (0)], stride) + (p_cost_mvx[(0) << 2] + p_cost_mvy[(0) << 2]);
                if ((cost) < (bcost)) {
                    (bcost) = (cost);
                    (bmx) = (0);
                    (bmy) = (0);
                };
            }
            while (0);
    }
    switch (h->mb.i_me_method) {
    case 0 :
        {
            bcost <<= 4;
            int i = i_me_range;
            do {
                {
                    pixel *pix_base = p_fref_w + bmx + bmy * stride;
                    h->pixf.fpelcmp_x4[i_pixel] (p_fenc, pix_base +(0) + (-1) * stride, pix_base +(0) + (1) * stride, pix_base +(-1) + (0) * stride, pix_base +(1) + (0) * stride, stride, costs);
                    (costs)[0] += (p_cost_mvx[(bmx + (0)) << 2] + p_cost_mvy[(bmy + (-1)) << 2]);
                    (costs)[1] += (p_cost_mvx[(bmx + (0)) << 2] + p_cost_mvy[(bmy + (1)) << 2]);
                    (costs)[2] += (p_cost_mvx[(bmx + (-1)) << 2] + p_cost_mvy[(bmy + (0)) << 2]);
                    (costs)[3] += (p_cost_mvx[(bmx + (1)) << 2] + p_cost_mvy[(bmy + (0)) << 2]);
                };
                if (((costs[0] << 4) + 1) < (bcost))
                    (bcost) = ((costs[0] << 4) + 1);
                ;
                if (((costs[1] << 4) + 3) < (bcost))
                    (bcost) = ((costs[1] << 4) + 3);
                ;
                if (((costs[2] << 4) + 4) < (bcost))
                    (bcost) = ((costs[2] << 4) + 4);
                ;
                if (((costs[3] << 4) + 12) < (bcost))
                    (bcost) = ((costs[3] << 4) + 12);
                ;
                if (!(bcost & 15))
                    break;
                bmx -= (bcost << 28) >> 30;
                bmy -= (bcost << 30) >> 30;
                bcost &= ~15;
            }
            while (--i && (!(((((bmx << 16) | (bmy & 0x7FFF)) + mv_min) | (mv_max - ((bmx << 16) | (bmy & 0x7FFF)))) & 0x80004000)));
            bcost >>= 4;
            break;
        }
    case 1 :
        {
        me_hex2 :
            {
                pixel *pix_base = p_fref_w + bmx + bmy * stride;
                h->pixf.fpelcmp_x3[i_pixel] (p_fenc, pix_base +(-2) + (0) * stride, pix_base +(-1) + (2) * stride, pix_base +(1) + (2) * stride, stride, costs);
                (costs)[0] += (p_cost_mvx[(bmx + (-2)) << 2] + p_cost_mvy[(bmy + (0)) << 2]);
                (costs)[1] += (p_cost_mvx[(bmx + (-1)) << 2] + p_cost_mvy[(bmy + (2)) << 2]);
                (costs)[2] += (p_cost_mvx[(bmx + (1)) << 2] + p_cost_mvy[(bmy + (2)) << 2]);
            };
            {
                pixel *pix_base = p_fref_w + bmx + bmy * stride;
                h->pixf.fpelcmp_x3[i_pixel] (p_fenc, pix_base +(2) + (0) * stride, pix_base +(1) + (-2) * stride, pix_base +(-1) + (-2) * stride, stride, costs +4);
                (costs + 4)[0] += (p_cost_mvx[(bmx + (2)) << 2] + p_cost_mvy[(bmy + (0)) << 2]);
                (costs + 4)[1] += (p_cost_mvx[(bmx + (1)) << 2] + p_cost_mvy[(bmy + (-2)) << 2]);
                (costs + 4)[2] += (p_cost_mvx[(bmx + (-1)) << 2] + p_cost_mvy[(bmy + (-2)) << 2]);
            };
            bcost <<= 3;
            if (((costs[0] << 3) + 2) < (bcost))
                (bcost) = ((costs[0] << 3) + 2);
            ;
            if (((costs[1] << 3) + 3) < (bcost))
                (bcost) = ((costs[1] << 3) + 3);
            ;
            if (((costs[2] << 3) + 4) < (bcost))
                (bcost) = ((costs[2] << 3) + 4);
            ;
            if (((costs[4] << 3) + 5) < (bcost))
                (bcost) = ((costs[4] << 3) + 5);
            ;
            if (((costs[5] << 3) + 6) < (bcost))
                (bcost) = ((costs[5] << 3) + 6);
            ;
            if (((costs[6] << 3) + 7) < (bcost))
                (bcost) = ((costs[6] << 3) + 7);
            ;
            if (bcost & 7) {
                int dir = (bcost & 7) - 2;
                bmx += hex2[dir + 1][0];
                bmy += hex2[dir + 1][1];
                for (int i = (i_me_range >> 1) - 1; i > 0 && (!(((((bmx << 16) | (bmy & 0x7FFF)) + mv_min) | (mv_max - ((bmx << 16) | (bmy & 0x7FFF)))) & 0x80004000)); i--) {
                    {
                        pixel *pix_base = p_fref_w + bmx + bmy * stride;
                        h->pixf.fpelcmp_x3[i_pixel] (p_fenc, pix_base +(hex2[dir + 0][0]) + (hex2[dir + 0][1]) * stride, pix_base +(hex2[dir + 1][0]) + (hex2[dir + 1][1]) * stride, pix_base +(hex2[dir + 2][0]) + (hex2[dir + 2][1]) * stride, stride, costs);
                        (costs)[0] += (p_cost_mvx[(bmx + (hex2[dir + 0][0])) << 2] + p_cost_mvy[(bmy + (hex2[dir + 0][1])) << 2]);
                        (costs)[1] += (p_cost_mvx[(bmx + (hex2[dir + 1][0])) << 2] + p_cost_mvy[(bmy + (hex2[dir + 1][1])) << 2]);
                        (costs)[2] += (p_cost_mvx[(bmx + (hex2[dir + 2][0])) << 2] + p_cost_mvy[(bmy + (hex2[dir + 2][1])) << 2]);
                    };
                    bcost &= ~7;
                    if (((costs[0] << 3) + 1) < (bcost))
                        (bcost) = ((costs[0] << 3) + 1);
                    ;
                    if (((costs[1] << 3) + 2) < (bcost))
                        (bcost) = ((costs[1] << 3) + 2);
                    ;
                    if (((costs[2] << 3) + 3) < (bcost))
                        (bcost) = ((costs[2] << 3) + 3);
                    ;
                    if (!(bcost & 7))
                        break;
                    dir += (bcost & 7) - 2;
                    dir = mod6m1[dir + 1];
                    bmx += hex2[dir + 1][0];
                    bmy += hex2[dir + 1][1];
                }
            }
            bcost >>= 3;
            bcost <<= 4;
            {
                pixel *pix_base = p_fref_w + bmx + bmy * stride;
                h->pixf.fpelcmp_x4[i_pixel] (p_fenc, pix_base +(0) + (-1) * stride, pix_base +(0) + (1) * stride, pix_base +(-1) + (0) * stride, pix_base +(1) + (0) * stride, stride, costs);
                (costs)[0] += (p_cost_mvx[(bmx + (0)) << 2] + p_cost_mvy[(bmy + (-1)) << 2]);
                (costs)[1] += (p_cost_mvx[(bmx + (0)) << 2] + p_cost_mvy[(bmy + (1)) << 2]);
                (costs)[2] += (p_cost_mvx[(bmx + (-1)) << 2] + p_cost_mvy[(bmy + (0)) << 2]);
                (costs)[3] += (p_cost_mvx[(bmx + (1)) << 2] + p_cost_mvy[(bmy + (0)) << 2]);
            };
            if (((costs[0] << 4) + 1) < (bcost))
                (bcost) = ((costs[0] << 4) + 1);
            ;
            if (((costs[1] << 4) + 2) < (bcost))
                (bcost) = ((costs[1] << 4) + 2);
            ;
            if (((costs[2] << 4) + 3) < (bcost))
                (bcost) = ((costs[2] << 4) + 3);
            ;
            if (((costs[3] << 4) + 4) < (bcost))
                (bcost) = ((costs[3] << 4) + 4);
            ;
            {
                pixel *pix_base = p_fref_w + bmx + bmy * stride;
                h->pixf.fpelcmp_x4[i_pixel] (p_fenc, pix_base +(-1) + (-1) * stride, pix_base +(-1) + (1) * stride, pix_base +(1) + (-1) * stride, pix_base +(1) + (1) * stride, stride, costs);
                (costs)[0] += (p_cost_mvx[(bmx + (-1)) << 2] + p_cost_mvy[(bmy + (-1)) << 2]);
                (costs)[1] += (p_cost_mvx[(bmx + (-1)) << 2] + p_cost_mvy[(bmy + (1)) << 2]);
                (costs)[2] += (p_cost_mvx[(bmx + (1)) << 2] + p_cost_mvy[(bmy + (-1)) << 2]);
                (costs)[3] += (p_cost_mvx[(bmx + (1)) << 2] + p_cost_mvy[(bmy + (1)) << 2]);
            };
            if (((costs[0] << 4) + 5) < (bcost))
                (bcost) = ((costs[0] << 4) + 5);
            ;
            if (((costs[1] << 4) + 6) < (bcost))
                (bcost) = ((costs[1] << 4) + 6);
            ;
            if (((costs[2] << 4) + 7) < (bcost))
                (bcost) = ((costs[2] << 4) + 7);
            ;
            if (((costs[3] << 4) + 8) < (bcost))
                (bcost) = ((costs[3] << 4) + 8);
            ;
            bmx += square1[bcost & 15][0];
            bmy += square1[bcost & 15][1];
            bcost >>= 4;
            break;
        }
    case 2 :
        {
            const uint8_t x264_pixel_size_shift [7] = {0, 1, 1, 2, 3, 3, 4};
            int ucost1, ucost2;
            int cross_start = 1;
            ucost1 = bcost;
            {
                omx = pmx;
                omy = pmy;
                {
                    pixel *pix_base = p_fref_w + omx + omy * stride;
                    h->pixf.fpelcmp_x4[i_pixel] (p_fenc, pix_base +(0) + (-1) * stride, pix_base +(0) + (1) * stride, pix_base +(-1) + (0) * stride, pix_base +(1) + (0) * stride, stride, costs);
                    costs[0] += (p_cost_mvx[(omx + (0)) << 2] + p_cost_mvy[(omy + (-1)) << 2]);
                    costs[1] += (p_cost_mvx[(omx + (0)) << 2] + p_cost_mvy[(omy + (1)) << 2]);
                    costs[2] += (p_cost_mvx[(omx + (-1)) << 2] + p_cost_mvy[(omy + (0)) << 2]);
                    costs[3] += (p_cost_mvx[(omx + (1)) << 2] + p_cost_mvy[(omy + (0)) << 2]);
                    if ((costs[0]) < (bcost)) {
                        (bcost) = (costs[0]);
                        (bmx) = (omx + (0));
                        (bmy) = (omy + (-1));
                    };
                    if ((costs[1]) < (bcost)) {
                        (bcost) = (costs[1]);
                        (bmx) = (omx + (0));
                        (bmy) = (omy + (1));
                    };
                    if ((costs[2]) < (bcost)) {
                        (bcost) = (costs[2]);
                        (bmx) = (omx + (-1));
                        (bmy) = (omy + (0));
                    };
                    if ((costs[3]) < (bcost)) {
                        (bcost) = (costs[3]);
                        (bmx) = (omx + (1));
                        (bmy) = (omy + (0));
                    };
                };
            };
            if (pmx | pmy) {
                omx = 0;
                omy = 0;
                {
                    pixel *pix_base = p_fref_w + omx + omy * stride;
                    h->pixf.fpelcmp_x4[i_pixel] (p_fenc, pix_base +(0) + (-1) * stride, pix_base +(0) + (1) * stride, pix_base +(-1) + (0) * stride, pix_base +(1) + (0) * stride, stride, costs);
                    costs[0] += (p_cost_mvx[(omx + (0)) << 2] + p_cost_mvy[(omy + (-1)) << 2]);
                    costs[1] += (p_cost_mvx[(omx + (0)) << 2] + p_cost_mvy[(omy + (1)) << 2]);
                    costs[2] += (p_cost_mvx[(omx + (-1)) << 2] + p_cost_mvy[(omy + (0)) << 2]);
                    costs[3] += (p_cost_mvx[(omx + (1)) << 2] + p_cost_mvy[(omy + (0)) << 2]);
                    if ((costs[0]) < (bcost)) {
                        (bcost) = (costs[0]);
                        (bmx) = (omx + (0));
                        (bmy) = (omy + (-1));
                    };
                    if ((costs[1]) < (bcost)) {
                        (bcost) = (costs[1]);
                        (bmx) = (omx + (0));
                        (bmy) = (omy + (1));
                    };
                    if ((costs[2]) < (bcost)) {
                        (bcost) = (costs[2]);
                        (bmx) = (omx + (-1));
                        (bmy) = (omy + (0));
                    };
                    if ((costs[3]) < (bcost)) {
                        (bcost) = (costs[3]);
                        (bmx) = (omx + (1));
                        (bmy) = (omy + (0));
                    };
                };
            };
            if (i_pixel == PIXEL_4x4)
                goto me_hex2;
            ucost2 = bcost;
            if ((bmx | bmy) && ((bmx - pmx) | (bmy - pmy))) {
                omx = bmx;
                omy = bmy;
                {
                    pixel *pix_base = p_fref_w + omx + omy * stride;
                    h->pixf.fpelcmp_x4[i_pixel] (p_fenc, pix_base +(0) + (-1) * stride, pix_base +(0) + (1) * stride, pix_base +(-1) + (0) * stride, pix_base +(1) + (0) * stride, stride, costs);
                    costs[0] += (p_cost_mvx[(omx + (0)) << 2] + p_cost_mvy[(omy + (-1)) << 2]);
                    costs[1] += (p_cost_mvx[(omx + (0)) << 2] + p_cost_mvy[(omy + (1)) << 2]);
                    costs[2] += (p_cost_mvx[(omx + (-1)) << 2] + p_cost_mvy[(omy + (0)) << 2]);
                    costs[3] += (p_cost_mvx[(omx + (1)) << 2] + p_cost_mvy[(omy + (0)) << 2]);
                    if ((costs[0]) < (bcost)) {
                        (bcost) = (costs[0]);
                        (bmx) = (omx + (0));
                        (bmy) = (omy + (-1));
                    };
                    if ((costs[1]) < (bcost)) {
                        (bcost) = (costs[1]);
                        (bmx) = (omx + (0));
                        (bmy) = (omy + (1));
                    };
                    if ((costs[2]) < (bcost)) {
                        (bcost) = (costs[2]);
                        (bmx) = (omx + (-1));
                        (bmy) = (omy + (0));
                    };
                    if ((costs[3]) < (bcost)) {
                        (bcost) = (costs[3]);
                        (bmx) = (omx + (1));
                        (bmy) = (omy + (0));
                    };
                };
            };
            if (bcost == ucost2)
                cross_start = 3;
            omx = bmx;
            omy = bmy;
            if (bcost == ucost2 && (bcost < (2000 >> x264_pixel_size_shift[i_pixel]))) {
                {
                    pixel *pix_base = p_fref_w + omx + omy * stride;
                    h->pixf.fpelcmp_x4[i_pixel] (p_fenc, pix_base +(0) + (-2) * stride, pix_base +(-1) + (-1) * stride, pix_base +(1) + (-1) * stride, pix_base +(-2) + (0) * stride, stride, costs);
                    costs[0] += (p_cost_mvx[(omx + (0)) << 2] + p_cost_mvy[(omy + (-2)) << 2]);
                    costs[1] += (p_cost_mvx[(omx + (-1)) << 2] + p_cost_mvy[(omy + (-1)) << 2]);
                    costs[2] += (p_cost_mvx[(omx + (1)) << 2] + p_cost_mvy[(omy + (-1)) << 2]);
                    costs[3] += (p_cost_mvx[(omx + (-2)) << 2] + p_cost_mvy[(omy + (0)) << 2]);
                    if ((costs[0]) < (bcost)) {
                        (bcost) = (costs[0]);
                        (bmx) = (omx + (0));
                        (bmy) = (omy + (-2));
                    };
                    if ((costs[1]) < (bcost)) {
                        (bcost) = (costs[1]);
                        (bmx) = (omx + (-1));
                        (bmy) = (omy + (-1));
                    };
                    if ((costs[2]) < (bcost)) {
                        (bcost) = (costs[2]);
                        (bmx) = (omx + (1));
                        (bmy) = (omy + (-1));
                    };
                    if ((costs[3]) < (bcost)) {
                        (bcost) = (costs[3]);
                        (bmx) = (omx + (-2));
                        (bmy) = (omy + (0));
                    };
                };
                {
                    pixel *pix_base = p_fref_w + omx + omy * stride;
                    h->pixf.fpelcmp_x4[i_pixel] (p_fenc, pix_base +(2) + (0) * stride, pix_base +(-1) + (1) * stride, pix_base +(1) + (1) * stride, pix_base +(0) + (2) * stride, stride, costs);
                    costs[0] += (p_cost_mvx[(omx + (2)) << 2] + p_cost_mvy[(omy + (0)) << 2]);
                    costs[1] += (p_cost_mvx[(omx + (-1)) << 2] + p_cost_mvy[(omy + (1)) << 2]);
                    costs[2] += (p_cost_mvx[(omx + (1)) << 2] + p_cost_mvy[(omy + (1)) << 2]);
                    costs[3] += (p_cost_mvx[(omx + (0)) << 2] + p_cost_mvy[(omy + (2)) << 2]);
                    if ((costs[0]) < (bcost)) {
                        (bcost) = (costs[0]);
                        (bmx) = (omx + (2));
                        (bmy) = (omy + (0));
                    };
                    if ((costs[1]) < (bcost)) {
                        (bcost) = (costs[1]);
                        (bmx) = (omx + (-1));
                        (bmy) = (omy + (1));
                    };
                    if ((costs[2]) < (bcost)) {
                        (bcost) = (costs[2]);
                        (bmx) = (omx + (1));
                        (bmy) = (omy + (1));
                    };
                    if ((costs[3]) < (bcost)) {
                        (bcost) = (costs[3]);
                        (bmx) = (omx + (0));
                        (bmy) = (omy + (2));
                    };
                };
                if (bcost == ucost1 && (bcost < (500 >> x264_pixel_size_shift[i_pixel])))
                    break;
                if (bcost == ucost2) {
                    int range = (i_me_range >> 1) | 1;
                    {
                        int i = 3;
                        if ((range) <= ((mv_x_max - omx) < (omx - mv_x_min) ? (mv_x_max - omx) : (omx - mv_x_min)))
                            for (; i < (range) -2; i += 4) {
                                pixel *pix_base = p_fref_w + omx + omy * stride;
                                h->pixf.fpelcmp_x4[i_pixel] (p_fenc, pix_base +(i)+(0) * stride, pix_base +(-i) + (0) * stride, pix_base +(i + 2) + (0) * stride, pix_base +(-i - 2) + (0) * stride, stride, costs);
                                costs[0] += (p_cost_mvx[(omx + (i)) << 2] + p_cost_mvy[(omy + (0)) << 2]);
                                costs[1] += (p_cost_mvx[(omx + (-i)) << 2] + p_cost_mvy[(omy + (0)) << 2]);
                                costs[2] += (p_cost_mvx[(omx + (i + 2)) << 2] + p_cost_mvy[(omy + (0)) << 2]);
                                costs[3] += (p_cost_mvx[(omx + (-i - 2)) << 2] + p_cost_mvy[(omy + (0)) << 2]);
                                if ((costs[0]) < (bcost)) {
                                    (bcost) = (costs[0]);
                                    (bmx) = (omx + (i));
                                    (bmy) = (omy + (0));
                                };
                                if ((costs[1]) < (bcost)) {
                                    (bcost) = (costs[1]);
                                    (bmx) = (omx + (-i));
                                    (bmy) = (omy + (0));
                                };
                                if ((costs[2]) < (bcost)) {
                                    (bcost) = (costs[2]);
                                    (bmx) = (omx + (i + 2));
                                    (bmy) = (omy + (0));
                                };
                                if ((costs[3]) < (bcost)) {
                                    (bcost) = (costs[3]);
                                    (bmx) = (omx + (-i - 2));
                                    (bmy) = (omy + (0));
                                };
                            };
                        for (; i < (range); i += 2) {
                            if (omx + i <= mv_x_max)
                                do {
                                    int cost = h->pixf.fpelcmp[i_pixel] (p_fenc, 16, &p_fref_w[(omy) *stride + (omx + i)], stride) + (p_cost_mvx[(omx + i) << 2] + p_cost_mvy[(omy) << 2]);
                                    if ((cost) < (bcost)) {
                                        (bcost) = (cost);
                                        (bmx) = (omx + i);
                                        (bmy) = (omy);
                                    };
                                }
                                while (0);
                            if (omx - i >= mv_x_min)
                                do {
                                    int cost = h->pixf.fpelcmp[i_pixel] (p_fenc, 16, &p_fref_w[(omy) *stride + (omx - i)], stride) + (p_cost_mvx[(omx - i) << 2] + p_cost_mvy[(omy) << 2]);
                                    if ((cost) < (bcost)) {
                                        (bcost) = (cost);
                                        (bmx) = (omx - i);
                                        (bmy) = (omy);
                                    };
                                }
                                while (0);
                        }
                        i = 3;
                        if ((range) <= ((mv_y_max - omy) < (omy - mv_y_min) ? (mv_y_max - omy) : (omy - mv_y_min)))
                            for (; i < (range) -2; i += 4) {
                                pixel *pix_base = p_fref_w + omx + omy * stride;
                                h->pixf.fpelcmp_x4[i_pixel] (p_fenc, pix_base +(0) + (i) *stride, pix_base +(0) + (-i) * stride, pix_base +(0) + (i + 2) * stride, pix_base +(0) + (-i - 2) * stride, stride, costs);
                                costs[0] += (p_cost_mvx[(omx + (0)) << 2] + p_cost_mvy[(omy + (i)) << 2]);
                                costs[1] += (p_cost_mvx[(omx + (0)) << 2] + p_cost_mvy[(omy + (-i)) << 2]);
                                costs[2] += (p_cost_mvx[(omx + (0)) << 2] + p_cost_mvy[(omy + (i + 2)) << 2]);
                                costs[3] += (p_cost_mvx[(omx + (0)) << 2] + p_cost_mvy[(omy + (-i - 2)) << 2]);
                                if ((costs[0]) < (bcost)) {
                                    (bcost) = (costs[0]);
                                    (bmx) = (omx + (0));
                                    (bmy) = (omy + (i));
                                };
                                if ((costs[1]) < (bcost)) {
                                    (bcost) = (costs[1]);
                                    (bmx) = (omx + (0));
                                    (bmy) = (omy + (-i));
                                };
                                if ((costs[2]) < (bcost)) {
                                    (bcost) = (costs[2]);
                                    (bmx) = (omx + (0));
                                    (bmy) = (omy + (i + 2));
                                };
                                if ((costs[3]) < (bcost)) {
                                    (bcost) = (costs[3]);
                                    (bmx) = (omx + (0));
                                    (bmy) = (omy + (-i - 2));
                                };
                            };
                        for (; i < (range); i += 2) {
                            if (omy + i <= mv_y_max)
                                do {
                                    int cost = h->pixf.fpelcmp[i_pixel] (p_fenc, 16, &p_fref_w[(omy + i) * stride + (omx)], stride) + (p_cost_mvx[(omx) << 2] + p_cost_mvy[(omy + i) << 2]);
                                    if ((cost) < (bcost)) {
                                        (bcost) = (cost);
                                        (bmx) = (omx);
                                        (bmy) = (omy + i);
                                    };
                                }
                                while (0);
                            if (omy - i >= mv_y_min)
                                do {
                                    int cost = h->pixf.fpelcmp[i_pixel] (p_fenc, 16, &p_fref_w[(omy - i) * stride + (omx)], stride) + (p_cost_mvx[(omx) << 2] + p_cost_mvy[(omy - i) << 2]);
                                    if ((cost) < (bcost)) {
                                        (bcost) = (cost);
                                        (bmx) = (omx);
                                        (bmy) = (omy - i);
                                    };
                                }
                                while (0);
                        }
                    };
                    {
                        pixel *pix_base = p_fref_w + omx + omy * stride;
                        h->pixf.fpelcmp_x4[i_pixel] (p_fenc, pix_base +(-1) + (-2) * stride, pix_base +(1) + (-2) * stride, pix_base +(-2) + (-1) * stride, pix_base +(2) + (-1) * stride, stride, costs);
                        costs[0] += (p_cost_mvx[(omx + (-1)) << 2] + p_cost_mvy[(omy + (-2)) << 2]);
                        costs[1] += (p_cost_mvx[(omx + (1)) << 2] + p_cost_mvy[(omy + (-2)) << 2]);
                        costs[2] += (p_cost_mvx[(omx + (-2)) << 2] + p_cost_mvy[(omy + (-1)) << 2]);
                        costs[3] += (p_cost_mvx[(omx + (2)) << 2] + p_cost_mvy[(omy + (-1)) << 2]);
                        if ((costs[0]) < (bcost)) {
                            (bcost) = (costs[0]);
                            (bmx) = (omx + (-1));
                            (bmy) = (omy + (-2));
                        };
                        if ((costs[1]) < (bcost)) {
                            (bcost) = (costs[1]);
                            (bmx) = (omx + (1));
                            (bmy) = (omy + (-2));
                        };
                        if ((costs[2]) < (bcost)) {
                            (bcost) = (costs[2]);
                            (bmx) = (omx + (-2));
                            (bmy) = (omy + (-1));
                        };
                        if ((costs[3]) < (bcost)) {
                            (bcost) = (costs[3]);
                            (bmx) = (omx + (2));
                            (bmy) = (omy + (-1));
                        };
                    };
                    {
                        pixel *pix_base = p_fref_w + omx + omy * stride;
                        h->pixf.fpelcmp_x4[i_pixel] (p_fenc, pix_base +(-2) + (1) * stride, pix_base +(2) + (1) * stride, pix_base +(-1) + (2) * stride, pix_base +(1) + (2) * stride, stride, costs);
                        costs[0] += (p_cost_mvx[(omx + (-2)) << 2] + p_cost_mvy[(omy + (1)) << 2]);
                        costs[1] += (p_cost_mvx[(omx + (2)) << 2] + p_cost_mvy[(omy + (1)) << 2]);
                        costs[2] += (p_cost_mvx[(omx + (-1)) << 2] + p_cost_mvy[(omy + (2)) << 2]);
                        costs[3] += (p_cost_mvx[(omx + (1)) << 2] + p_cost_mvy[(omy + (2)) << 2]);
                        if ((costs[0]) < (bcost)) {
                            (bcost) = (costs[0]);
                            (bmx) = (omx + (-2));
                            (bmy) = (omy + (1));
                        };
                        if ((costs[1]) < (bcost)) {
                            (bcost) = (costs[1]);
                            (bmx) = (omx + (2));
                            (bmy) = (omy + (1));
                        };
                        if ((costs[2]) < (bcost)) {
                            (bcost) = (costs[2]);
                            (bmx) = (omx + (-1));
                            (bmy) = (omy + (2));
                        };
                        if ((costs[3]) < (bcost)) {
                            (bcost) = (costs[3]);
                            (bmx) = (omx + (1));
                            (bmy) = (omy + (2));
                        };
                    };
                    if (bcost == ucost2)
                        break;
                    cross_start = range + 2;
                }
            }
            if (i_mvc) {
                const uint8_t range_mul [4] [4] = {{3, 3, 4, 4}, {3, 4, 4, 4}, {4, 4, 4, 5}, {4, 4, 5, 6},};
                int mvd;
                int sad_ctx, mvd_ctx;
                int denom = 1;
                if (i_mvc == 1) {
                    if (i_pixel == PIXEL_16x16)
                        mvd = 25;
                    else
                        mvd = abs (m->mvp[0] - mvc[0][0]) + abs (m->mvp[1] - mvc[0][1]);
                }
                else {
                    denom = i_mvc - 1;
                    mvd = 0;
                    if (i_pixel != PIXEL_16x16) {
                        mvd = abs (m->mvp[0] - mvc[0][0]) + abs (m->mvp[1] - mvc[0][1]);
                        denom++;
                    }
                    mvd += x264_predictor_difference (mvc, i_mvc);
                }
                sad_ctx = (bcost < (1000 >> x264_pixel_size_shift[i_pixel])) ? 0 : (bcost < (2000 >> x264_pixel_size_shift[i_pixel])) ? 1 : (bcost < (4000 >> x264_pixel_size_shift[i_pixel])) ? 2 : 3;
                mvd_ctx = mvd < 10 * denom ? 0 : mvd < 20 * denom ? 1 : mvd < 40 * denom ? 2 : 3;
                i_me_range = i_me_range * range_mul[mvd_ctx][sad_ctx] >> 2;
            }
            {
                int i = cross_start;
                if ((i_me_range) <= ((mv_x_max - omx) < (omx - mv_x_min) ? (mv_x_max - omx) : (omx - mv_x_min)))
                    for (; i < (i_me_range) -2; i += 4) {
                        pixel *pix_base = p_fref_w + omx + omy * stride;
                        h->pixf.fpelcmp_x4[i_pixel] (p_fenc, pix_base +(i)+(0) * stride, pix_base +(-i) + (0) * stride, pix_base +(i + 2) + (0) * stride, pix_base +(-i - 2) + (0) * stride, stride, costs);
                        costs[0] += (p_cost_mvx[(omx + (i)) << 2] + p_cost_mvy[(omy + (0)) << 2]);
                        costs[1] += (p_cost_mvx[(omx + (-i)) << 2] + p_cost_mvy[(omy + (0)) << 2]);
                        costs[2] += (p_cost_mvx[(omx + (i + 2)) << 2] + p_cost_mvy[(omy + (0)) << 2]);
                        costs[3] += (p_cost_mvx[(omx + (-i - 2)) << 2] + p_cost_mvy[(omy + (0)) << 2]);
                        if ((costs[0]) < (bcost)) {
                            (bcost) = (costs[0]);
                            (bmx) = (omx + (i));
                            (bmy) = (omy + (0));
                        };
                        if ((costs[1]) < (bcost)) {
                            (bcost) = (costs[1]);
                            (bmx) = (omx + (-i));
                            (bmy) = (omy + (0));
                        };
                        if ((costs[2]) < (bcost)) {
                            (bcost) = (costs[2]);
                            (bmx) = (omx + (i + 2));
                            (bmy) = (omy + (0));
                        };
                        if ((costs[3]) < (bcost)) {
                            (bcost) = (costs[3]);
                            (bmx) = (omx + (-i - 2));
                            (bmy) = (omy + (0));
                        };
                    };
                for (; i < (i_me_range); i += 2) {
                    if (omx + i <= mv_x_max)
                        do {
                            int cost = h->pixf.fpelcmp[i_pixel] (p_fenc, 16, &p_fref_w[(omy) *stride + (omx + i)], stride) + (p_cost_mvx[(omx + i) << 2] + p_cost_mvy[(omy) << 2]);
                            if ((cost) < (bcost)) {
                                (bcost) = (cost);
                                (bmx) = (omx + i);
                                (bmy) = (omy);
                            };
                        }
                        while (0);
                    if (omx - i >= mv_x_min)
                        do {
                            int cost = h->pixf.fpelcmp[i_pixel] (p_fenc, 16, &p_fref_w[(omy) *stride + (omx - i)], stride) + (p_cost_mvx[(omx - i) << 2] + p_cost_mvy[(omy) << 2]);
                            if ((cost) < (bcost)) {
                                (bcost) = (cost);
                                (bmx) = (omx - i);
                                (bmy) = (omy);
                            };
                        }
                        while (0);
                }
                i = cross_start;
                if ((i_me_range >> 1) <= ((mv_y_max - omy) < (omy - mv_y_min) ? (mv_y_max - omy) : (omy - mv_y_min)))
                    for (; i < (i_me_range >> 1) - 2; i += 4) {
                        pixel *pix_base = p_fref_w + omx + omy * stride;
                        h->pixf.fpelcmp_x4[i_pixel] (p_fenc, pix_base +(0) + (i) *stride, pix_base +(0) + (-i) * stride, pix_base +(0) + (i + 2) * stride, pix_base +(0) + (-i - 2) * stride, stride, costs);
                        costs[0] += (p_cost_mvx[(omx + (0)) << 2] + p_cost_mvy[(omy + (i)) << 2]);
                        costs[1] += (p_cost_mvx[(omx + (0)) << 2] + p_cost_mvy[(omy + (-i)) << 2]);
                        costs[2] += (p_cost_mvx[(omx + (0)) << 2] + p_cost_mvy[(omy + (i + 2)) << 2]);
                        costs[3] += (p_cost_mvx[(omx + (0)) << 2] + p_cost_mvy[(omy + (-i - 2)) << 2]);
                        if ((costs[0]) < (bcost)) {
                            (bcost) = (costs[0]);
                            (bmx) = (omx + (0));
                            (bmy) = (omy + (i));
                        };
                        if ((costs[1]) < (bcost)) {
                            (bcost) = (costs[1]);
                            (bmx) = (omx + (0));
                            (bmy) = (omy + (-i));
                        };
                        if ((costs[2]) < (bcost)) {
                            (bcost) = (costs[2]);
                            (bmx) = (omx + (0));
                            (bmy) = (omy + (i + 2));
                        };
                        if ((costs[3]) < (bcost)) {
                            (bcost) = (costs[3]);
                            (bmx) = (omx + (0));
                            (bmy) = (omy + (-i - 2));
                        };
                    };
                for (; i < (i_me_range >> 1); i += 2) {
                    if (omy + i <= mv_y_max)
                        do {
                            int cost = h->pixf.fpelcmp[i_pixel] (p_fenc, 16, &p_fref_w[(omy + i) * stride + (omx)], stride) + (p_cost_mvx[(omx) << 2] + p_cost_mvy[(omy + i) << 2]);
                            if ((cost) < (bcost)) {
                                (bcost) = (cost);
                                (bmx) = (omx);
                                (bmy) = (omy + i);
                            };
                        }
                        while (0);
                    if (omy - i >= mv_y_min)
                        do {
                            int cost = h->pixf.fpelcmp[i_pixel] (p_fenc, 16, &p_fref_w[(omy - i) * stride + (omx)], stride) + (p_cost_mvx[(omx) << 2] + p_cost_mvy[(omy - i) << 2]);
                            if ((cost) < (bcost)) {
                                (bcost) = (cost);
                                (bmx) = (omx);
                                (bmy) = (omy - i);
                            };
                        }
                        while (0);
                }
            };
            {
                pixel *pix_base = p_fref_w + omx + omy * stride;
                h->pixf.fpelcmp_x4[i_pixel] (p_fenc, pix_base +(-2) + (-2) * stride, pix_base +(-2) + (2) * stride, pix_base +(2) + (-2) * stride, pix_base +(2) + (2) * stride, stride, costs);
                costs[0] += (p_cost_mvx[(omx + (-2)) << 2] + p_cost_mvy[(omy + (-2)) << 2]);
                costs[1] += (p_cost_mvx[(omx + (-2)) << 2] + p_cost_mvy[(omy + (2)) << 2]);
                costs[2] += (p_cost_mvx[(omx + (2)) << 2] + p_cost_mvy[(omy + (-2)) << 2]);
                costs[3] += (p_cost_mvx[(omx + (2)) << 2] + p_cost_mvy[(omy + (2)) << 2]);
                if ((costs[0]) < (bcost)) {
                    (bcost) = (costs[0]);
                    (bmx) = (omx + (-2));
                    (bmy) = (omy + (-2));
                };
                if ((costs[1]) < (bcost)) {
                    (bcost) = (costs[1]);
                    (bmx) = (omx + (-2));
                    (bmy) = (omy + (2));
                };
                if ((costs[2]) < (bcost)) {
                    (bcost) = (costs[2]);
                    (bmx) = (omx + (2));
                    (bmy) = (omy + (-2));
                };
                if ((costs[3]) < (bcost)) {
                    (bcost) = (costs[3]);
                    (bmx) = (omx + (2));
                    (bmy) = (omy + (2));
                };
            };
            omx = bmx;
            omy = bmy;
            const uint16_t *p_cost_omvx = p_cost_mvx + omx * 4;
            const uint16_t *p_cost_omvy = p_cost_mvy + omy * 4;
            int i = 1;
            do {
                const int8_t hex4 [16] [2] = {{0, -4}, {0, 4}, {-2, -3}, {2, -3}, {-4, -2}, {4, -2}, {-4, -1}, {4, -1}, {-4, 0}, {4, 0}, {-4, 1}, {4, 1}, {-4, 2}, {4, 2}, {-2, 3}, {2, 3},};
                if (4 * i > (((mv_x_max - omx)) < (((((omx - mv_x_min))) < (((((mv_y_max - omy))) < (((omy - mv_y_min))) ? (((mv_y_max - omy))) : (((omy - mv_y_min))))) ? (((omx - mv_x_min))) : (((((mv_y_max - omy))) < (((omy - mv_y_min))) ? (((mv_y_max - omy))) : (((omy - mv_y_min))))))) ? ((mv_x_max - omx)) : (((((omx - mv_x_min))) < (((((mv_y_max - omy))) < (((omy - mv_y_min))) ? (((mv_y_max - omy))) : (((omy - mv_y_min))))) ? (((omx - mv_x_min))) : (((((mv_y_max - omy))) < (((omy - mv_y_min))) ? (((mv_y_max - omy))) : (((omy - mv_y_min))))))))) {
                    for (int j = 0; j < 16; j++) {
                        int mx = omx + hex4[j][0] * i;
                        int my = omy + hex4[j][1] * i;
                        if ((!(((((mx << 16) | (my & 0x7FFF)) + mv_min) | (mv_max - ((mx << 16) | (my & 0x7FFF)))) & 0x80004000)))
                            do {
                                int cost = h->pixf.fpelcmp[i_pixel] (p_fenc, 16, &p_fref_w[(my) *stride + (mx)], stride) + (p_cost_mvx[(mx) << 2] + p_cost_mvy[(my) << 2]);
                                if ((cost) < (bcost)) {
                                    (bcost) = (cost);
                                    (bmx) = (mx);
                                    (bmy) = (my);
                                };
                            }
                            while (0);
                    }
                }
                else {
                    int dir = 0;
                    pixel *pix_base = p_fref_w + omx + (omy - 4 * i) * stride;
                    int dy = i * stride;
                    h->pixf.fpelcmp_x4[i_pixel] (p_fenc, pix_base +0 * i + (-4 - 2 * 0 + 4) * dy, pix_base +0 * i + (+4 - 2 * 0 + 4) * dy, pix_base -2 * i + (-3 - 2 * 0 + 4) * dy, pix_base +2 * i + (-3 - 2 * 0 + 4) * dy, stride, costs +4 * 0);
                    pix_base += 2 * dy;
                    ;
                    h->pixf.fpelcmp_x4[i_pixel] (p_fenc, pix_base -4 * i + (-2 - 2 * 1 + 4) * dy, pix_base +4 * i + (-2 - 2 * 1 + 4) * dy, pix_base -4 * i + (-1 - 2 * 1 + 4) * dy, pix_base +4 * i + (-1 - 2 * 1 + 4) * dy, stride, costs +4 * 1);
                    pix_base += 2 * dy;
                    ;
                    h->pixf.fpelcmp_x4[i_pixel] (p_fenc, pix_base -4 * i + (+0 - 2 * 2 + 4) * dy, pix_base +4 * i + (+0 - 2 * 2 + 4) * dy, pix_base -4 * i + (+1 - 2 * 2 + 4) * dy, pix_base +4 * i + (+1 - 2 * 2 + 4) * dy, stride, costs +4 * 2);
                    pix_base += 2 * dy;
                    ;
                    h->pixf.fpelcmp_x4[i_pixel] (p_fenc, pix_base -4 * i + (+2 - 2 * 3 + 4) * dy, pix_base +4 * i + (+2 - 2 * 3 + 4) * dy, pix_base -2 * i + (+3 - 2 * 3 + 4) * dy, pix_base +2 * i + (+3 - 2 * 3 + 4) * dy, stride, costs +4 * 3);
                    pix_base += 2 * dy;
                    ;
                    costs[0] += p_cost_omvx[0 * 4 * i] + p_cost_omvy[-4 * 4 * i];
                    costs[1] += p_cost_omvx[0 * 4 * i] + p_cost_omvy[4 * 4 * i];
                    costs[2] += p_cost_omvx[-2 * 4 * i] + p_cost_omvy[-3 * 4 * i];
                    costs[3] += p_cost_omvx[2 * 4 * i] + p_cost_omvy[-3 * 4 * i];
                    costs[4] += p_cost_omvx[-4 * 4 * i] + p_cost_omvy[-2 * 4 * i];
                    costs[5] += p_cost_omvx[4 * 4 * i] + p_cost_omvy[-2 * 4 * i];
                    costs[6] += p_cost_omvx[-4 * 4 * i] + p_cost_omvy[-1 * 4 * i];
                    costs[7] += p_cost_omvx[4 * 4 * i] + p_cost_omvy[-1 * 4 * i];
                    costs[8] += p_cost_omvx[-4 * 4 * i] + p_cost_omvy[0 * 4 * i];
                    costs[9] += p_cost_omvx[4 * 4 * i] + p_cost_omvy[0 * 4 * i];
                    costs[10] += p_cost_omvx[-4 * 4 * i] + p_cost_omvy[1 * 4 * i];
                    costs[11] += p_cost_omvx[4 * 4 * i] + p_cost_omvy[1 * 4 * i];
                    costs[12] += p_cost_omvx[-4 * 4 * i] + p_cost_omvy[2 * 4 * i];
                    costs[13] += p_cost_omvx[4 * 4 * i] + p_cost_omvy[2 * 4 * i];
                    costs[14] += p_cost_omvx[-2 * 4 * i] + p_cost_omvy[3 * 4 * i];
                    costs[15] += p_cost_omvx[2 * 4 * i] + p_cost_omvy[3 * 4 * i];
                    if ((costs[0]) < (bcost)) {
                        (bcost) = (costs[0]);
                        (dir) = (0 * 16 + (-4 & 15));
                    };
                    if ((costs[1]) < (bcost)) {
                        (bcost) = (costs[1]);
                        (dir) = (0 * 16 + (4 & 15));
                    };
                    if ((costs[2]) < (bcost)) {
                        (bcost) = (costs[2]);
                        (dir) = (-2 * 16 + (-3 & 15));
                    };
                    if ((costs[3]) < (bcost)) {
                        (bcost) = (costs[3]);
                        (dir) = (2 * 16 + (-3 & 15));
                    };
                    if ((costs[4]) < (bcost)) {
                        (bcost) = (costs[4]);
                        (dir) = (-4 * 16 + (-2 & 15));
                    };
                    if ((costs[5]) < (bcost)) {
                        (bcost) = (costs[5]);
                        (dir) = (4 * 16 + (-2 & 15));
                    };
                    if ((costs[6]) < (bcost)) {
                        (bcost) = (costs[6]);
                        (dir) = (-4 * 16 + (-1 & 15));
                    };
                    if ((costs[7]) < (bcost)) {
                        (bcost) = (costs[7]);
                        (dir) = (4 * 16 + (-1 & 15));
                    };
                    if ((costs[8]) < (bcost)) {
                        (bcost) = (costs[8]);
                        (dir) = (-4 * 16 + (0 & 15));
                    };
                    if ((costs[9]) < (bcost)) {
                        (bcost) = (costs[9]);
                        (dir) = (4 * 16 + (0 & 15));
                    };
                    if ((costs[10]) < (bcost)) {
                        (bcost) = (costs[10]);
                        (dir) = (-4 * 16 + (1 & 15));
                    };
                    if ((costs[11]) < (bcost)) {
                        (bcost) = (costs[11]);
                        (dir) = (4 * 16 + (1 & 15));
                    };
                    if ((costs[12]) < (bcost)) {
                        (bcost) = (costs[12]);
                        (dir) = (-4 * 16 + (2 & 15));
                    };
                    if ((costs[13]) < (bcost)) {
                        (bcost) = (costs[13]);
                        (dir) = (4 * 16 + (2 & 15));
                    };
                    if ((costs[14]) < (bcost)) {
                        (bcost) = (costs[14]);
                        (dir) = (-2 * 16 + (3 & 15));
                    };
                    if ((costs[15]) < (bcost)) {
                        (bcost) = (costs[15]);
                        (dir) = (2 * 16 + (3 & 15));
                    };
                    if (dir) {
                        bmx = omx + i * (dir >> 4);
                        bmy = omy + i * ((dir << 28) >> 28);
                    }
                }
            }
            while (++i <= i_me_range >> 2);
            if (bmy <= mv_y_max && bmy >= mv_y_min && bmx <= mv_x_max && bmx >= mv_x_min)
                goto me_hex2;
            break;
        }
    case 3 :
    case 4 :
        {
            const int min_x = ((bmx - i_me_range) > (mv_x_min) ? (bmx - i_me_range) : (mv_x_min));
            const int min_y = ((bmy - i_me_range) > (mv_y_min) ? (bmy - i_me_range) : (mv_y_min));
            const int max_x = ((bmx + i_me_range) < (mv_x_max) ? (bmx + i_me_range) : (mv_x_max));
            const int max_y = ((bmy + i_me_range) < (mv_y_max) ? (bmy + i_me_range) : (mv_y_max));
            const int width = (max_x - min_x + 3) & ~3;
            uint16_t *sums_base = m->integral;
            pixel zero [8 * 16] = {0};
            int enc_dc [4];
            int sad_size = i_pixel <= PIXEL_8x8 ? PIXEL_8x8 : PIXEL_4x4;
            int delta = x264_pixel_size[sad_size].w;
            int16_t *xs = h->scratch_buffer;
            int xn;
            uint16_t *cost_fpel_mvx = h->cost_mv_fpel[h->mb.i_qp][-m->mvp[0] & 3] + (-m->mvp[0] >> 2);
            h->pixf.sad_x4[sad_size] (zero, p_fenc, p_fenc +delta, p_fenc +delta * 16, p_fenc +delta + delta * 16, 16, enc_dc);
            if (delta == 4)
                sums_base += stride * (h->fenc->i_lines[0] + 32 * 2);
            if (i_pixel == PIXEL_16x16 || i_pixel == PIXEL_8x16 || i_pixel == PIXEL_4x8)
                delta *= stride;
            if (i_pixel == PIXEL_8x16 || i_pixel == PIXEL_4x8)
                enc_dc[1] = enc_dc[2];
            if (h->mb.i_me_method == 4) {
                mvsad_t *mvsads = (mvsad_t *) (xs + ((width + 31) & ~31) + 4);
                int nmvsad = 0, limit;
                int sad_thresh = i_me_range <= 16 ? 10 : i_me_range <= 24 ? 11 : 12;
                int bsad = h->pixf.sad[i_pixel] (p_fenc, 16, p_fref_w +bmy * stride + bmx, stride) + (p_cost_mvx[(bmx) << 2] + p_cost_mvy[(bmy) << 2]);
                for (int my = min_y; my <= max_y; my++) {
                    int i;
                    int ycost = p_cost_mvy[my << 2];
                    if (bsad <= ycost)
                        continue;
                    bsad -= ycost;
                    xn = h->pixf.ads[i_pixel] (enc_dc, sums_base +min_x + my * stride, delta, cost_fpel_mvx +min_x, xs, width, bsad *17 >> 4);
                    for (i = 0; i < xn - 2; i += 3) {
                        pixel *ref = p_fref_w + min_x + my * stride;
                        int sads [4];
                        h->pixf.sad_x3[i_pixel] (p_fenc, ref +xs[i], ref +xs[i + 1], ref +xs[i + 2], stride, sads);
                        for (int j = 0; j < 3; j++) {
                            int sad = sads[j] + cost_fpel_mvx[xs[i + j]];
                            if (sad < bsad * sad_thresh >> 3) {
                                if ((sad) < (bsad))
                                    (bsad) = (sad);
                                ;
                                mvsads[nmvsad].sad = sad + ycost;
                                mvsads[nmvsad].mv[0] = min_x + xs[i + j];
                                mvsads[nmvsad].mv[1] = my;
                                nmvsad++;
                            }
                        }
                    }
                    for (; i < xn; i++) {
                        int mx = min_x + xs[i];
                        int sad = h->pixf.sad[i_pixel] (p_fenc, 16, p_fref_w +mx + my * stride, stride) + cost_fpel_mvx[xs[i]];
                        if (sad < bsad * sad_thresh >> 3) {
                            if ((sad) < (bsad))
                                (bsad) = (sad);
                            ;
                            mvsads[nmvsad].sad = sad + ycost;
                            mvsads[nmvsad].mv[0] = mx;
                            mvsads[nmvsad].mv[1] = my;
                            nmvsad++;
                        }
                    }
                    bsad += ycost;
                }
                limit = i_me_range >> 1;
                sad_thresh = bsad * sad_thresh >> 3;
                while (nmvsad > limit * 2 && sad_thresh > bsad) {
                    int i;
                    sad_thresh = (sad_thresh + bsad) >> 1;
                    for (i = 0; i < nmvsad && mvsads[i].sad <= sad_thresh; i++)
                        ;
                    for (int j = i; j < nmvsad; j++) {
                        uint32_t sad;
                        if (sizeof (void *) == 8 && sizeof (mvsad_t) == 8) {
                            uint64_t mvsad = (((x264_union64_t *) (&mvsads[i]))->i) = (((x264_union64_t *) (&mvsads[j]))->i);
                            sad = mvsad;
                        }
                        else {
                            sad = mvsads[j].sad;
                            (((x264_union32_t *) (mvsads[i].mv))->i) = (((x264_union32_t *) (mvsads[j].mv))->i);
                            mvsads[i].sad = sad;
                        }
                        i += (sad - (sad_thresh + 1)) >> 31;
                    }
                    nmvsad = i;
                }
                while (nmvsad > limit) {
                    int bi = 0;
                    for (int i = 1; i < nmvsad; i++)
                        if (mvsads[i].sad > mvsads[bi].sad)
                            bi = i;
                    nmvsad--;
                    if (sizeof (mvsad_t) == sizeof (uint64_t))
                        (((x264_union64_t *) (&mvsads[bi]))->i) = (((x264_union64_t *) (&mvsads[nmvsad]))->i);
                    else
                        mvsads[bi] = mvsads[nmvsad];
                }
                for (int i = 0; i < nmvsad; i++)
                    do {
                        int cost = h->pixf.fpelcmp[i_pixel] (p_fenc, 16, &p_fref_w[(mvsads[i].mv[1]) * stride + (mvsads[i].mv[0])], stride) + (p_cost_mvx[(mvsads[i].mv[0]) << 2] + p_cost_mvy[(mvsads[i].mv[1]) << 2]);
                        if ((cost) < (bcost)) {
                            (bcost) = (cost);
                            (bmx) = (mvsads[i].mv[0]);
                            (bmy) = (mvsads[i].mv[1]);
                        };
                    }
                    while (0);
            }
            else {
                for (int my = min_y; my <= max_y; my++) {
                    int i;
                    int ycost = p_cost_mvy[my << 2];
                    if (bcost <= ycost)
                        continue;
                    bcost -= ycost;
                    xn = h->pixf.ads[i_pixel] (enc_dc, sums_base +min_x + my * stride, delta, cost_fpel_mvx +min_x, xs, width, bcost);
                    for (i = 0; i < xn - 2; i += 3) {
                        h->pixf.fpelcmp_x3[i_pixel] (p_fenc, p_fref_w +(min_x + xs[i]) + (my) *stride, p_fref_w +(min_x + xs[i + 1]) + (my) *stride, p_fref_w +(min_x + xs[i + 2]) + (my) *stride, stride, costs);
                        costs[0] += p_cost_mvx[(min_x + xs[i]) << 2];
                        costs[1] += p_cost_mvx[(min_x + xs[i + 1]) << 2];
                        costs[2] += p_cost_mvx[(min_x + xs[i + 2]) << 2];
                        if ((costs[0]) < (bcost)) {
                            (bcost) = (costs[0]);
                            (bmx) = (min_x + xs[i]);
                            (bmy) = (my);
                        };
                        if ((costs[1]) < (bcost)) {
                            (bcost) = (costs[1]);
                            (bmx) = (min_x + xs[i + 1]);
                            (bmy) = (my);
                        };
                        if ((costs[2]) < (bcost)) {
                            (bcost) = (costs[2]);
                            (bmx) = (min_x + xs[i + 2]);
                            (bmy) = (my);
                        };
                    };
                    bcost += ycost;
                    for (; i < xn; i++)
                        do {
                            int cost = h->pixf.fpelcmp[i_pixel] (p_fenc, 16, &p_fref_w[(my) *stride + (min_x + xs[i])], stride) + (p_cost_mvx[(min_x + xs[i]) << 2] + p_cost_mvy[(my) << 2]);
                            if ((cost) < (bcost)) {
                                (bcost) = (cost);
                                (bmx) = (min_x + xs[i]);
                                (bmy) = (my);
                            };
                        }
                        while (0);
                }
            }
        }
        break;
    }
    uint32_t bmv = pack16to32_mask (bmx, bmy);
    uint32_t bmv_spel = (((bmv) << 2) & 0xFFFCFFFC);
    if (h->mb.i_subpel_refine < 3) {
        m->cost_mv = p_cost_mvx[bmx << 2] + p_cost_mvy[bmy << 2];
        m->cost = bcost;
        if (bmv == pmv)
            m->cost += m->cost_mv;
        (((x264_union32_t *) (m->mv))->i) = bmv_spel;
    }
    else {
        (((x264_union32_t *) (m->mv))->i) = bpred_cost < bcost ? bpred_mv : bmv_spel;
        m->cost = ((bpred_cost) < (bcost) ? (bpred_cost) : (bcost));
    }
    if (h->mb.i_subpel_refine >= 2) {
        int hpel = subpel_iterations[h->mb.i_subpel_refine][2];
        int qpel = subpel_iterations[h->mb.i_subpel_refine][3];
        refine_subpel (h, m, hpel, qpel, p_halfpel_thresh, 0);
    }
}

void x264_me_refine_qpel (x264_t *h, x264_me_t *m) {
    int hpel = subpel_iterations[h->mb.i_subpel_refine][0];
    int qpel = subpel_iterations[h->mb.i_subpel_refine][1];
    if (m->i_pixel <= PIXEL_8x8)
        m->cost -= m->i_ref_cost;
    refine_subpel (h, m, hpel, qpel, ((void *) 0), 1);
}

void x264_me_refine_qpel_refdupe (x264_t *h, x264_me_t *m, int *p_halfpel_thresh) {
    refine_subpel (h, m, 0, ((2) < (subpel_iterations [h -> mb.i_subpel_refine] [3]) ? (2) : (subpel_iterations [h -> mb.i_subpel_refine] [3])), p_halfpel_thresh, 0);
}

void refine_subpel (x264_t *h, x264_me_t *m, int hpel_iters, int qpel_iters, int *p_halfpel_thresh, int b_refine_qpel) {
    const int bw = x264_pixel_size[m->i_pixel].w;
    const int bh = x264_pixel_size[m->i_pixel].h;
    const uint16_t *p_cost_mvx = m->p_cost_mv - m->mvp[0];
    const uint16_t *p_cost_mvy = m->p_cost_mv - m->mvp[1];
    const int i_pixel = m->i_pixel;
    const int b_chroma_me = h->mb.b_chroma_me && (i_pixel <= PIXEL_8x8 || (h->sps->i_chroma_format_idc == CHROMA_444));
    int chromapix = h->luma2chroma_pixel[i_pixel];
    int chroma_v_shift = h->mb.chroma_v_shift;
    int mvy_offset = chroma_v_shift & 0 & m->i_ref ? (h->mb.i_mb_y & 1) * 4 - 2 : 0;
    uint8_t pix_u [sizeof (pixel[64 * 18]) + 31];
    pixel (*pix) = (void *) ((intptr_t) (pix_u + 31) & ~31);
    int costs [4];
    int bmx = m->mv[0];
    int bmy = m->mv[1];
    int bcost = m->cost;
    int odir = -1, bdir;
    if (hpel_iters) {
        if (h->mb.i_subpel_refine < 3) {
            int mx = x264_clip3 (m->mvp[0], h->mb.mv_min_spel[0] + 2, h->mb.mv_max_spel[0] - 2);
            int my = x264_clip3 (m->mvp[1], h->mb.mv_min_spel[1] + 2, h->mb.mv_max_spel[1] - 2);
            if ((mx - bmx) | (my - bmy)) {
                intptr_t stride = 16;
                pixel *src = h->mc.get_ref (pix, &stride, m->p_fref, m->i_stride[0], mx, my, bw, bh, &m->weight[0]);
                int cost = h->pixf.fpelcmp[i_pixel] (m->p_fenc[0], 16, src, stride) + p_cost_mvx[mx] + p_cost_mvy[my];
                if ((cost) < (bcost)) {
                    (bcost) = (cost);
                    (bmx) = (mx);
                    (bmy) = (my);
                };
            };
        }
        bcost <<= 6;
        for (int i = hpel_iters; i > 0; i--) {
            int omx = bmx, omy = bmy;
            intptr_t stride = 64;
            pixel *src0, *src1, *src2, *src3;
            src0 = h->mc.get_ref (pix, &stride, m->p_fref, m->i_stride[0], omx, omy -2, bw, bh +1, &m->weight[0]);
            src2 = h->mc.get_ref (pix +32, &stride, m->p_fref, m->i_stride[0], omx -2, omy, bw +4, bh, &m->weight[0]);
            src1 = src0 + stride;
            src3 = src2 + 1;
            h->pixf.fpelcmp_x4[i_pixel] (m->p_fenc[0], src0, src1, src2, src3, stride, costs);
            costs[0] += p_cost_mvx[omx] + p_cost_mvy[omy - 2];
            costs[1] += p_cost_mvx[omx] + p_cost_mvy[omy + 2];
            costs[2] += p_cost_mvx[omx - 2] + p_cost_mvy[omy];
            costs[3] += p_cost_mvx[omx + 2] + p_cost_mvy[omy];
            if (((costs[0] << 6) + 2) < (bcost))
                (bcost) = ((costs[0] << 6) + 2);
            ;
            if (((costs[1] << 6) + 6) < (bcost))
                (bcost) = ((costs[1] << 6) + 6);
            ;
            if (((costs[2] << 6) + 16) < (bcost))
                (bcost) = ((costs[2] << 6) + 16);
            ;
            if (((costs[3] << 6) + 48) < (bcost))
                (bcost) = ((costs[3] << 6) + 48);
            ;
            if (!(bcost & 63))
                break;
            bmx -= (bcost << 26) >> 29;
            bmy -= (bcost << 29) >> 29;
            bcost &= ~63;
        }
        bcost >>= 6;
    }
    if (!b_refine_qpel && (h->pixf.mbcmp_unaligned[0] != h->pixf.fpelcmp[0] || b_chroma_me)) {
        bcost = (1 << 28);
        if (b_refine_qpel || (-1 ^ 1) != odir) {
            intptr_t stride = 16;
            pixel *src = h->mc.get_ref (pix, &stride, &m->p_fref[0], m->i_stride[0], bmx, bmy, bw, bh, &m->weight[0]);
            int cost = h->pixf.mbcmp_unaligned[i_pixel] (m->p_fenc[0], 16, src, stride) + p_cost_mvx[bmx] + p_cost_mvy[bmy];
            if (b_chroma_me && cost < bcost) {
                if ((h->sps->i_chroma_format_idc == CHROMA_444)) {
                    stride = 16;
                    src = h->mc.get_ref (pix, &stride, &m->p_fref[4], m->i_stride[1], bmx, bmy, bw, bh, &m->weight[1]);
                    cost += h->pixf.mbcmp_unaligned[i_pixel] (m->p_fenc[1], 16, src, stride);
                    if (cost < bcost) {
                        stride = 16;
                        src = h->mc.get_ref (pix, &stride, &m->p_fref[8], m->i_stride[2], bmx, bmy, bw, bh, &m->weight[2]);
                        cost += h->pixf.mbcmp_unaligned[i_pixel] (m->p_fenc[2], 16, src, stride);
                    }
                }
                else {
                    h->mc.mc_chroma (pix, pix +8, 16, m->p_fref[4], m->i_stride[1], bmx, 2 * (bmy + mvy_offset) >> chroma_v_shift, bw >> 1, bh >> chroma_v_shift);
                    if (m->weight[1].weightfn)
                        m->weight[1].weightfn[bw >> 3] (pix, 16, pix, 16, &m->weight[1], bh >> chroma_v_shift);
                    cost += h->pixf.mbcmp[chromapix] (m->p_fenc[1], 16, pix, 16);
                    if (cost < bcost) {
                        if (m->weight[2].weightfn)
                            m->weight[2].weightfn[bw >> 3] (pix +8, 16, pix +8, 16, &m->weight[2], bh >> chroma_v_shift);
                        cost += h->pixf.mbcmp[chromapix] (m->p_fenc[2], 16, pix +8, 16);
                    }
                }
            }
            if ((cost) < (bcost)) {
                (bcost) = (cost);
                (bmx) = (bmx);
                (bmy) = (bmy);
                (bdir) = (-1);
            };
        };
    }
    if (p_halfpel_thresh) {
        if ((bcost * 7) >> 3 > *p_halfpel_thresh) {
            m->cost = bcost;
            m->mv[0] = bmx;
            m->mv[1] = bmy;
            return;
        }
        else if (bcost < *p_halfpel_thresh)
            *p_halfpel_thresh = bcost;
    }
    if (h->mb.i_subpel_refine != 1) {
        bdir = -1;
        for (int i = qpel_iters; i > 0; i--) {
            if (bmy <= h->mb.mv_min_spel[1] || bmy >= h->mb.mv_max_spel[1] || bmx <= h->mb.mv_min_spel[0] || bmx >= h->mb.mv_max_spel[0])
                break;
            odir = bdir;
            int omx = bmx, omy = bmy;
            if (b_refine_qpel || (0 ^ 1) != odir) {
                intptr_t stride = 16;
                pixel *src = h->mc.get_ref (pix, &stride, &m->p_fref[0], m->i_stride[0], omx, omy -1, bw, bh, &m->weight[0]);
                int cost = h->pixf.mbcmp_unaligned[i_pixel] (m->p_fenc[0], 16, src, stride) + p_cost_mvx[omx] + p_cost_mvy[omy - 1];
                if (b_chroma_me && cost < bcost) {
                    if ((h->sps->i_chroma_format_idc == CHROMA_444)) {
                        stride = 16;
                        src = h->mc.get_ref (pix, &stride, &m->p_fref[4], m->i_stride[1], omx, omy -1, bw, bh, &m->weight[1]);
                        cost += h->pixf.mbcmp_unaligned[i_pixel] (m->p_fenc[1], 16, src, stride);
                        if (cost < bcost) {
                            stride = 16;
                            src = h->mc.get_ref (pix, &stride, &m->p_fref[8], m->i_stride[2], omx, omy -1, bw, bh, &m->weight[2]);
                            cost += h->pixf.mbcmp_unaligned[i_pixel] (m->p_fenc[2], 16, src, stride);
                        }
                    }
                    else {
                        h->mc.mc_chroma (pix, pix +8, 16, m->p_fref[4], m->i_stride[1], omx, 2 * (omy - 1 + mvy_offset) >> chroma_v_shift, bw >> 1, bh >> chroma_v_shift);
                        if (m->weight[1].weightfn)
                            m->weight[1].weightfn[bw >> 3] (pix, 16, pix, 16, &m->weight[1], bh >> chroma_v_shift);
                        cost += h->pixf.mbcmp[chromapix] (m->p_fenc[1], 16, pix, 16);
                        if (cost < bcost) {
                            if (m->weight[2].weightfn)
                                m->weight[2].weightfn[bw >> 3] (pix +8, 16, pix +8, 16, &m->weight[2], bh >> chroma_v_shift);
                            cost += h->pixf.mbcmp[chromapix] (m->p_fenc[2], 16, pix +8, 16);
                        }
                    }
                }
                if ((cost) < (bcost)) {
                    (bcost) = (cost);
                    (bmx) = (omx);
                    (bmy) = (omy - 1);
                    (bdir) = (0);
                };
            };
            if (b_refine_qpel || (1 ^ 1) != odir) {
                intptr_t stride = 16;
                pixel *src = h->mc.get_ref (pix, &stride, &m->p_fref[0], m->i_stride[0], omx, omy +1, bw, bh, &m->weight[0]);
                int cost = h->pixf.mbcmp_unaligned[i_pixel] (m->p_fenc[0], 16, src, stride) + p_cost_mvx[omx] + p_cost_mvy[omy + 1];
                if (b_chroma_me && cost < bcost) {
                    if ((h->sps->i_chroma_format_idc == CHROMA_444)) {
                        stride = 16;
                        src = h->mc.get_ref (pix, &stride, &m->p_fref[4], m->i_stride[1], omx, omy +1, bw, bh, &m->weight[1]);
                        cost += h->pixf.mbcmp_unaligned[i_pixel] (m->p_fenc[1], 16, src, stride);
                        if (cost < bcost) {
                            stride = 16;
                            src = h->mc.get_ref (pix, &stride, &m->p_fref[8], m->i_stride[2], omx, omy +1, bw, bh, &m->weight[2]);
                            cost += h->pixf.mbcmp_unaligned[i_pixel] (m->p_fenc[2], 16, src, stride);
                        }
                    }
                    else {
                        h->mc.mc_chroma (pix, pix +8, 16, m->p_fref[4], m->i_stride[1], omx, 2 * (omy + 1 + mvy_offset) >> chroma_v_shift, bw >> 1, bh >> chroma_v_shift);
                        if (m->weight[1].weightfn)
                            m->weight[1].weightfn[bw >> 3] (pix, 16, pix, 16, &m->weight[1], bh >> chroma_v_shift);
                        cost += h->pixf.mbcmp[chromapix] (m->p_fenc[1], 16, pix, 16);
                        if (cost < bcost) {
                            if (m->weight[2].weightfn)
                                m->weight[2].weightfn[bw >> 3] (pix +8, 16, pix +8, 16, &m->weight[2], bh >> chroma_v_shift);
                            cost += h->pixf.mbcmp[chromapix] (m->p_fenc[2], 16, pix +8, 16);
                        }
                    }
                }
                if ((cost) < (bcost)) {
                    (bcost) = (cost);
                    (bmx) = (omx);
                    (bmy) = (omy + 1);
                    (bdir) = (1);
                };
            };
            if (b_refine_qpel || (2 ^ 1) != odir) {
                intptr_t stride = 16;
                pixel *src = h->mc.get_ref (pix, &stride, &m->p_fref[0], m->i_stride[0], omx -1, omy, bw, bh, &m->weight[0]);
                int cost = h->pixf.mbcmp_unaligned[i_pixel] (m->p_fenc[0], 16, src, stride) + p_cost_mvx[omx - 1] + p_cost_mvy[omy];
                if (b_chroma_me && cost < bcost) {
                    if ((h->sps->i_chroma_format_idc == CHROMA_444)) {
                        stride = 16;
                        src = h->mc.get_ref (pix, &stride, &m->p_fref[4], m->i_stride[1], omx -1, omy, bw, bh, &m->weight[1]);
                        cost += h->pixf.mbcmp_unaligned[i_pixel] (m->p_fenc[1], 16, src, stride);
                        if (cost < bcost) {
                            stride = 16;
                            src = h->mc.get_ref (pix, &stride, &m->p_fref[8], m->i_stride[2], omx -1, omy, bw, bh, &m->weight[2]);
                            cost += h->pixf.mbcmp_unaligned[i_pixel] (m->p_fenc[2], 16, src, stride);
                        }
                    }
                    else {
                        h->mc.mc_chroma (pix, pix +8, 16, m->p_fref[4], m->i_stride[1], omx -1, 2 * (omy + mvy_offset) >> chroma_v_shift, bw >> 1, bh >> chroma_v_shift);
                        if (m->weight[1].weightfn)
                            m->weight[1].weightfn[bw >> 3] (pix, 16, pix, 16, &m->weight[1], bh >> chroma_v_shift);
                        cost += h->pixf.mbcmp[chromapix] (m->p_fenc[1], 16, pix, 16);
                        if (cost < bcost) {
                            if (m->weight[2].weightfn)
                                m->weight[2].weightfn[bw >> 3] (pix +8, 16, pix +8, 16, &m->weight[2], bh >> chroma_v_shift);
                            cost += h->pixf.mbcmp[chromapix] (m->p_fenc[2], 16, pix +8, 16);
                        }
                    }
                }
                if ((cost) < (bcost)) {
                    (bcost) = (cost);
                    (bmx) = (omx - 1);
                    (bmy) = (omy);
                    (bdir) = (2);
                };
            };
            if (b_refine_qpel || (3 ^ 1) != odir) {
                intptr_t stride = 16;
                pixel *src = h->mc.get_ref (pix, &stride, &m->p_fref[0], m->i_stride[0], omx +1, omy, bw, bh, &m->weight[0]);
                int cost = h->pixf.mbcmp_unaligned[i_pixel] (m->p_fenc[0], 16, src, stride) + p_cost_mvx[omx + 1] + p_cost_mvy[omy];
                if (b_chroma_me && cost < bcost) {
                    if ((h->sps->i_chroma_format_idc == CHROMA_444)) {
                        stride = 16;
                        src = h->mc.get_ref (pix, &stride, &m->p_fref[4], m->i_stride[1], omx +1, omy, bw, bh, &m->weight[1]);
                        cost += h->pixf.mbcmp_unaligned[i_pixel] (m->p_fenc[1], 16, src, stride);
                        if (cost < bcost) {
                            stride = 16;
                            src = h->mc.get_ref (pix, &stride, &m->p_fref[8], m->i_stride[2], omx +1, omy, bw, bh, &m->weight[2]);
                            cost += h->pixf.mbcmp_unaligned[i_pixel] (m->p_fenc[2], 16, src, stride);
                        }
                    }
                    else {
                        h->mc.mc_chroma (pix, pix +8, 16, m->p_fref[4], m->i_stride[1], omx +1, 2 * (omy + mvy_offset) >> chroma_v_shift, bw >> 1, bh >> chroma_v_shift);
                        if (m->weight[1].weightfn)
                            m->weight[1].weightfn[bw >> 3] (pix, 16, pix, 16, &m->weight[1], bh >> chroma_v_shift);
                        cost += h->pixf.mbcmp[chromapix] (m->p_fenc[1], 16, pix, 16);
                        if (cost < bcost) {
                            if (m->weight[2].weightfn)
                                m->weight[2].weightfn[bw >> 3] (pix +8, 16, pix +8, 16, &m->weight[2], bh >> chroma_v_shift);
                            cost += h->pixf.mbcmp[chromapix] (m->p_fenc[2], 16, pix +8, 16);
                        }
                    }
                }
                if ((cost) < (bcost)) {
                    (bcost) = (cost);
                    (bmx) = (omx + 1);
                    (bmy) = (omy);
                    (bdir) = (3);
                };
            };
            if ((bmx == omx) & (bmy == omy))
                break;
        }
    }
    else if (bmy > h->mb.mv_min_spel[1] && bmy < h->mb.mv_max_spel[1] && bmx > h->mb.mv_min_spel[0] && bmx < h->mb.mv_max_spel[0]) {
        int omx = bmx, omy = bmy;
        h->mc.mc_luma (pix, 64, m->p_fref, m->i_stride[0], omx, omy -1, bw, bh, &m->weight[0]);
        h->mc.mc_luma (pix +16, 64, m->p_fref, m->i_stride[0], omx, omy +1, bw, bh, &m->weight[0]);
        h->mc.mc_luma (pix +32, 64, m->p_fref, m->i_stride[0], omx -1, omy, bw, bh, &m->weight[0]);
        h->mc.mc_luma (pix +48, 64, m->p_fref, m->i_stride[0], omx +1, omy, bw, bh, &m->weight[0]);
        h->pixf.fpelcmp_x4[i_pixel] (m->p_fenc[0], pix, pix +16, pix +32, pix +48, 64, costs);
        costs[0] += p_cost_mvx[omx] + p_cost_mvy[omy - 1];
        costs[1] += p_cost_mvx[omx] + p_cost_mvy[omy + 1];
        costs[2] += p_cost_mvx[omx - 1] + p_cost_mvy[omy];
        costs[3] += p_cost_mvx[omx + 1] + p_cost_mvy[omy];
        bcost <<= 4;
        if (((costs[0] << 4) + 1) < (bcost))
            (bcost) = ((costs[0] << 4) + 1);
        ;
        if (((costs[1] << 4) + 3) < (bcost))
            (bcost) = ((costs[1] << 4) + 3);
        ;
        if (((costs[2] << 4) + 4) < (bcost))
            (bcost) = ((costs[2] << 4) + 4);
        ;
        if (((costs[3] << 4) + 12) < (bcost))
            (bcost) = ((costs[3] << 4) + 12);
        ;
        bmx -= (bcost << 28) >> 30;
        bmy -= (bcost << 30) >> 30;
        bcost >>= 4;
    }
    m->cost = bcost;
    m->mv[0] = bmx;
    m->mv[1] = bmy;
    m->cost_mv = p_cost_mvx[bmx] + p_cost_mvy[bmy];
}

int x264_iter_kludge = 0;

void x264_me_refine_bidir (x264_t *h, x264_me_t *m0, x264_me_t *m1, int i_weight, int i8, int i_lambda2, int rd) {
    int x = i8 & 1;
    int y = i8 >> 1;
    int s8 = (4 + 1 * 8) + 2 * x + 16 * y;
    int16_t *cache0_mv = h->mb.cache.mv[0][s8];
    int16_t *cache1_mv = h->mb.cache.mv[1][s8];
    const int i_pixel = m0->i_pixel;
    const int bw = x264_pixel_size[i_pixel].w;
    const int bh = x264_pixel_size[i_pixel].h;
    uint8_t pixy_buf_u [sizeof (pixel[2][9][16 * 16]) + 31];
    pixel (*pixy_buf) [9] [16 * 16] = (void *) ((intptr_t) (pixy_buf_u + 31) & ~31);
    uint8_t pixu_buf_u [sizeof (pixel[2][9][16 * 16]) + 31];
    pixel (*pixu_buf) [9] [16 * 16] = (void *) ((intptr_t) (pixu_buf_u + 31) & ~31);
    uint8_t pixv_buf_u [sizeof (pixel[2][9][16 * 16]) + 31];
    pixel (*pixv_buf) [9] [16 * 16] = (void *) ((intptr_t) (pixv_buf_u + 31) & ~31);
    pixel *src [3] [2] [9];
    int chromapix = h->luma2chroma_pixel[i_pixel];
    int chroma_v_shift = h->mb.chroma_v_shift;
    int chroma_x = (8 >> h->mb.chroma_h_shift) * x;
    int chroma_y = (8 >> chroma_v_shift) * y;
    pixel *pix = &h->mb.pic.p_fdec[0][8 * x + 8 * y * 32];
    pixel *pixu = &h->mb.pic.p_fdec[1][chroma_x + chroma_y * 32];
    pixel *pixv = &h->mb.pic.p_fdec[2][chroma_x + chroma_y * 32];
    int ref0 = h->mb.cache.ref[0][s8];
    int ref1 = h->mb.cache.ref[1][s8];
    const int mv0y_offset = chroma_v_shift & 0 & ref0 ? (h->mb.i_mb_y & 1) * 4 - 2 : 0;
    const int mv1y_offset = chroma_v_shift & 0 & ref1 ? (h->mb.i_mb_y & 1) * 4 - 2 : 0;
    intptr_t stride [3] [2] [9];
    int bm0x = m0->mv[0];
    int bm0y = m0->mv[1];
    int bm1x = m1->mv[0];
    int bm1y = m1->mv[1];
    int bcost = (1 << 28);
    int mc_list0 = 1, mc_list1 = 1;
    uint64_t bcostrd = (1ULL << 60);
    uint16_t amvd;
    uint8_t visited_u [sizeof (uint8_t[8][8][8]) + 31];
    uint8_t (*visited) [8] [8] = (void *) ((intptr_t) (visited_u + 31) & ~31);
    const int8_t dia4d [33] [4] = {{0, 0, 0, 0}, {0, 0, 0, 1}, {0, 0, 0, -1}, {0, 0, 1, 0}, {0, 0, -1, 0}, {0, 1, 0, 0}, {0, -1, 0, 0}, {1, 0, 0, 0}, {-1, 0, 0, 0}, {0, 0, 1, 1}, {0, 0, -1, -1}, {0, 1, 1, 0}, {0, -1, -1, 0}, {1, 1, 0, 0}, {-1, -1, 0, 0}, {1, 0, 0, 1}, {-1, 0, 0, -1}, {0, 1, 0, 1}, {0, -1, 0, -1}, {1, 0, 1, 0}, {-1, 0, -1, 0}, {0, 0, -1, 1}, {0, 0, 1, -1}, {0, -1, 1, 0}, {0, 1, -1, 0}, {-1, 1, 0, 0}, {1, -1, 0, 0}, {1, 0, 0, -1}, {-1, 0, 0, 1}, {0, -1, 0, 1}, {0, 1, 0, -1}, {-1, 0, 1, 0}, {1, 0, -1, 0},};
    if (bm0y < h->mb.mv_min_spel[1] + 8 || bm1y < h->mb.mv_min_spel[1] + 8 || bm0y > h->mb.mv_max_spel[1] - 8 || bm1y > h->mb.mv_max_spel[1] - 8 || bm0x < h->mb.mv_min_spel[0] + 8 || bm1x < h->mb.mv_min_spel[0] + 8 || bm0x > h->mb.mv_max_spel[0] - 8 || bm1x > h->mb.mv_max_spel[0] - 8)
        return;
    if (rd && m0->i_pixel != PIXEL_16x16 && i8 != 0) {
        x264_mb_predict_mv (h, 0, i8 << 2, bw >> 2, m0 -> mvp);
        x264_mb_predict_mv (h, 1, i8 << 2, bw >> 2, m1 -> mvp);
    }
    const uint16_t *p_cost_m0x = m0->p_cost_mv - m0->mvp[0];
    const uint16_t *p_cost_m0y = m0->p_cost_mv - m0->mvp[1];
    const uint16_t *p_cost_m1x = m1->p_cost_mv - m1->mvp[0];
    const uint16_t *p_cost_m1y = m1->p_cost_mv - m1->mvp[1];
    h->mc.memzero_aligned (visited, sizeof (uint8_t[8][8][8]));
    for (int pass = 0; pass < 8; pass++) {
        int bestj = 0;
        if (mc_list0)
            for (int j = x264_iter_kludge; j < 9; j++) {
                x264_me_t *m = m0;
                int i = 4 + 3 * square1[j][0] + square1[j][1];
                int mvx = bm0x + square1[j][0];
                int mvy = bm0y + square1[j][1];
                stride[0][0][i] = bw;
                src[0][0][i] = h->mc.get_ref (pixy_buf[0][i], &stride[0][0][i], &m->p_fref[0], m->i_stride[0], mvx, mvy, bw, bh, x264_weight_none);
                if (rd) {
                    if ((h->sps->i_chroma_format_idc == CHROMA_444)) {
                        stride[1][0][i] = bw;
                        src[1][0][i] = h->mc.get_ref (pixu_buf[0][i], &stride[1][0][i], &m->p_fref[4], m->i_stride[1], mvx, mvy, bw, bh, x264_weight_none);
                        stride[2][0][i] = bw;
                        src[2][0][i] = h->mc.get_ref (pixv_buf[0][i], &stride[2][0][i], &m->p_fref[8], m->i_stride[2], mvx, mvy, bw, bh, x264_weight_none);
                    }
                    else
                        h->mc.mc_chroma (pixu_buf[0][i], pixv_buf[0][i], 8, m->p_fref[4], m->i_stride[1], mvx, 2 * (mvy + mv0y_offset) >> chroma_v_shift, bw >> 1, bh >> chroma_v_shift);
                }
            };
        if (mc_list1)
            for (int j = x264_iter_kludge; j < 9; j++) {
                x264_me_t *m = m1;
                int i = 4 + 3 * square1[j][0] + square1[j][1];
                int mvx = bm1x + square1[j][0];
                int mvy = bm1y + square1[j][1];
                stride[0][1][i] = bw;
                src[0][1][i] = h->mc.get_ref (pixy_buf[1][i], &stride[0][1][i], &m->p_fref[0], m->i_stride[0], mvx, mvy, bw, bh, x264_weight_none);
                if (rd) {
                    if ((h->sps->i_chroma_format_idc == CHROMA_444)) {
                        stride[1][1][i] = bw;
                        src[1][1][i] = h->mc.get_ref (pixu_buf[1][i], &stride[1][1][i], &m->p_fref[4], m->i_stride[1], mvx, mvy, bw, bh, x264_weight_none);
                        stride[2][1][i] = bw;
                        src[2][1][i] = h->mc.get_ref (pixv_buf[1][i], &stride[2][1][i], &m->p_fref[8], m->i_stride[2], mvx, mvy, bw, bh, x264_weight_none);
                    }
                    else
                        h->mc.mc_chroma (pixu_buf[1][i], pixv_buf[1][i], 8, m->p_fref[4], m->i_stride[1], mvx, 2 * (mvy + mv1y_offset) >> chroma_v_shift, bw >> 1, bh >> chroma_v_shift);
                }
            };
        for (int j = !!pass; j < 33; j++) {
            int m0x = dia4d[j][0] + bm0x;
            int m0y = dia4d[j][1] + bm0y;
            int m1x = dia4d[j][2] + bm1x;
            int m1y = dia4d[j][3] + bm1y;
            if (!pass || !((visited[(m0x) &7][(m0y) &7][(m1x) &7] & (1 << ((m1y) &7))))) {
                int i0 = 4 + 3 * dia4d[j][0] + dia4d[j][1];
                int i1 = 4 + 3 * dia4d[j][2] + dia4d[j][3];
                visited[(m0x) &7][(m0y) &7][(m1x) &7] |= (1 << ((m1y) &7));
                h->mc.avg[i_pixel] (pix, 32, src[0][0][i0], stride[0][0][i0], src[0][1][i1], stride[0][1][i1], i_weight);
                int cost = h->pixf.mbcmp[i_pixel] (m0->p_fenc[0], 16, pix, 32) + p_cost_m0x[m0x] + p_cost_m0y[m0y] + p_cost_m1x[m1x] + p_cost_m1y[m1y];
                if (rd) {
                    if (cost < (bcost + (bcost >> 4))) {
                        bcost = ((cost) < (bcost) ? (cost) : (bcost));
                        (((x264_union32_t *) (cache0_mv))->i) = pack16to32_mask (m0x, m0y);
                        (((x264_union32_t *) (cache1_mv))->i) = pack16to32_mask (m1x, m1y);
                        if ((h->sps->i_chroma_format_idc == CHROMA_444)) {
                            h->mc.avg[i_pixel] (pixu, 32, src[1][0][i0], stride[1][0][i0], src[1][1][i1], stride[1][1][i1], i_weight);
                            h->mc.avg[i_pixel] (pixv, 32, src[2][0][i0], stride[2][0][i0], src[2][1][i1], stride[2][1][i1], i_weight);
                        }
                        else {
                            h->mc.avg[chromapix] (pixu, 32, pixu_buf[0][i0], 8, pixu_buf[1][i1], 8, i_weight);
                            h->mc.avg[chromapix] (pixv, 32, pixv_buf[0][i0], 8, pixv_buf[1][i1], 8, i_weight);
                        }
                        uint64_t costrd = x264_rd_cost_part (h, i_lambda2, i8 *4, m0->i_pixel);
                        if ((costrd) < (bcostrd)) {
                            (bcostrd) = (costrd);
                            (bestj) = (j);
                        };
                    }
                }
                else if ((cost) < (bcost)) {
                    (bcost) = (cost);
                    (bestj) = (j);
                };
            }
        }
        if (!bestj)
            break;
        bm0x += dia4d[bestj][0];
        bm0y += dia4d[bestj][1];
        bm1x += dia4d[bestj][2];
        bm1y += dia4d[bestj][3];
        mc_list0 = (((x264_union16_t *) (&dia4d[bestj][0]))->i);
        mc_list1 = (((x264_union16_t *) (&dia4d[bestj][2]))->i);
    }
    if (rd) {
        x264_macroblock_cache_mv (h, 2 * x, 2 * y, bw >> 2, bh >> 2, 0, pack16to32_mask (bm0x, bm0y));
        amvd = pack8to16 (((abs (bm0x -m0->mvp[0])) < (33) ? (abs (bm0x -m0->mvp[0])) : (33)), ((abs (bm0y -m0->mvp[1])) < (33) ? (abs (bm0y -m0->mvp[1])) : (33)));
        x264_macroblock_cache_mvd (h, 2 * x, 2 * y, bw >> 2, bh >> 2, 0, amvd);
        x264_macroblock_cache_mv (h, 2 * x, 2 * y, bw >> 2, bh >> 2, 1, pack16to32_mask (bm1x, bm1y));
        amvd = pack8to16 (((abs (bm1x -m1->mvp[0])) < (33) ? (abs (bm1x -m1->mvp[0])) : (33)), ((abs (bm1y -m1->mvp[1])) < (33) ? (abs (bm1y -m1->mvp[1])) : (33)));
        x264_macroblock_cache_mvd (h, 2 * x, 2 * y, bw >> 2, bh >> 2, 1, amvd);
    }
    m0->mv[0] = bm0x;
    m0->mv[1] = bm0y;
    m1->mv[0] = bm1x;
    m1->mv[1] = bm1y;
}

void x264_me_refine_bidir_satd (x264_t *h, x264_me_t *m0, x264_me_t *m1, int i_weight) {
    x264_me_refine_bidir (h, m0, m1, i_weight, 0, 0, 0);
}

void x264_me_refine_bidir_rd (x264_t *h, x264_me_t *m0, x264_me_t *m1, int i_weight, int i8, int i_lambda2) {
    h->mb.b_skip_mc = 1;
    x264_me_refine_bidir (h, m0, m1, i_weight, i8, i_lambda2, 1);
    h->mb.b_skip_mc = 0;
}

void x264_me_refine_qpel_rd (x264_t *h, x264_me_t *m, int i_lambda2, int i4, int i_list) {
    int16_t *cache_mv = h->mb.cache.mv[i_list][x264_scan8[i4]];
    const uint16_t *p_cost_mvx, *p_cost_mvy;
    const int bw = x264_pixel_size[m->i_pixel].w;
    const int bh = x264_pixel_size[m->i_pixel].h;
    const int i_pixel = m->i_pixel;
    int chroma_v_shift = h->mb.chroma_v_shift;
    int mvy_offset = chroma_v_shift & 0 & m->i_ref ? (h->mb.i_mb_y & 1) * 4 - 2 : 0;
    uint64_t bcost = (1ULL << 60);
    int bmx = m->mv[0];
    int bmy = m->mv[1];
    int omx, omy, pmx, pmy;
    int satd, bsatd;
    int dir = -2;
    int i8 = i4 >> 2;
    uint16_t amvd;
    pixel *pix = &h->mb.pic.p_fdec[0][block_idx_xy_fdec[i4]];
    pixel *pixu, *pixv;
    if ((h->sps->i_chroma_format_idc == CHROMA_444)) {
        pixu = &h->mb.pic.p_fdec[1][block_idx_xy_fdec[i4]];
        pixv = &h->mb.pic.p_fdec[2][block_idx_xy_fdec[i4]];
    }
    else {
        pixu = &h->mb.pic.p_fdec[1][(i8 >> 1) * (8 * 32 >> chroma_v_shift) + (i8 & 1) * 4];
        pixv = &h->mb.pic.p_fdec[2][(i8 >> 1) * (8 * 32 >> chroma_v_shift) + (i8 & 1) * 4];
    }
    h->mb.b_skip_mc = 1;
    if (m->i_pixel != PIXEL_16x16 && i4 != 0)
        x264_mb_predict_mv (h, i_list, i4, bw >> 2, m->mvp);
    pmx = m->mvp[0];
    pmy = m->mvp[1];
    p_cost_mvx = m->p_cost_mv - pmx;
    p_cost_mvy = m->p_cost_mv - pmy;
    {
        if (!0 || !(bmx == pmx && bmy == pmy)) {
            h->mc.mc_luma (pix, 32, m->p_fref, m->i_stride[0], bmx, bmy, bw, bh, &m->weight[0]);
            bsatd = h->pixf.mbcmp[i_pixel] (m->p_fenc[0], 16, pix, 32) + p_cost_mvx[bmx] + p_cost_mvy[bmy];
            if ((bsatd) < (bsatd))
                (bsatd) = (bsatd);
            ;
        }
        else
            bsatd = (1 << 28);
    };
    if (m->i_pixel != PIXEL_16x16) {
        if (0 <= (bsatd + (bsatd >> 4))) {
            uint64_t cost;
            (((x264_union32_t *) (cache_mv))->i) = pack16to32_mask (bmx, bmy);
            if ((h->sps->i_chroma_format_idc == CHROMA_444)) {
                h->mc.mc_luma (pixu, 32, &m->p_fref[4], m->i_stride[1], bmx, bmy, bw, bh, &m->weight[1]);
                h->mc.mc_luma (pixv, 32, &m->p_fref[8], m->i_stride[2], bmx, bmy, bw, bh, &m->weight[2]);
            }
            else if (m->i_pixel <= PIXEL_8x8) {
                h->mc.mc_chroma (pixu, pixv, 32, m->p_fref[4], m->i_stride[1], bmx, 2 * (bmy + mvy_offset) >> chroma_v_shift, bw >> 1, bh >> chroma_v_shift);
                if (m->weight[1].weightfn)
                    m->weight[1].weightfn[bw >> 3] (pixu, 32, pixu, 32, &m->weight[1], bh >> chroma_v_shift);
                if (m->weight[2].weightfn)
                    m->weight[2].weightfn[bw >> 3] (pixv, 32, pixv, 32, &m->weight[2], bh >> chroma_v_shift);
            }
            cost = x264_rd_cost_part (h, i_lambda2, i4, m->i_pixel);
            if ((cost) < (bcost)) {
                (bcost) = (cost);
                (bmx) = (bmx);
                (bmy) = (bmy);
                (dir) = (0 ? 0 : dir);
            };
        }
    }
    else
        bcost = m->cost;
    if ((bmx != pmx || bmy != pmy) && pmx >= h->mb.mv_min_spel[0] && pmx <= h->mb.mv_max_spel[0] && pmy >= h->mb.mv_min_spel[1] && pmy <= h->mb.mv_max_spel[1]) {
        {
            if (!0 || !(pmx == pmx && pmy == pmy)) {
                h->mc.mc_luma (pix, 32, m->p_fref, m->i_stride[0], pmx, pmy, bw, bh, &m->weight[0]);
                satd = h->pixf.mbcmp[i_pixel] (m->p_fenc[0], 16, pix, 32) + p_cost_mvx[pmx] + p_cost_mvy[pmy];
                if ((satd) < (bsatd))
                    (bsatd) = (satd);
                ;
            }
            else
                satd = (1 << 28);
        };
        {
            if (satd <= (bsatd + (bsatd >> 4))) {
                uint64_t cost;
                (((x264_union32_t *) (cache_mv))->i) = pack16to32_mask (pmx, pmy);
                if ((h->sps->i_chroma_format_idc == CHROMA_444)) {
                    h->mc.mc_luma (pixu, 32, &m->p_fref[4], m->i_stride[1], pmx, pmy, bw, bh, &m->weight[1]);
                    h->mc.mc_luma (pixv, 32, &m->p_fref[8], m->i_stride[2], pmx, pmy, bw, bh, &m->weight[2]);
                }
                else if (m->i_pixel <= PIXEL_8x8) {
                    h->mc.mc_chroma (pixu, pixv, 32, m->p_fref[4], m->i_stride[1], pmx, 2 * (pmy + mvy_offset) >> chroma_v_shift, bw >> 1, bh >> chroma_v_shift);
                    if (m->weight[1].weightfn)
                        m->weight[1].weightfn[bw >> 3] (pixu, 32, pixu, 32, &m->weight[1], bh >> chroma_v_shift);
                    if (m->weight[2].weightfn)
                        m->weight[2].weightfn[bw >> 3] (pixv, 32, pixv, 32, &m->weight[2], bh >> chroma_v_shift);
                }
                cost = x264_rd_cost_part (h, i_lambda2, i4, m->i_pixel);
                if ((cost) < (bcost)) {
                    (bcost) = (cost);
                    (bmx) = (pmx);
                    (bmy) = (pmy);
                    (dir) = (0 ? 0 : dir);
                };
            }
        };
        if (bmx == pmx && bmy == pmy) {
            pmx = m->mv[0];
            pmy = m->mv[1];
        }
    }
    if (bmy < h->mb.mv_min_spel[1] + 3 || bmy > h->mb.mv_max_spel[1] - 3 || bmx < h->mb.mv_min_spel[0] + 3 || bmx > h->mb.mv_max_spel[0] - 3) {
        h->mb.b_skip_mc = 0;
        return;
    }
    dir = -2;
    omx = bmx;
    omy = bmy;
    for (int j = 0; j < 6; j++) {
        {
            if (!1 || !(omx + hex2[j + 1][0] == pmx && omy + hex2[j + 1][1] == pmy)) {
                h->mc.mc_luma (pix, 32, m->p_fref, m->i_stride[0], omx +hex2[j + 1][0], omy +hex2[j + 1][1], bw, bh, &m->weight[0]);
                satd = h->pixf.mbcmp[i_pixel] (m->p_fenc[0], 16, pix, 32) + p_cost_mvx[omx + hex2[j + 1][0]] + p_cost_mvy[omy + hex2[j + 1][1]];
                if ((satd) < (bsatd))
                    (bsatd) = (satd);
                ;
            }
            else
                satd = (1 << 28);
        };
        {
            if (satd <= (bsatd + (bsatd >> 4))) {
                uint64_t cost;
                (((x264_union32_t *) (cache_mv))->i) = pack16to32_mask (omx +hex2[j + 1][0], omy +hex2[j + 1][1]);
                if ((h->sps->i_chroma_format_idc == CHROMA_444)) {
                    h->mc.mc_luma (pixu, 32, &m->p_fref[4], m->i_stride[1], omx +hex2[j + 1][0], omy +hex2[j + 1][1], bw, bh, &m->weight[1]);
                    h->mc.mc_luma (pixv, 32, &m->p_fref[8], m->i_stride[2], omx +hex2[j + 1][0], omy +hex2[j + 1][1], bw, bh, &m->weight[2]);
                }
                else if (m->i_pixel <= PIXEL_8x8) {
                    h->mc.mc_chroma (pixu, pixv, 32, m->p_fref[4], m->i_stride[1], omx +hex2[j + 1][0], 2 * (omy + hex2[j + 1][1] + mvy_offset) >> chroma_v_shift, bw >> 1, bh >> chroma_v_shift);
                    if (m->weight[1].weightfn)
                        m->weight[1].weightfn[bw >> 3] (pixu, 32, pixu, 32, &m->weight[1], bh >> chroma_v_shift);
                    if (m->weight[2].weightfn)
                        m->weight[2].weightfn[bw >> 3] (pixv, 32, pixv, 32, &m->weight[2], bh >> chroma_v_shift);
                }
                cost = x264_rd_cost_part (h, i_lambda2, i4, m->i_pixel);
                if ((cost) < (bcost)) {
                    (bcost) = (cost);
                    (bmx) = (omx + hex2[j + 1][0]);
                    (bmy) = (omy + hex2[j + 1][1]);
                    (dir) = (1 ? j : dir);
                };
            }
        };
    }
    if (dir != -2) {
        for (int i = 1; i < 10; i++) {
            const int odir = mod6m1[dir + 1];
            if (bmy < h->mb.mv_min_spel[1] + 3 || bmy > h->mb.mv_max_spel[1] - 3)
                break;
            dir = -2;
            omx = bmx;
            omy = bmy;
            for (int j = 0; j < 3; j++) {
                {
                    if (!1 || !(omx + hex2[odir + j][0] == pmx && omy + hex2[odir + j][1] == pmy)) {
                        h->mc.mc_luma (pix, 32, m->p_fref, m->i_stride[0], omx +hex2[odir + j][0], omy +hex2[odir + j][1], bw, bh, &m->weight[0]);
                        satd = h->pixf.mbcmp[i_pixel] (m->p_fenc[0], 16, pix, 32) + p_cost_mvx[omx + hex2[odir + j][0]] + p_cost_mvy[omy + hex2[odir + j][1]];
                        if ((satd) < (bsatd))
                            (bsatd) = (satd);
                        ;
                    }
                    else
                        satd = (1 << 28);
                };
                {
                    if (satd <= (bsatd + (bsatd >> 4))) {
                        uint64_t cost;
                        (((x264_union32_t *) (cache_mv))->i) = pack16to32_mask (omx +hex2[odir + j][0], omy +hex2[odir + j][1]);
                        if ((h->sps->i_chroma_format_idc == CHROMA_444)) {
                            h->mc.mc_luma (pixu, 32, &m->p_fref[4], m->i_stride[1], omx +hex2[odir + j][0], omy +hex2[odir + j][1], bw, bh, &m->weight[1]);
                            h->mc.mc_luma (pixv, 32, &m->p_fref[8], m->i_stride[2], omx +hex2[odir + j][0], omy +hex2[odir + j][1], bw, bh, &m->weight[2]);
                        }
                        else if (m->i_pixel <= PIXEL_8x8) {
                            h->mc.mc_chroma (pixu, pixv, 32, m->p_fref[4], m->i_stride[1], omx +hex2[odir + j][0], 2 * (omy + hex2[odir + j][1] + mvy_offset) >> chroma_v_shift, bw >> 1, bh >> chroma_v_shift);
                            if (m->weight[1].weightfn)
                                m->weight[1].weightfn[bw >> 3] (pixu, 32, pixu, 32, &m->weight[1], bh >> chroma_v_shift);
                            if (m->weight[2].weightfn)
                                m->weight[2].weightfn[bw >> 3] (pixv, 32, pixv, 32, &m->weight[2], bh >> chroma_v_shift);
                        }
                        cost = x264_rd_cost_part (h, i_lambda2, i4, m->i_pixel);
                        if ((cost) < (bcost)) {
                            (bcost) = (cost);
                            (bmx) = (omx + hex2[odir + j][0]);
                            (bmy) = (omy + hex2[odir + j][1]);
                            (dir) = (1 ? odir - 1 + j : dir);
                        };
                    }
                };
            }
            if (dir == -2)
                break;
        }
    }
    omx = bmx;
    omy = bmy;
    for (int i = 0; i < 8; i++) {
        {
            if (!1 || !(omx + square1[i + 1][0] == pmx && omy + square1[i + 1][1] == pmy)) {
                h->mc.mc_luma (pix, 32, m->p_fref, m->i_stride[0], omx +square1[i + 1][0], omy +square1[i + 1][1], bw, bh, &m->weight[0]);
                satd = h->pixf.mbcmp[i_pixel] (m->p_fenc[0], 16, pix, 32) + p_cost_mvx[omx + square1[i + 1][0]] + p_cost_mvy[omy + square1[i + 1][1]];
                if ((satd) < (bsatd))
                    (bsatd) = (satd);
                ;
            }
            else
                satd = (1 << 28);
        };
        {
            if (satd <= (bsatd + (bsatd >> 4))) {
                uint64_t cost;
                (((x264_union32_t *) (cache_mv))->i) = pack16to32_mask (omx +square1[i + 1][0], omy +square1[i + 1][1]);
                if ((h->sps->i_chroma_format_idc == CHROMA_444)) {
                    h->mc.mc_luma (pixu, 32, &m->p_fref[4], m->i_stride[1], omx +square1[i + 1][0], omy +square1[i + 1][1], bw, bh, &m->weight[1]);
                    h->mc.mc_luma (pixv, 32, &m->p_fref[8], m->i_stride[2], omx +square1[i + 1][0], omy +square1[i + 1][1], bw, bh, &m->weight[2]);
                }
                else if (m->i_pixel <= PIXEL_8x8) {
                    h->mc.mc_chroma (pixu, pixv, 32, m->p_fref[4], m->i_stride[1], omx +square1[i + 1][0], 2 * (omy + square1[i + 1][1] + mvy_offset) >> chroma_v_shift, bw >> 1, bh >> chroma_v_shift);
                    if (m->weight[1].weightfn)
                        m->weight[1].weightfn[bw >> 3] (pixu, 32, pixu, 32, &m->weight[1], bh >> chroma_v_shift);
                    if (m->weight[2].weightfn)
                        m->weight[2].weightfn[bw >> 3] (pixv, 32, pixv, 32, &m->weight[2], bh >> chroma_v_shift);
                }
                cost = x264_rd_cost_part (h, i_lambda2, i4, m->i_pixel);
                if ((cost) < (bcost)) {
                    (bcost) = (cost);
                    (bmx) = (omx + square1[i + 1][0]);
                    (bmy) = (omy + square1[i + 1][1]);
                    (dir) = (0 ? 0 : dir);
                };
            }
        };
    }
    m->cost = bcost;
    m->mv[0] = bmx;
    m->mv[1] = bmy;
    x264_macroblock_cache_mv (h, block_idx_x [i4], block_idx_y [i4], bw >> 2, bh >> 2, i_list, pack16to32_mask (bmx, bmy));
    amvd = pack8to16 (((abs (bmx -m->mvp[0])) < (66) ? (abs (bmx -m->mvp[0])) : (66)), ((abs (bmy -m->mvp[1])) < (66) ? (abs (bmy -m->mvp[1])) : (66)));
    x264_macroblock_cache_mvd (h, block_idx_x [i4], block_idx_y [i4], bw >> 2, bh >> 2, i_list, amvd);
    h->mb.b_skip_mc = 0;
}

