
#include "common.h"

#include "oclobj.h"

#include <dlfcn.h> //dlopen, dlsym, dlclose

#define ocl_open dlopen( "libOpenCL.so", RTLD_NOW )

#define ocl_close dlclose

#define ocl_address dlsym

x264_opencl_function_t *x264_opencl_load_library (void) {
    x264_opencl_function_t *ocl;
    do {
        do {
            ocl = x264_malloc (sizeof (x264_opencl_function_t));
            if (!ocl)
                goto fail0;
        }
        while (0);
        memset (ocl, 0, sizeof (x264_opencl_function_t));
    }
    while (0);
    ocl->library = dlopen ("libOpenCL.so", 0x00002);
    if (!ocl->library)
        goto fail1;
    {
        ocl->clBuildProgram = (void *) dlsym (ocl->library, "clBuildProgram");
        if (!0 && !ocl->clBuildProgram)
            goto fail2;
    };
    {
        ocl->clCreateBuffer = (void *) dlsym (ocl->library, "clCreateBuffer");
        if (!0 && !ocl->clCreateBuffer)
            goto fail2;
    };
    {
        ocl->clCreateCommandQueue = (void *) dlsym (ocl->library, "clCreateCommandQueue");
        if (!0 && !ocl->clCreateCommandQueue)
            goto fail2;
    };
    {
        ocl->clCreateContext = (void *) dlsym (ocl->library, "clCreateContext");
        if (!0 && !ocl->clCreateContext)
            goto fail2;
    };
    {
        ocl->clCreateImage2D = (void *) dlsym (ocl->library, "clCreateImage2D");
        if (!0 && !ocl->clCreateImage2D)
            goto fail2;
    };
    {
        ocl->clCreateKernel = (void *) dlsym (ocl->library, "clCreateKernel");
        if (!0 && !ocl->clCreateKernel)
            goto fail2;
    };
    {
        ocl->clCreateProgramWithBinary = (void *) dlsym (ocl->library, "clCreateProgramWithBinary");
        if (!0 && !ocl->clCreateProgramWithBinary)
            goto fail2;
    };
    {
        ocl->clCreateProgramWithSource = (void *) dlsym (ocl->library, "clCreateProgramWithSource");
        if (!0 && !ocl->clCreateProgramWithSource)
            goto fail2;
    };
    {
        ocl->clEnqueueCopyBuffer = (void *) dlsym (ocl->library, "clEnqueueCopyBuffer");
        if (!0 && !ocl->clEnqueueCopyBuffer)
            goto fail2;
    };
    {
        ocl->clEnqueueMapBuffer = (void *) dlsym (ocl->library, "clEnqueueMapBuffer");
        if (!0 && !ocl->clEnqueueMapBuffer)
            goto fail2;
    };
    {
        ocl->clEnqueueNDRangeKernel = (void *) dlsym (ocl->library, "clEnqueueNDRangeKernel");
        if (!0 && !ocl->clEnqueueNDRangeKernel)
            goto fail2;
    };
    {
        ocl->clEnqueueReadBuffer = (void *) dlsym (ocl->library, "clEnqueueReadBuffer");
        if (!0 && !ocl->clEnqueueReadBuffer)
            goto fail2;
    };
    {
        ocl->clEnqueueWriteBuffer = (void *) dlsym (ocl->library, "clEnqueueWriteBuffer");
        if (!0 && !ocl->clEnqueueWriteBuffer)
            goto fail2;
    };
    {
        ocl->clFinish = (void *) dlsym (ocl->library, "clFinish");
        if (!0 && !ocl->clFinish)
            goto fail2;
    };
    {
        ocl->clGetCommandQueueInfo = (void *) dlsym (ocl->library, "clGetCommandQueueInfo");
        if (!0 && !ocl->clGetCommandQueueInfo)
            goto fail2;
    };
    {
        ocl->clGetDeviceIDs = (void *) dlsym (ocl->library, "clGetDeviceIDs");
        if (!0 && !ocl->clGetDeviceIDs)
            goto fail2;
    };
    {
        ocl->clGetDeviceInfo = (void *) dlsym (ocl->library, "clGetDeviceInfo");
        if (!0 && !ocl->clGetDeviceInfo)
            goto fail2;
    };
    {
        ocl->clGetKernelWorkGroupInfo = (void *) dlsym (ocl->library, "clGetKernelWorkGroupInfo");
        if (!0 && !ocl->clGetKernelWorkGroupInfo)
            goto fail2;
    };
    {
        ocl->clGetPlatformIDs = (void *) dlsym (ocl->library, "clGetPlatformIDs");
        if (!0 && !ocl->clGetPlatformIDs)
            goto fail2;
    };
    {
        ocl->clGetProgramBuildInfo = (void *) dlsym (ocl->library, "clGetProgramBuildInfo");
        if (!0 && !ocl->clGetProgramBuildInfo)
            goto fail2;
    };
    {
        ocl->clGetProgramInfo = (void *) dlsym (ocl->library, "clGetProgramInfo");
        if (!0 && !ocl->clGetProgramInfo)
            goto fail2;
    };
    {
        ocl->clGetSupportedImageFormats = (void *) dlsym (ocl->library, "clGetSupportedImageFormats");
        if (!0 && !ocl->clGetSupportedImageFormats)
            goto fail2;
    };
    {
        ocl->clReleaseCommandQueue = (void *) dlsym (ocl->library, "clReleaseCommandQueue");
        if (!0 && !ocl->clReleaseCommandQueue)
            goto fail2;
    };
    {
        ocl->clReleaseContext = (void *) dlsym (ocl->library, "clReleaseContext");
        if (!0 && !ocl->clReleaseContext)
            goto fail2;
    };
    {
        ocl->clReleaseKernel = (void *) dlsym (ocl->library, "clReleaseKernel");
        if (!0 && !ocl->clReleaseKernel)
            goto fail2;
    };
    {
        ocl->clReleaseMemObject = (void *) dlsym (ocl->library, "clReleaseMemObject");
        if (!0 && !ocl->clReleaseMemObject)
            goto fail2;
    };
    {
        ocl->clReleaseProgram = (void *) dlsym (ocl->library, "clReleaseProgram");
        if (!0 && !ocl->clReleaseProgram)
            goto fail2;
    };
    {
        ocl->clSetKernelArg = (void *) dlsym (ocl->library, "clSetKernelArg");
        if (!0 && !ocl->clSetKernelArg)
            goto fail2;
    };
    return ocl;
fail2 :
    dlclose (ocl->library);
fail1 :
    x264_free (ocl);
fail0 :
    return ((void *) 0);
}

void x264_opencl_close_library (x264_opencl_function_t *ocl) {
    if (!ocl)
        return;
    dlclose (ocl -> library);
    x264_free (ocl);
}

cl_program x264_opencl_cache_load1 (x264_t *h, const char *dev_name, const char *dev_vendor, const char *driver_version) {
    FILE *fp = fopen (h->param.psz_clbin_file, "rb");
    if (!fp)
        return ((void *) 0);
    x264_opencl_function_t *ocl = h->opencl.ocl;
    cl_program program = ((void *) 0);
    uint8_t *binary = ((void *) 0);
    fseeko (fp, 0, 2);
    size_t size = ftello (fp);
    rewind (fp);
    do {
        binary = x264_malloc (size);
        if (!binary)
            goto fail;
    }
    while (0);
    if (fread (binary, 1, size, fp) != size)
        goto fail;
    const uint8_t *ptr = (const uint8_t *) binary;
    do {
        size_t len = strlen (dev_name);
        if (size <= len || strncmp ((char *) ptr, dev_name, len))
            goto fail;
        else {
            size -= (len + 1);
            ptr += (len + 1);
        }
    }
    while (0);
    do {
        size_t len = strlen (dev_vendor);
        if (size <= len || strncmp ((char *) ptr, dev_vendor, len))
            goto fail;
        else {
            size -= (len + 1);
            ptr += (len + 1);
        }
    }
    while (0);
    do {
        size_t len = strlen (driver_version);
        if (size <= len || strncmp ((char *) ptr, driver_version, len))
            goto fail;
        else {
            size -= (len + 1);
            ptr += (len + 1);
        }
    }
    while (0);
    do {
        size_t len = strlen (x264_opencl_source_hash);
        if (size <= len || strncmp ((char *) ptr, x264_opencl_source_hash, len))
            goto fail;
        else {
            size -= (len + 1);
            ptr += (len + 1);
        }
    }
    while (0);
    cl_int status;
    program = ocl->clCreateProgramWithBinary (h->opencl.context, 1, &h->opencl.device, &size, &ptr, ((void *) 0), &status);
    if (status != 0)
        program = ((void *) 0);
fail :
    fclose (fp);
    x264_free (binary);
    return program;
}

void x264_opencl_cache_save1 (x264_t *h, cl_program program, const char *dev_name, const char *dev_vendor, const char *driver_version) {
    FILE *fp = fopen (h->param.psz_clbin_file, "wb");
    if (!fp) {
        x264_log (h, 2, "OpenCL: unable to open clbin file for write\n");
        return;
    }
    x264_opencl_function_t *ocl = h->opencl.ocl;
    uint8_t *binary = ((void *) 0);
    size_t size = 0;
    cl_int status = ocl->clGetProgramInfo (program, 0x1165, sizeof (size_t), &size, ((void *) 0));
    if (status != 0 || !size) {
        x264_log (h, 2, "OpenCL: Unable to query program binary size, no cache file generated\n");
        goto fail;
    }
    do {
        binary = x264_malloc (size);
        if (!binary)
            goto fail;
    }
    while (0);
    status = ocl->clGetProgramInfo (program, 0x1166, sizeof (uint8_t *), &binary, ((void *) 0));
    if (status != 0) {
        x264_log (h, 2, "OpenCL: Unable to query program binary, no cache file generated\n");
        goto fail;
    }
    fputs (dev_name, fp);
    fputc ('\n', fp);
    fputs (dev_vendor, fp);
    fputc ('\n', fp);
    fputs (driver_version, fp);
    fputc ('\n', fp);
    fputs (x264_opencl_source_hash, fp);
    fputc ('\n', fp);
    fwrite (binary, 1, size, fp);
fail :
    fclose (fp);
    x264_free (binary);
    return;
}

cl_program x264_opencl_compile1 (x264_t *h) {
    x264_opencl_function_t *ocl = h->opencl.ocl;
    cl_program program = ((void *) 0);
    char *build_log = ((void *) 0);
    char dev_name [64];
    char dev_vendor [64];
    char driver_version [64];
    cl_int status;
    status = ocl->clGetDeviceInfo (h->opencl.device, 0x102B, sizeof (dev_name), dev_name, ((void *) 0));
    status |= ocl->clGetDeviceInfo (h->opencl.device, 0x102C, sizeof (dev_vendor), dev_vendor, ((void *) 0));
    status |= ocl->clGetDeviceInfo (h->opencl.device, 0x102D, sizeof (driver_version), driver_version, ((void *) 0));
    if (status != 0)
        return ((void *) 0);
    int vectorize = !strcmp (dev_vendor, "Advanced Micro Devices, Inc.");
    h->opencl.b_device_AMD_SI = 0;
    if (vectorize) {
        if (x264_detect_switchable_graphics ()) {
            x264_log (h, 2, "OpenCL acceleration disabled, switchable graphics detected\n");
            return ((void *) 0);
        }
        cl_uint simdwidth = 4;
        status = ocl->clGetDeviceInfo (h->opencl.device, 0x4042, sizeof (cl_uint), &simdwidth, ((void *) 0));
        if (status == 0 && simdwidth == 1) {
            vectorize = 0;
            h->opencl.b_device_AMD_SI = 1;
        }
    }
    x264_log (h, 2, "OpenCL acceleration enabled with %s %s %s\n", dev_vendor, dev_name, h -> opencl.b_device_AMD_SI ? "(SI)" : "");
    program = x264_opencl_cache_load1 (h, dev_name, dev_vendor, driver_version);
    if (!program) {
        x264_log (h, 2, "Compiling OpenCL kernels...\n");
        const char *strptr = (const char *) x264_opencl_source;
        size_t size = sizeof (x264_opencl_source);
        program = ocl->clCreateProgramWithSource (h->opencl.context, 1, &strptr, &size, &status);
        if (status != 0 || !program) {
            x264_log (h, 1, "OpenCL: unable to create program\n");
            return ((void *) 0);
        }
    }
    const char *buildopts = vectorize ? "-DVECTORIZE=1" : "";
    status = ocl->clBuildProgram (program, 1, &h->opencl.device, buildopts, ((void *) 0), ((void *) 0));
    if (status == 0) {
        x264_opencl_cache_save1 (h, program, dev_name, dev_vendor, driver_version);
        return program;
    }
    size_t build_log_len = 0;
    status = ocl->clGetProgramBuildInfo (program, h->opencl.device, 0x1183, 0, ((void *) 0), &build_log_len);
    if (status != 0 || !build_log_len) {
        x264_log (h, 1, "OpenCL: Compilation failed, unable to query build log\n");
        goto fail;
    }
    build_log = x264_malloc (build_log_len);
    if (!build_log) {
        x264_log (h, 1, "OpenCL: Compilation failed, unable to alloc build log\n");
        goto fail;
    }
    status = ocl->clGetProgramBuildInfo (program, h->opencl.device, 0x1183, build_log_len, build_log, ((void *) 0));
    if (status != 0) {
        x264_log (h, 1, "OpenCL: Compilation failed, unable to get build log\n");
        goto fail;
    }
    FILE *log_file = fopen ("x264_kernel_build_log.txt", "w");
    if (!log_file) {
        x264_log (h, 1, "OpenCL: Compilation failed, unable to create file x264_kernel_build_log.txt\n");
        goto fail;
    }
    fwrite (build_log, 1, build_log_len, log_file);
    fclose (log_file);
    x264_log (h, 1, "OpenCL: kernel build errors written to x264_kernel_build_log.txt\n");
fail :
    x264_free (build_log);
    if (program)
        ocl->clReleaseProgram (program);
    return ((void *) 0);
}

int x264_opencl_lookahead_alloc1 (x264_t *h) {
    if (!h->param.rc.i_lookahead)
        return -1;
    static const char *kernelnames [] = {"mb_intra_cost_satd_8x8", "sum_intra_cost", "downscale_hpel", "downscale1", "downscale2", "memset_int16", "weightp_scaled_images", "weightp_hpel", "hierarchical_motion", "subpel_refine", "mode_selection", "sum_inter_cost"};
    cl_kernel *kernels [] = {&h->opencl.intra_kernel, &h->opencl.rowsum_intra_kernel, &h->opencl.downscale_hpel_kernel, &h->opencl.downscale_kernel1, &h->opencl.downscale_kernel2, &h->opencl.memset_kernel, &h->opencl.weightp_scaled_images_kernel, &h->opencl.weightp_hpel_kernel, &h->opencl.hme_kernel, &h->opencl.subpel_refine_kernel, &h->opencl.mode_select_kernel, &h->opencl.rowsum_inter_kernel};
    x264_opencl_function_t *ocl = h->opencl.ocl;
    cl_int status;
    h->opencl.lookahead_program = x264_opencl_compile1 (h);
    if (!h->opencl.lookahead_program)
        goto fail;
    for (int i = 0; i < (sizeof (kernelnames) / sizeof (kernelnames[0])); i++) {
        *kernels[i] = ocl->clCreateKernel (h->opencl.lookahead_program, kernelnames[i], &status);
        if (status != 0) {
            x264_log (h, 1, "OpenCL: Unable to compile kernel '%s' (%d)\n", kernelnames [i], status);
            goto fail;
        }
    }
    h->opencl.page_locked_buffer = ocl->clCreateBuffer (h->opencl.context, (1 << 1) | (1 << 4), 32 * 1024 * 1024, ((void *) 0), &status);
    if (status != 0) {
        x264_log (h, 1, "OpenCL: Unable to allocate page-locked buffer, error '%d'\n", status);
        goto fail;
    }
    h->opencl.page_locked_ptr = ocl->clEnqueueMapBuffer (h->opencl.queue, h->opencl.page_locked_buffer, 1, (1 << 0) | (1 << 1), 0, 32 * 1024 * 1024, 0, ((void *) 0), ((void *) 0), &status);
    if (status != 0) {
        x264_log (h, 1, "OpenCL: Unable to map page-locked buffer, error '%d'\n", status);
        goto fail;
    }
    return 0;
fail :
    x264_opencl_lookahead_delete (h);
    return -1;
}

void x264_opencl_error_notify1 (const char *errinfo, const void *private_info, size_t cb, void *user_data) {
    x264_t *h = (x264_t *) user_data;
    h->param.b_opencl = 0;
    h->opencl.b_fatal_error = 1;
    x264_log (h, 0, "OpenCL: %s\n", errinfo);
    x264_log (h, 0, "OpenCL: fatal error, aborting encode\n");
}

int x264_opencl_lookahead_init (x264_t *h) {
    x264_opencl_function_t *ocl = h->opencl.ocl;
    cl_platform_id *platforms = ((void *) 0);
    cl_device_id *devices = ((void *) 0);
    cl_image_format *imageType = ((void *) 0);
    cl_context context = ((void *) 0);
    int ret = -1;
    cl_uint numPlatforms = 0;
    cl_int status = ocl->clGetPlatformIDs (0, ((void *) 0), &numPlatforms);
    if (status != 0 || !numPlatforms) {
        x264_log (h, 1, "OpenCL: Unable to query installed platforms\n");
        goto fail;
    }
    platforms = (cl_platform_id *) x264_malloc (sizeof (cl_platform_id) * numPlatforms);
    if (!platforms) {
        x264_log (h, 1, "OpenCL: malloc of installed platforms buffer failed\n");
        goto fail;
    }
    status = ocl->clGetPlatformIDs (numPlatforms, platforms, ((void *) 0));
    if (status != 0) {
        x264_log (h, 1, "OpenCL: Unable to query installed platforms\n");
        goto fail;
    }
    for (cl_uint i = 0; i < numPlatforms; i++) {
        cl_uint gpu_count = 0;
        status = ocl->clGetDeviceIDs (platforms[i], (1 << 2), 0, ((void *) 0), &gpu_count);
        if (status != 0 || !gpu_count)
            continue;
        x264_free (devices);
        devices = x264_malloc (sizeof (cl_device_id) * gpu_count);
        if (!devices)
            continue;
        status = ocl->clGetDeviceIDs (platforms[i], (1 << 2), gpu_count, devices, ((void *) 0));
        if (status != 0)
            continue;
        for (cl_uint gpu = 0; gpu < gpu_count; gpu++) {
            h->opencl.device = devices[gpu];
            if (h->param.opencl_device_id && devices[gpu] != (cl_device_id) h->param.opencl_device_id)
                continue;
            cl_bool image_support = 0;
            status = ocl->clGetDeviceInfo (h->opencl.device, 0x1016, sizeof (cl_bool), &image_support, ((void *) 0));
            if (status != 0 || !image_support)
                continue;
            if (context)
                ocl->clReleaseContext (context);
            context = ocl->clCreateContext (((void *) 0), 1, &h->opencl.device, (void *) x264_opencl_error_notify1, (void *) h, &status);
            if (status != 0 || !context)
                continue;
            cl_uint imagecount = 0;
            status = ocl->clGetSupportedImageFormats (context, (1 << 0), 0x10F1, 0, ((void *) 0), &imagecount);
            if (status != 0 || !imagecount)
                continue;
            x264_free (imageType);
            imageType = x264_malloc (sizeof (cl_image_format) * imagecount);
            if (!imageType)
                continue;
            status = ocl->clGetSupportedImageFormats (context, (1 << 0), 0x10F1, imagecount, imageType, ((void *) 0));
            if (status != 0)
                continue;
            int b_has_r = 0;
            int b_has_rgba = 0;
            for (cl_uint j = 0; j < imagecount; j++) {
                if (imageType[j].image_channel_order == 0x10B0 && imageType[j].image_channel_data_type == 0x10DC)
                    b_has_r = 1;
                else if (imageType[j].image_channel_order == 0x10B5 && imageType[j].image_channel_data_type == 0x10DA)
                    b_has_rgba = 1;
            }
            if (!b_has_r || !b_has_rgba) {
                char dev_name [64];
                status = ocl->clGetDeviceInfo (h->opencl.device, 0x102B, sizeof (dev_name), dev_name, ((void *) 0));
                if (status == 0) {
                    int level = h->param.opencl_device_id ? 1 : 3;
                    x264_log (h, level, "OpenCL: %s does not support required image formats\n", dev_name);
                }
                continue;
            }
            if (h->param.i_opencl_device) {
                h->param.i_opencl_device--;
                continue;
            }
            h->opencl.queue = ocl->clCreateCommandQueue (context, h->opencl.device, 0, &status);
            if (status != 0 || !h->opencl.queue)
                continue;
            h->opencl.context = context;
            context = ((void *) 0);
            ret = 0;
            break;
        }
        if (!ret)
            break;
    }
    if (!h->param.psz_clbin_file)
        h->param.psz_clbin_file = "x264_lookahead.clbin";
    if (ret)
        x264_log (h, 1, "OpenCL: Unable to find a compatible device\n");
    else
        ret = x264_opencl_lookahead_alloc1 (h);
fail :
    if (context)
        ocl->clReleaseContext (context);
    x264_free (imageType);
    x264_free (devices);
    x264_free (platforms);
    return ret;
}

void x264_opencl_lookahead_free1 (x264_t *h) {
    x264_opencl_function_t *ocl = h->opencl.ocl;
    do {
        if (h->opencl.downscale_hpel_kernel) {
            ocl->clReleaseKernel (h->opencl.downscale_hpel_kernel);
            h->opencl.downscale_hpel_kernel = ((void *) 0);
        }
    }
    while (0);
    do {
        if (h->opencl.downscale_kernel1) {
            ocl->clReleaseKernel (h->opencl.downscale_kernel1);
            h->opencl.downscale_kernel1 = ((void *) 0);
        }
    }
    while (0);
    do {
        if (h->opencl.downscale_kernel2) {
            ocl->clReleaseKernel (h->opencl.downscale_kernel2);
            h->opencl.downscale_kernel2 = ((void *) 0);
        }
    }
    while (0);
    do {
        if (h->opencl.weightp_hpel_kernel) {
            ocl->clReleaseKernel (h->opencl.weightp_hpel_kernel);
            h->opencl.weightp_hpel_kernel = ((void *) 0);
        }
    }
    while (0);
    do {
        if (h->opencl.weightp_scaled_images_kernel) {
            ocl->clReleaseKernel (h->opencl.weightp_scaled_images_kernel);
            h->opencl.weightp_scaled_images_kernel = ((void *) 0);
        }
    }
    while (0);
    do {
        if (h->opencl.memset_kernel) {
            ocl->clReleaseKernel (h->opencl.memset_kernel);
            h->opencl.memset_kernel = ((void *) 0);
        }
    }
    while (0);
    do {
        if (h->opencl.intra_kernel) {
            ocl->clReleaseKernel (h->opencl.intra_kernel);
            h->opencl.intra_kernel = ((void *) 0);
        }
    }
    while (0);
    do {
        if (h->opencl.rowsum_intra_kernel) {
            ocl->clReleaseKernel (h->opencl.rowsum_intra_kernel);
            h->opencl.rowsum_intra_kernel = ((void *) 0);
        }
    }
    while (0);
    do {
        if (h->opencl.hme_kernel) {
            ocl->clReleaseKernel (h->opencl.hme_kernel);
            h->opencl.hme_kernel = ((void *) 0);
        }
    }
    while (0);
    do {
        if (h->opencl.subpel_refine_kernel) {
            ocl->clReleaseKernel (h->opencl.subpel_refine_kernel);
            h->opencl.subpel_refine_kernel = ((void *) 0);
        }
    }
    while (0);
    do {
        if (h->opencl.mode_select_kernel) {
            ocl->clReleaseKernel (h->opencl.mode_select_kernel);
            h->opencl.mode_select_kernel = ((void *) 0);
        }
    }
    while (0);
    do {
        if (h->opencl.rowsum_inter_kernel) {
            ocl->clReleaseKernel (h->opencl.rowsum_inter_kernel);
            h->opencl.rowsum_inter_kernel = ((void *) 0);
        }
    }
    while (0);
    do {
        if (h->opencl.lookahead_program) {
            ocl->clReleaseProgram (h->opencl.lookahead_program);
            h->opencl.lookahead_program = ((void *) 0);
        }
    }
    while (0);
    do {
        if (h->opencl.page_locked_buffer) {
            ocl->clReleaseMemObject (h->opencl.page_locked_buffer);
            h->opencl.page_locked_buffer = ((void *) 0);
        }
    }
    while (0);
    do {
        if (h->opencl.luma_16x16_image[0]) {
            ocl->clReleaseMemObject (h->opencl.luma_16x16_image[0]);
            h->opencl.luma_16x16_image[0] = ((void *) 0);
        }
    }
    while (0);
    do {
        if (h->opencl.luma_16x16_image[1]) {
            ocl->clReleaseMemObject (h->opencl.luma_16x16_image[1]);
            h->opencl.luma_16x16_image[1] = ((void *) 0);
        }
    }
    while (0);
    for (int i = 0; i < 4; i++)
        do {
            if (h->opencl.weighted_scaled_images[i]) {
                ocl->clReleaseMemObject (h->opencl.weighted_scaled_images[i]);
                h->opencl.weighted_scaled_images[i] = ((void *) 0);
            }
        }
        while (0);
    do {
        if (h->opencl.weighted_luma_hpel) {
            ocl->clReleaseMemObject (h->opencl.weighted_luma_hpel);
            h->opencl.weighted_luma_hpel = ((void *) 0);
        }
    }
    while (0);
    do {
        if (h->opencl.row_satds[0]) {
            ocl->clReleaseMemObject (h->opencl.row_satds[0]);
            h->opencl.row_satds[0] = ((void *) 0);
        }
    }
    while (0);
    do {
        if (h->opencl.row_satds[1]) {
            ocl->clReleaseMemObject (h->opencl.row_satds[1]);
            h->opencl.row_satds[1] = ((void *) 0);
        }
    }
    while (0);
    do {
        if (h->opencl.mv_buffers[0]) {
            ocl->clReleaseMemObject (h->opencl.mv_buffers[0]);
            h->opencl.mv_buffers[0] = ((void *) 0);
        }
    }
    while (0);
    do {
        if (h->opencl.mv_buffers[1]) {
            ocl->clReleaseMemObject (h->opencl.mv_buffers[1]);
            h->opencl.mv_buffers[1] = ((void *) 0);
        }
    }
    while (0);
    do {
        if (h->opencl.lowres_mv_costs) {
            ocl->clReleaseMemObject (h->opencl.lowres_mv_costs);
            h->opencl.lowres_mv_costs = ((void *) 0);
        }
    }
    while (0);
    do {
        if (h->opencl.mvp_buffer) {
            ocl->clReleaseMemObject (h->opencl.mvp_buffer);
            h->opencl.mvp_buffer = ((void *) 0);
        }
    }
    while (0);
    do {
        if (h->opencl.lowres_costs[0]) {
            ocl->clReleaseMemObject (h->opencl.lowres_costs[0]);
            h->opencl.lowres_costs[0] = ((void *) 0);
        }
    }
    while (0);
    do {
        if (h->opencl.lowres_costs[1]) {
            ocl->clReleaseMemObject (h->opencl.lowres_costs[1]);
            h->opencl.lowres_costs[1] = ((void *) 0);
        }
    }
    while (0);
    do {
        if (h->opencl.frame_stats[0]) {
            ocl->clReleaseMemObject (h->opencl.frame_stats[0]);
            h->opencl.frame_stats[0] = ((void *) 0);
        }
    }
    while (0);
    do {
        if (h->opencl.frame_stats[1]) {
            ocl->clReleaseMemObject (h->opencl.frame_stats[1]);
            h->opencl.frame_stats[1] = ((void *) 0);
        }
    }
    while (0);
}

void x264_opencl_lookahead_delete (x264_t *h) {
    x264_opencl_function_t *ocl = h->opencl.ocl;
    if (!ocl)
        return;
    if (h->opencl.queue)
        ocl->clFinish (h->opencl.queue);
    x264_opencl_lookahead_free1 (h);
    if (h->opencl.queue) {
        ocl->clReleaseCommandQueue (h->opencl.queue);
        h->opencl.queue = ((void *) 0);
    }
    if (h->opencl.context) {
        ocl->clReleaseContext (h->opencl.context);
        h->opencl.context = ((void *) 0);
    }
}

void x264_opencl_frame_delete (x264_frame_t *frame) {
    x264_opencl_function_t *ocl = frame->opencl.ocl;
    if (!ocl)
        return;
    for (int j = 0; j < 4; j++)
        do {
            if (frame->opencl.scaled_image2Ds[j]) {
                ocl->clReleaseMemObject (frame->opencl.scaled_image2Ds[j]);
                frame->opencl.scaled_image2Ds[j] = ((void *) 0);
            }
        }
        while (0);
    do {
        if (frame->opencl.luma_hpel) {
            ocl->clReleaseMemObject (frame->opencl.luma_hpel);
            frame->opencl.luma_hpel = ((void *) 0);
        }
    }
    while (0);
    do {
        if (frame->opencl.inv_qscale_factor) {
            ocl->clReleaseMemObject (frame->opencl.inv_qscale_factor);
            frame->opencl.inv_qscale_factor = ((void *) 0);
        }
    }
    while (0);
    do {
        if (frame->opencl.intra_cost) {
            ocl->clReleaseMemObject (frame->opencl.intra_cost);
            frame->opencl.intra_cost = ((void *) 0);
        }
    }
    while (0);
    do {
        if (frame->opencl.lowres_mvs0) {
            ocl->clReleaseMemObject (frame->opencl.lowres_mvs0);
            frame->opencl.lowres_mvs0 = ((void *) 0);
        }
    }
    while (0);
    do {
        if (frame->opencl.lowres_mvs1) {
            ocl->clReleaseMemObject (frame->opencl.lowres_mvs1);
            frame->opencl.lowres_mvs1 = ((void *) 0);
        }
    }
    while (0);
    do {
        if (frame->opencl.lowres_mv_costs0) {
            ocl->clReleaseMemObject (frame->opencl.lowres_mv_costs0);
            frame->opencl.lowres_mv_costs0 = ((void *) 0);
        }
    }
    while (0);
    do {
        if (frame->opencl.lowres_mv_costs1) {
            ocl->clReleaseMemObject (frame->opencl.lowres_mv_costs1);
            frame->opencl.lowres_mv_costs1 = ((void *) 0);
        }
    }
    while (0);
}

typedef void * (*ADL_MAIN_MALLOC_CALLBACK) (int);
typedef int (*ADL_MAIN_CONTROL_CREATE) (ADL_MAIN_MALLOC_CALLBACK, int);
typedef int (*ADL_ADAPTER_NUMBEROFADAPTERS_GET) (int *);
typedef int (*ADL_POWERXPRESS_SCHEME_GET) (int, int *, int *, int *);
typedef int (*ADL_MAIN_CONTROL_DESTROY) (void);

void *adl_malloc_wrapper1 (int iSize) {
    return x264_malloc (iSize);
}

int x264_detect_switchable_graphics (void) {
    void *hDLL;
    ADL_MAIN_CONTROL_CREATE ADL_Main_Control_Create;
    ADL_ADAPTER_NUMBEROFADAPTERS_GET ADL_Adapter_NumberOfAdapters_Get;
    ADL_POWERXPRESS_SCHEME_GET ADL_PowerXpress_Scheme_Get;
    ADL_MAIN_CONTROL_DESTROY ADL_Main_Control_Destroy;
    int ret = 0;
    hDLL = dlopen ("libatiadlxx.so", 0x00001 | 0x00100);
    if (!hDLL)
        goto fail0;
    ADL_Main_Control_Create = (ADL_MAIN_CONTROL_CREATE) dlsym (hDLL, "ADL_Main_Control_Create");
    ADL_Main_Control_Destroy = (ADL_MAIN_CONTROL_DESTROY) dlsym (hDLL, "ADL_Main_Control_Destroy");
    ADL_Adapter_NumberOfAdapters_Get = (ADL_ADAPTER_NUMBEROFADAPTERS_GET) dlsym (hDLL, "ADL_Adapter_NumberOfAdapters_Get");
    ADL_PowerXpress_Scheme_Get = (ADL_POWERXPRESS_SCHEME_GET) dlsym (hDLL, "ADL_PowerXpress_Scheme_Get");
    if (!ADL_Main_Control_Create || !ADL_Main_Control_Destroy || !ADL_Adapter_NumberOfAdapters_Get || !ADL_PowerXpress_Scheme_Get)
        goto fail1;
    if (0 != ADL_Main_Control_Create (adl_malloc_wrapper1, 1))
        goto fail1;
    int numAdapters = 0;
    if (0 != ADL_Adapter_NumberOfAdapters_Get (&numAdapters))
        goto fail2;
    for (int i = 0; i < numAdapters; i++) {
        int PXSchemeRange, PXSchemeCurrentState, PXSchemeDefaultState;
        if (0 != ADL_PowerXpress_Scheme_Get (i, &PXSchemeRange, &PXSchemeCurrentState, &PXSchemeDefaultState))
            break;
        if (PXSchemeRange >= 2) {
            ret = 1;
            break;
        }
    }
fail2 :
    ADL_Main_Control_Destroy ();
fail1 :
    dlclose (hDLL);
fail0 :
    return ret;
}

