
#include "common.h"

#include <sys/time.h>

#include <time.h>

int64_t x264_mdate (void) {
    struct timeval tv_date;
    gettimeofday (& tv_date, NULL);
    return (int64_t) tv_date.tv_sec * 1000000 + (int64_t) tv_date.tv_usec;
}

uint32_t endian_fix32 (uint32_t x) {
    return (x << 24) + ((x << 8) & 0xff0000) + ((x >> 8) & 0xff00) + (x >> 24);
}

uint64_t endian_fix64 (uint64_t x) {
    return endian_fix32 (x >> 32) + ((uint64_t) endian_fix32 (x) << 32);
}

intptr_t endian_fix (intptr_t x) {
    return WORD_SIZE == 8 ? endian_fix64 (x) : endian_fix32 (x);
}

uint16_t endian_fix16 (uint16_t x) {
    return (x << 8) | (x >> 8);
}

int x264_ctz_4bit (uint32_t x) {
    static uint8_t lut [16] = {4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0};
    return lut[x];
}

int x264_is_regular_file (FILE *filehandle) {
    x264_struct_stat file_stat;
    if (x264_fstat (fileno (filehandle), &file_stat))
        return 1;
    return S_ISREG (file_stat.st_mode);
}

int x264_is_regular_file_path (const char *filename) {
    x264_struct_stat file_stat;
    if (x264_stat (filename, &file_stat))
        return !x264_is_pipe (filename);
    return S_ISREG (file_stat.st_mode);
}

int x264_pthread_fetch_and_add (int *val, int add, x264_pthread_mutex_t *mutex) {
    int res = *val;
    *val += add;
    return res;
}

