
#include "output.h"

int open_file_RAW_OUT (char *psz_filename, hnd_t *p_handle, cli_output_opt_t *opt) {
    if (!strcmp (psz_filename, "-"))
        *p_handle = stdout;
    else if (!(*p_handle = x264_fopen (psz_filename, "w+b")))
        return -1;
    return 0;
}

int set_param (hnd_t handle, x264_param_t *p_param) {
    return 0;
}

int write_headers (hnd_t handle, x264_nal_t *p_nal) {
    int size = p_nal[0].i_payload + p_nal[1].i_payload + p_nal[2].i_payload;
    if (fwrite (p_nal[0].p_payload, size, 1, (FILE *) handle))
        return size;
    return -1;
}

int write_frame (hnd_t handle, uint8_t *p_nalu, int i_size, x264_picture_t *p_picture) {
    if (fwrite (p_nalu, i_size, 1, (FILE *) handle))
        return i_size;
    return -1;
}

int close_file_RAW_OUT (hnd_t handle, int64_t largest_pts, int64_t second_largest_pts) {
    if (!handle || handle == stdout)
        return 0;
    return fclose ((FILE *) handle);
}

const cli_output_t raw_output = {open_file_RAW_OUT, set_param, write_headers, write_frame, close_file_RAW_OUT};
