
#include "video.h"
struct _source_hnd_t {
    cli_pic_t pic;
    hnd_t hin;
    int cur_frame;
};
typedef struct _source_hnd_t source_hnd_t;
cli_vid_filter_t source_filter;

int init_SOURCE (hnd_t *handle, cli_vid_filter_t *filter, video_info_t *info, x264_param_t *param, char *opt_string) {
    source_hnd_t *h = calloc (1, sizeof (source_hnd_t));
    if (!h)
        return -1;
    h->cur_frame = -1;
    if (cli_input.picture_alloc (&h->pic, info->csp, info->width, info->height))
        return -1;
    h->hin = *handle;
    *handle = h;
    *filter = source_filter;
    return 0;
}

int get_frame_SOURCE (hnd_t handle, cli_pic_t *output, int frame) {
    source_hnd_t *h = handle;
    if (frame <= h->cur_frame || cli_input.read_frame (&h->pic, h->hin, frame))
        return -1;
    h->cur_frame = frame;
    *output = h->pic;
    return 0;
}

int release_frame_SOURCE (hnd_t handle, cli_pic_t *pic, int frame) {
    source_hnd_t *h = handle;
    if (cli_input.release_frame && cli_input.release_frame (&h->pic, h->hin))
        return -1;
    return 0;
}

void free_filter_SOURCE (hnd_t handle) {
    source_hnd_t *h = handle;
    cli_input.picture_clean (&h->pic);
    cli_input.close_file (h->hin);
    free (h);
}

cli_vid_filter_t source_filter = {"source", NULL, init_SOURCE, get_frame_SOURCE, release_frame_SOURCE, free_filter_SOURCE, NULL};
