
#include "video.h"
cli_vid_filter_t *first_filter = NULL;

void register_vid_filter (cli_vid_filter_t *new_filter) {
    cli_vid_filter_t *filter_i = first_filter;
    while (filter_i->next)
        filter_i = filter_i->next;
    filter_i->next = new_filter;
    new_filter->next = NULL;
}

void x264_register_vid_filters (void) {
    extern cli_vid_filter_t source_filter;
    first_filter = &source_filter;
    {
        extern cli_vid_filter_t fix_vfr_pts_filter;
        register_vid_filter (& fix_vfr_pts_filter);
    };
    {
        extern cli_vid_filter_t resize_filter;
        register_vid_filter (& resize_filter);
    };
    {
        extern cli_vid_filter_t depth_filter;
        register_vid_filter (& depth_filter);
    };
}

int x264_init_vid_filter (const char *name, hnd_t *handle, cli_vid_filter_t *filter, video_info_t *info, x264_param_t *param, char *opt_string) {
    cli_vid_filter_t *filter_i = first_filter;
    while (filter_i && strcasecmp (name, filter_i->name))
        filter_i = filter_i->next;
    FAIL_IF_ERR (! filter_i, "x264", "invalid filter `%s'\n", name);
    if (filter_i->init (handle, filter, info, param, opt_string))
        return -1;
    return 0;
}

void x264_vid_filter_help (int longhelp) {
    for (cli_vid_filter_t *filter_i = first_filter; filter_i; filter_i = filter_i->next)
        if (filter_i->help)
            filter_i->help (longhelp);
}

